// Only one namespace
const N = {};
N.ElectronFramework = {};
N.Functions = {};

N.boolDevMode = false;

N.ElectronFramework.Electron = require('electron');

// Uses to access main process things. More info here :
// http://electron.atom.io/docs/v0.37.2/api/remote/
N.ElectronFramework.Remote = N.ElectronFramework.Electron.remote;

// Get access to the BrowserWindow object which this web page belongs to.
N.ElectronFramework.CurrentWindow = N.ElectronFramework.Remote.getCurrentWindow();

// Hide application menu bar
N.ElectronFramework.CurrentWindow.setMenuBarVisibility(false);

if (N.boolDevMode) {
  N.ElectronFramework.CurrentWindow.webContents.openDevTools();
}

// Module to control application life.
N.ElectronFramework.App = N.ElectronFramework.Remote.app;
// Used to handle native dialog windows
N.ElectronFramework.Dialog = N.ElectronFramework.Remote.dialog;

// Used to trigger native commands
N.ElectronFramework.Shell = N.ElectronFramework.Electron.shell;
// Used to handle clipboard data
N.ElectronFramework.Clipboard = N.ElectronFramework.Electron.clipboard;

// "fs" for "File System" : used to read and write files on disks.
N.ElectronFramework.Fs = require('fs');

// manipulate path string
N.ElectronFramework.Path = require('path');

/**
 * material-design-lite - Material Design Components in CSS, JS and HTML
 * @version v1.2.1
 * @license Apache-2.0
 * @copyright 2015 Google, Inc.
 * @link https://github.com/google/material-design-lite
 */
!function(){"use strict";function e(e,t){if(e){if(t.element_.classList.contains(t.CssClasses_.MDL_JS_RIPPLE_EFFECT)){var s=document.createElement("span");s.classList.add(t.CssClasses_.MDL_RIPPLE_CONTAINER),s.classList.add(t.CssClasses_.MDL_JS_RIPPLE_EFFECT);var i=document.createElement("span");i.classList.add(t.CssClasses_.MDL_RIPPLE),s.appendChild(i),e.appendChild(s)}e.addEventListener("click",function(s){s.preventDefault();var i=e.href.split("#")[1],n=t.element_.querySelector("#"+i);t.resetTabState_(),t.resetPanelState_(),e.classList.add(t.CssClasses_.ACTIVE_CLASS),n.classList.add(t.CssClasses_.ACTIVE_CLASS)})}}function t(e,t,s,i){function n(){var n=e.href.split("#")[1],a=i.content_.querySelector("#"+n);i.resetTabState_(t),i.resetPanelState_(s),e.classList.add(i.CssClasses_.IS_ACTIVE),a.classList.add(i.CssClasses_.IS_ACTIVE)}if(i.tabBar_.classList.contains(i.CssClasses_.JS_RIPPLE_EFFECT)){var a=document.createElement("span");a.classList.add(i.CssClasses_.RIPPLE_CONTAINER),a.classList.add(i.CssClasses_.JS_RIPPLE_EFFECT);var l=document.createElement("span");l.classList.add(i.CssClasses_.RIPPLE),a.appendChild(l),e.appendChild(a)}e.addEventListener("click",function(t){"#"===e.getAttribute("href").charAt(0)&&(t.preventDefault(),n())}),e.show=n}var s={upgradeDom:function(e,t){},upgradeElement:function(e,t){},upgradeElements:function(e){},upgradeAllRegistered:function(){},registerUpgradedCallback:function(e,t){},register:function(e){},downgradeElements:function(e){}};s=function(){function e(e,t){for(var s=0;s<h.length;s++)if(h[s].className===e)return"undefined"!=typeof t&&(h[s]=t),h[s];return!1}function t(e){var t=e.getAttribute("data-upgraded");return null===t?[""]:t.split(",")}function s(e,s){var i=t(e);return i.indexOf(s)!==-1}function i(t,s){if("undefined"==typeof t&&"undefined"==typeof s)for(var a=0;a<h.length;a++)i(h[a].className,h[a].cssClass);else{var l=t;if("undefined"==typeof s){var o=e(l);o&&(s=o.cssClass)}for(var r=document.querySelectorAll("."+s),_=0;_<r.length;_++)n(r[_],l)}}function n(i,n){if(!("object"==typeof i&&i instanceof Element))throw new Error("Invalid argument provided to upgrade MDL element.");var a=t(i),l=[];if(n)s(i,n)||l.push(e(n));else{var o=i.classList;h.forEach(function(e){o.contains(e.cssClass)&&l.indexOf(e)===-1&&!s(i,e.className)&&l.push(e)})}for(var r,_=0,d=l.length;_<d;_++){if(r=l[_],!r)throw new Error("Unable to find a registered component for the given class.");a.push(r.className),i.setAttribute("data-upgraded",a.join(","));var C=new r.classConstructor(i);C[p]=r,c.push(C);for(var u=0,E=r.callbacks.length;u<E;u++)r.callbacks[u](i);r.widget&&(i[r.className]=C);var m;"CustomEvent"in window&&"function"==typeof window.CustomEvent?m=new CustomEvent("mdl-componentupgraded",{bubbles:!0,cancelable:!1}):(m=document.createEvent("Events"),m.initEvent("mdl-componentupgraded",!0,!0)),i.dispatchEvent(m)}}function a(e){Array.isArray(e)||(e=e instanceof Element?[e]:Array.prototype.slice.call(e));for(var t,s=0,i=e.length;s<i;s++)t=e[s],t instanceof HTMLElement&&(n(t),t.children.length>0&&a(t.children))}function l(t){var s="undefined"==typeof t.widget&&"undefined"==typeof t.widget,i=!0;s||(i=t.widget||t.widget);var n={classConstructor:t.constructor||t.constructor,className:t.classAsString||t.classAsString,cssClass:t.cssClass||t.cssClass,widget:i,callbacks:[]};if(h.forEach(function(e){if(e.cssClass===n.cssClass)throw new Error("The provided cssClass has already been registered: "+e.cssClass);if(e.className===n.className)throw new Error("The provided className has already been registered")}),t.constructor.prototype.hasOwnProperty(p))throw new Error("MDL component classes must not have "+p+" defined as a property.");var a=e(t.classAsString,n);a||h.push(n)}function o(t,s){var i=e(t);i&&i.callbacks.push(s)}function r(){for(var e=0;e<h.length;e++)i(h[e].className)}function _(e){if(e){var t=c.indexOf(e);c.splice(t,1);var s=e.element_.getAttribute("data-upgraded").split(","),i=s.indexOf(e[p].classAsString);s.splice(i,1),e.element_.setAttribute("data-upgraded",s.join(","));var n;"CustomEvent"in window&&"function"==typeof window.CustomEvent?n=new CustomEvent("mdl-componentdowngraded",{bubbles:!0,cancelable:!1}):(n=document.createEvent("Events"),n.initEvent("mdl-componentdowngraded",!0,!0)),e.element_.dispatchEvent(n)}}function d(e){var t=function(e){c.filter(function(t){return t.element_===e}).forEach(_)};if(e instanceof Array||e instanceof NodeList)for(var s=0;s<e.length;s++)t(e[s]);else{if(!(e instanceof Node))throw new Error("Invalid argument provided to downgrade MDL nodes.");t(e)}}var h=[],c=[],p="mdlComponentConfigInternal_";return{upgradeDom:i,upgradeElement:n,upgradeElements:a,upgradeAllRegistered:r,registerUpgradedCallback:o,register:l,downgradeElements:d}}(),s.ComponentConfigPublic,s.ComponentConfig,s.Component,s.upgradeDom=s.upgradeDom,s.upgradeElement=s.upgradeElement,s.upgradeElements=s.upgradeElements,s.upgradeAllRegistered=s.upgradeAllRegistered,s.registerUpgradedCallback=s.registerUpgradedCallback,s.register=s.register,s.downgradeElements=s.downgradeElements,window.componentHandler=s,window.componentHandler=s,window.addEventListener("load",function(){"classList"in document.createElement("div")&&"querySelector"in document&&"addEventListener"in window&&Array.prototype.forEach?(document.documentElement.classList.add("mdl-js"),s.upgradeAllRegistered()):(s.upgradeElement=function(){},s.register=function(){})}),Date.now||(Date.now=function(){return(new Date).getTime()},Date.now=Date.now);for(var i=["webkit","moz"],n=0;n<i.length&&!window.requestAnimationFrame;++n){var a=i[n];window.requestAnimationFrame=window[a+"RequestAnimationFrame"],window.cancelAnimationFrame=window[a+"CancelAnimationFrame"]||window[a+"CancelRequestAnimationFrame"],window.requestAnimationFrame=window.requestAnimationFrame,window.cancelAnimationFrame=window.cancelAnimationFrame}if(/iP(ad|hone|od).*OS 6/.test(window.navigator.userAgent)||!window.requestAnimationFrame||!window.cancelAnimationFrame){var l=0;window.requestAnimationFrame=function(e){var t=Date.now(),s=Math.max(l+16,t);return setTimeout(function(){e(l=s)},s-t)},window.cancelAnimationFrame=clearTimeout,window.requestAnimationFrame=window.requestAnimationFrame,window.cancelAnimationFrame=window.cancelAnimationFrame}var o=function(e){this.element_=e,this.init()};window.MaterialButton=o,o.prototype.Constant_={},o.prototype.CssClasses_={RIPPLE_EFFECT:"mdl-js-ripple-effect",RIPPLE_CONTAINER:"mdl-button__ripple-container",RIPPLE:"mdl-ripple"},o.prototype.blurHandler_=function(e){e&&this.element_.blur()},o.prototype.disable=function(){this.element_.disabled=!0},o.prototype.disable=o.prototype.disable,o.prototype.enable=function(){this.element_.disabled=!1},o.prototype.enable=o.prototype.enable,o.prototype.init=function(){if(this.element_){if(this.element_.classList.contains(this.CssClasses_.RIPPLE_EFFECT)){var e=document.createElement("span");e.classList.add(this.CssClasses_.RIPPLE_CONTAINER),this.rippleElement_=document.createElement("span"),this.rippleElement_.classList.add(this.CssClasses_.RIPPLE),e.appendChild(this.rippleElement_),this.boundRippleBlurHandler=this.blurHandler_.bind(this),this.rippleElement_.addEventListener("mouseup",this.boundRippleBlurHandler),this.element_.appendChild(e)}this.boundButtonBlurHandler=this.blurHandler_.bind(this),this.element_.addEventListener("mouseup",this.boundButtonBlurHandler),this.element_.addEventListener("mouseleave",this.boundButtonBlurHandler)}},s.register({constructor:o,classAsString:"MaterialButton",cssClass:"mdl-js-button",widget:!0});var r=function(e){this.element_=e,this.init()};window.MaterialCheckbox=r,r.prototype.Constant_={TINY_TIMEOUT:.001},r.prototype.CssClasses_={INPUT:"mdl-checkbox__input",BOX_OUTLINE:"mdl-checkbox__box-outline",FOCUS_HELPER:"mdl-checkbox__focus-helper",TICK_OUTLINE:"mdl-checkbox__tick-outline",RIPPLE_EFFECT:"mdl-js-ripple-effect",RIPPLE_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events",RIPPLE_CONTAINER:"mdl-checkbox__ripple-container",RIPPLE_CENTER:"mdl-ripple--center",RIPPLE:"mdl-ripple",IS_FOCUSED:"is-focused",IS_DISABLED:"is-disabled",IS_CHECKED:"is-checked",IS_UPGRADED:"is-upgraded"},r.prototype.onChange_=function(e){this.updateClasses_()},r.prototype.onFocus_=function(e){this.element_.classList.add(this.CssClasses_.IS_FOCUSED)},r.prototype.onBlur_=function(e){this.element_.classList.remove(this.CssClasses_.IS_FOCUSED)},r.prototype.onMouseUp_=function(e){this.blur_()},r.prototype.updateClasses_=function(){this.checkDisabled(),this.checkToggleState()},r.prototype.blur_=function(){window.setTimeout(function(){this.inputElement_.blur()}.bind(this),this.Constant_.TINY_TIMEOUT)},r.prototype.checkToggleState=function(){this.inputElement_.checked?this.element_.classList.add(this.CssClasses_.IS_CHECKED):this.element_.classList.remove(this.CssClasses_.IS_CHECKED)},r.prototype.checkToggleState=r.prototype.checkToggleState,r.prototype.checkDisabled=function(){this.inputElement_.disabled?this.element_.classList.add(this.CssClasses_.IS_DISABLED):this.element_.classList.remove(this.CssClasses_.IS_DISABLED)},r.prototype.checkDisabled=r.prototype.checkDisabled,r.prototype.disable=function(){this.inputElement_.disabled=!0,this.updateClasses_()},r.prototype.disable=r.prototype.disable,r.prototype.enable=function(){this.inputElement_.disabled=!1,this.updateClasses_()},r.prototype.enable=r.prototype.enable,r.prototype.check=function(){this.inputElement_.checked=!0,this.updateClasses_()},r.prototype.check=r.prototype.check,r.prototype.uncheck=function(){this.inputElement_.checked=!1,this.updateClasses_()},r.prototype.uncheck=r.prototype.uncheck,r.prototype.init=function(){if(this.element_){this.inputElement_=this.element_.querySelector("."+this.CssClasses_.INPUT);var e=document.createElement("span");e.classList.add(this.CssClasses_.BOX_OUTLINE);var t=document.createElement("span");t.classList.add(this.CssClasses_.FOCUS_HELPER);var s=document.createElement("span");if(s.classList.add(this.CssClasses_.TICK_OUTLINE),e.appendChild(s),this.element_.appendChild(t),this.element_.appendChild(e),this.element_.classList.contains(this.CssClasses_.RIPPLE_EFFECT)){this.element_.classList.add(this.CssClasses_.RIPPLE_IGNORE_EVENTS),this.rippleContainerElement_=document.createElement("span"),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_CONTAINER),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_EFFECT),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_CENTER),this.boundRippleMouseUp=this.onMouseUp_.bind(this),this.rippleContainerElement_.addEventListener("mouseup",this.boundRippleMouseUp);var i=document.createElement("span");i.classList.add(this.CssClasses_.RIPPLE),this.rippleContainerElement_.appendChild(i),this.element_.appendChild(this.rippleContainerElement_)}this.boundInputOnChange=this.onChange_.bind(this),this.boundInputOnFocus=this.onFocus_.bind(this),this.boundInputOnBlur=this.onBlur_.bind(this),this.boundElementMouseUp=this.onMouseUp_.bind(this),this.inputElement_.addEventListener("change",this.boundInputOnChange),this.inputElement_.addEventListener("focus",this.boundInputOnFocus),this.inputElement_.addEventListener("blur",this.boundInputOnBlur),this.element_.addEventListener("mouseup",this.boundElementMouseUp),this.updateClasses_(),this.element_.classList.add(this.CssClasses_.IS_UPGRADED)}},s.register({constructor:r,classAsString:"MaterialCheckbox",cssClass:"mdl-js-checkbox",widget:!0});var _=function(e){this.element_=e,this.init()};window.MaterialIconToggle=_,_.prototype.Constant_={TINY_TIMEOUT:.001},_.prototype.CssClasses_={INPUT:"mdl-icon-toggle__input",JS_RIPPLE_EFFECT:"mdl-js-ripple-effect",RIPPLE_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events",RIPPLE_CONTAINER:"mdl-icon-toggle__ripple-container",RIPPLE_CENTER:"mdl-ripple--center",RIPPLE:"mdl-ripple",IS_FOCUSED:"is-focused",IS_DISABLED:"is-disabled",IS_CHECKED:"is-checked"},_.prototype.onChange_=function(e){this.updateClasses_()},_.prototype.onFocus_=function(e){this.element_.classList.add(this.CssClasses_.IS_FOCUSED)},_.prototype.onBlur_=function(e){this.element_.classList.remove(this.CssClasses_.IS_FOCUSED)},_.prototype.onMouseUp_=function(e){this.blur_()},_.prototype.updateClasses_=function(){this.checkDisabled(),this.checkToggleState()},_.prototype.blur_=function(){window.setTimeout(function(){this.inputElement_.blur()}.bind(this),this.Constant_.TINY_TIMEOUT)},_.prototype.checkToggleState=function(){this.inputElement_.checked?this.element_.classList.add(this.CssClasses_.IS_CHECKED):this.element_.classList.remove(this.CssClasses_.IS_CHECKED)},_.prototype.checkToggleState=_.prototype.checkToggleState,_.prototype.checkDisabled=function(){this.inputElement_.disabled?this.element_.classList.add(this.CssClasses_.IS_DISABLED):this.element_.classList.remove(this.CssClasses_.IS_DISABLED)},_.prototype.checkDisabled=_.prototype.checkDisabled,_.prototype.disable=function(){this.inputElement_.disabled=!0,this.updateClasses_()},_.prototype.disable=_.prototype.disable,_.prototype.enable=function(){this.inputElement_.disabled=!1,this.updateClasses_()},_.prototype.enable=_.prototype.enable,_.prototype.check=function(){this.inputElement_.checked=!0,this.updateClasses_()},_.prototype.check=_.prototype.check,_.prototype.uncheck=function(){this.inputElement_.checked=!1,this.updateClasses_()},_.prototype.uncheck=_.prototype.uncheck,_.prototype.init=function(){if(this.element_){if(this.inputElement_=this.element_.querySelector("."+this.CssClasses_.INPUT),this.element_.classList.contains(this.CssClasses_.JS_RIPPLE_EFFECT)){this.element_.classList.add(this.CssClasses_.RIPPLE_IGNORE_EVENTS),this.rippleContainerElement_=document.createElement("span"),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_CONTAINER),this.rippleContainerElement_.classList.add(this.CssClasses_.JS_RIPPLE_EFFECT),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_CENTER),this.boundRippleMouseUp=this.onMouseUp_.bind(this),this.rippleContainerElement_.addEventListener("mouseup",this.boundRippleMouseUp);var e=document.createElement("span");e.classList.add(this.CssClasses_.RIPPLE),this.rippleContainerElement_.appendChild(e),this.element_.appendChild(this.rippleContainerElement_)}this.boundInputOnChange=this.onChange_.bind(this),this.boundInputOnFocus=this.onFocus_.bind(this),this.boundInputOnBlur=this.onBlur_.bind(this),this.boundElementOnMouseUp=this.onMouseUp_.bind(this),this.inputElement_.addEventListener("change",this.boundInputOnChange),this.inputElement_.addEventListener("focus",this.boundInputOnFocus),this.inputElement_.addEventListener("blur",this.boundInputOnBlur),this.element_.addEventListener("mouseup",this.boundElementOnMouseUp),this.updateClasses_(),this.element_.classList.add("is-upgraded")}},s.register({constructor:_,classAsString:"MaterialIconToggle",cssClass:"mdl-js-icon-toggle",widget:!0});var d=function(e){this.element_=e,this.init()};window.MaterialMenu=d,d.prototype.Constant_={TRANSITION_DURATION_SECONDS:.3,TRANSITION_DURATION_FRACTION:.8,CLOSE_TIMEOUT:150},d.prototype.Keycodes_={ENTER:13,ESCAPE:27,SPACE:32,UP_ARROW:38,DOWN_ARROW:40},d.prototype.CssClasses_={CONTAINER:"mdl-menu__container",OUTLINE:"mdl-menu__outline",ITEM:"mdl-menu__item",ITEM_RIPPLE_CONTAINER:"mdl-menu__item-ripple-container",RIPPLE_EFFECT:"mdl-js-ripple-effect",RIPPLE_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events",RIPPLE:"mdl-ripple",IS_UPGRADED:"is-upgraded",IS_VISIBLE:"is-visible",IS_ANIMATING:"is-animating",BOTTOM_LEFT:"mdl-menu--bottom-left",BOTTOM_RIGHT:"mdl-menu--bottom-right",TOP_LEFT:"mdl-menu--top-left",TOP_RIGHT:"mdl-menu--top-right",UNALIGNED:"mdl-menu--unaligned"},d.prototype.init=function(){if(this.element_){var e=document.createElement("div");e.classList.add(this.CssClasses_.CONTAINER),this.element_.parentElement.insertBefore(e,this.element_),this.element_.parentElement.removeChild(this.element_),e.appendChild(this.element_),this.container_=e;var t=document.createElement("div");t.classList.add(this.CssClasses_.OUTLINE),this.outline_=t,e.insertBefore(t,this.element_);var s=this.element_.getAttribute("for")||this.element_.getAttribute("data-mdl-for"),i=null;s&&(i=document.getElementById(s),i&&(this.forElement_=i,i.addEventListener("click",this.handleForClick_.bind(this)),i.addEventListener("keydown",this.handleForKeyboardEvent_.bind(this))));var n=this.element_.querySelectorAll("."+this.CssClasses_.ITEM);this.boundItemKeydown_=this.handleItemKeyboardEvent_.bind(this),this.boundItemClick_=this.handleItemClick_.bind(this);for(var a=0;a<n.length;a++)n[a].addEventListener("click",this.boundItemClick_),n[a].tabIndex="-1",n[a].addEventListener("keydown",this.boundItemKeydown_);if(this.element_.classList.contains(this.CssClasses_.RIPPLE_EFFECT))for(this.element_.classList.add(this.CssClasses_.RIPPLE_IGNORE_EVENTS),a=0;a<n.length;a++){var l=n[a],o=document.createElement("span");o.classList.add(this.CssClasses_.ITEM_RIPPLE_CONTAINER);var r=document.createElement("span");r.classList.add(this.CssClasses_.RIPPLE),o.appendChild(r),l.appendChild(o),l.classList.add(this.CssClasses_.RIPPLE_EFFECT)}this.element_.classList.contains(this.CssClasses_.BOTTOM_LEFT)&&this.outline_.classList.add(this.CssClasses_.BOTTOM_LEFT),this.element_.classList.contains(this.CssClasses_.BOTTOM_RIGHT)&&this.outline_.classList.add(this.CssClasses_.BOTTOM_RIGHT),this.element_.classList.contains(this.CssClasses_.TOP_LEFT)&&this.outline_.classList.add(this.CssClasses_.TOP_LEFT),this.element_.classList.contains(this.CssClasses_.TOP_RIGHT)&&this.outline_.classList.add(this.CssClasses_.TOP_RIGHT),this.element_.classList.contains(this.CssClasses_.UNALIGNED)&&this.outline_.classList.add(this.CssClasses_.UNALIGNED),e.classList.add(this.CssClasses_.IS_UPGRADED)}},d.prototype.handleForClick_=function(e){if(this.element_&&this.forElement_){var t=this.forElement_.getBoundingClientRect(),s=this.forElement_.parentElement.getBoundingClientRect();this.element_.classList.contains(this.CssClasses_.UNALIGNED)||(this.element_.classList.contains(this.CssClasses_.BOTTOM_RIGHT)?(this.container_.style.right=s.right-t.right+"px",this.container_.style.top=this.forElement_.offsetTop+this.forElement_.offsetHeight+"px"):this.element_.classList.contains(this.CssClasses_.TOP_LEFT)?(this.container_.style.left=this.forElement_.offsetLeft+"px",this.container_.style.bottom=s.bottom-t.top+"px"):this.element_.classList.contains(this.CssClasses_.TOP_RIGHT)?(this.container_.style.right=s.right-t.right+"px",this.container_.style.bottom=s.bottom-t.top+"px"):(this.container_.style.left=this.forElement_.offsetLeft+"px",this.container_.style.top=this.forElement_.offsetTop+this.forElement_.offsetHeight+"px"))}this.toggle(e)},d.prototype.handleForKeyboardEvent_=function(e){if(this.element_&&this.container_&&this.forElement_){var t=this.element_.querySelectorAll("."+this.CssClasses_.ITEM+":not([disabled])");t&&t.length>0&&this.container_.classList.contains(this.CssClasses_.IS_VISIBLE)&&(e.keyCode===this.Keycodes_.UP_ARROW?(e.preventDefault(),t[t.length-1].focus()):e.keyCode===this.Keycodes_.DOWN_ARROW&&(e.preventDefault(),t[0].focus()))}},d.prototype.handleItemKeyboardEvent_=function(e){if(this.element_&&this.container_){var t=this.element_.querySelectorAll("."+this.CssClasses_.ITEM+":not([disabled])");if(t&&t.length>0&&this.container_.classList.contains(this.CssClasses_.IS_VISIBLE)){var s=Array.prototype.slice.call(t).indexOf(e.target);if(e.keyCode===this.Keycodes_.UP_ARROW)e.preventDefault(),s>0?t[s-1].focus():t[t.length-1].focus();else if(e.keyCode===this.Keycodes_.DOWN_ARROW)e.preventDefault(),t.length>s+1?t[s+1].focus():t[0].focus();else if(e.keyCode===this.Keycodes_.SPACE||e.keyCode===this.Keycodes_.ENTER){e.preventDefault();var i=new MouseEvent("mousedown");e.target.dispatchEvent(i),i=new MouseEvent("mouseup"),e.target.dispatchEvent(i),e.target.click()}else e.keyCode===this.Keycodes_.ESCAPE&&(e.preventDefault(),this.hide())}}},d.prototype.handleItemClick_=function(e){e.target.hasAttribute("disabled")?e.stopPropagation():(this.closing_=!0,window.setTimeout(function(e){this.hide(),this.closing_=!1}.bind(this),this.Constant_.CLOSE_TIMEOUT))},d.prototype.applyClip_=function(e,t){this.element_.classList.contains(this.CssClasses_.UNALIGNED)?this.element_.style.clip="":this.element_.classList.contains(this.CssClasses_.BOTTOM_RIGHT)?this.element_.style.clip="rect(0 "+t+"px 0 "+t+"px)":this.element_.classList.contains(this.CssClasses_.TOP_LEFT)?this.element_.style.clip="rect("+e+"px 0 "+e+"px 0)":this.element_.classList.contains(this.CssClasses_.TOP_RIGHT)?this.element_.style.clip="rect("+e+"px "+t+"px "+e+"px "+t+"px)":this.element_.style.clip=""},d.prototype.removeAnimationEndListener_=function(e){e.target.classList.remove(d.prototype.CssClasses_.IS_ANIMATING)},d.prototype.addAnimationEndListener_=function(){this.element_.addEventListener("transitionend",this.removeAnimationEndListener_),this.element_.addEventListener("webkitTransitionEnd",this.removeAnimationEndListener_)},d.prototype.show=function(e){if(this.element_&&this.container_&&this.outline_){var t=this.element_.getBoundingClientRect().height,s=this.element_.getBoundingClientRect().width;this.container_.style.width=s+"px",this.container_.style.height=t+"px",this.outline_.style.width=s+"px",this.outline_.style.height=t+"px";for(var i=this.Constant_.TRANSITION_DURATION_SECONDS*this.Constant_.TRANSITION_DURATION_FRACTION,n=this.element_.querySelectorAll("."+this.CssClasses_.ITEM),a=0;a<n.length;a++){var l=null;l=this.element_.classList.contains(this.CssClasses_.TOP_LEFT)||this.element_.classList.contains(this.CssClasses_.TOP_RIGHT)?(t-n[a].offsetTop-n[a].offsetHeight)/t*i+"s":n[a].offsetTop/t*i+"s",n[a].style.transitionDelay=l}this.applyClip_(t,s),window.requestAnimationFrame(function(){this.element_.classList.add(this.CssClasses_.IS_ANIMATING),this.element_.style.clip="rect(0 "+s+"px "+t+"px 0)",this.container_.classList.add(this.CssClasses_.IS_VISIBLE)}.bind(this)),this.addAnimationEndListener_();var o=function(t){t===e||this.closing_||t.target.parentNode===this.element_||(document.removeEventListener("click",o),this.hide())}.bind(this);document.addEventListener("click",o)}},d.prototype.show=d.prototype.show,d.prototype.hide=function(){if(this.element_&&this.container_&&this.outline_){for(var e=this.element_.querySelectorAll("."+this.CssClasses_.ITEM),t=0;t<e.length;t++)e[t].style.removeProperty("transition-delay");var s=this.element_.getBoundingClientRect(),i=s.height,n=s.width;this.element_.classList.add(this.CssClasses_.IS_ANIMATING),this.applyClip_(i,n),this.container_.classList.remove(this.CssClasses_.IS_VISIBLE),this.addAnimationEndListener_()}},d.prototype.hide=d.prototype.hide,d.prototype.toggle=function(e){this.container_.classList.contains(this.CssClasses_.IS_VISIBLE)?this.hide():this.show(e)},d.prototype.toggle=d.prototype.toggle,s.register({constructor:d,classAsString:"MaterialMenu",cssClass:"mdl-js-menu",widget:!0});var h=function(e){this.element_=e,this.init()};window.MaterialProgress=h,h.prototype.Constant_={},h.prototype.CssClasses_={INDETERMINATE_CLASS:"mdl-progress__indeterminate"},h.prototype.setProgress=function(e){this.element_.classList.contains(this.CssClasses_.INDETERMINATE_CLASS)||(this.progressbar_.style.width=e+"%")},h.prototype.setProgress=h.prototype.setProgress,h.prototype.setBuffer=function(e){this.bufferbar_.style.width=e+"%",this.auxbar_.style.width=100-e+"%"},h.prototype.setBuffer=h.prototype.setBuffer,h.prototype.init=function(){if(this.element_){var e=document.createElement("div");e.className="progressbar bar bar1",this.element_.appendChild(e),this.progressbar_=e,e=document.createElement("div"),e.className="bufferbar bar bar2",this.element_.appendChild(e),this.bufferbar_=e,e=document.createElement("div"),e.className="auxbar bar bar3",this.element_.appendChild(e),this.auxbar_=e,this.progressbar_.style.width="0%",this.bufferbar_.style.width="100%",this.auxbar_.style.width="0%",this.element_.classList.add("is-upgraded")}},s.register({constructor:h,classAsString:"MaterialProgress",cssClass:"mdl-js-progress",widget:!0});var c=function(e){this.element_=e,this.init()};window.MaterialRadio=c,c.prototype.Constant_={TINY_TIMEOUT:.001},c.prototype.CssClasses_={IS_FOCUSED:"is-focused",IS_DISABLED:"is-disabled",IS_CHECKED:"is-checked",IS_UPGRADED:"is-upgraded",JS_RADIO:"mdl-js-radio",RADIO_BTN:"mdl-radio__button",RADIO_OUTER_CIRCLE:"mdl-radio__outer-circle",RADIO_INNER_CIRCLE:"mdl-radio__inner-circle",RIPPLE_EFFECT:"mdl-js-ripple-effect",RIPPLE_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events",RIPPLE_CONTAINER:"mdl-radio__ripple-container",RIPPLE_CENTER:"mdl-ripple--center",RIPPLE:"mdl-ripple"},c.prototype.onChange_=function(e){for(var t=document.getElementsByClassName(this.CssClasses_.JS_RADIO),s=0;s<t.length;s++){var i=t[s].querySelector("."+this.CssClasses_.RADIO_BTN);i.getAttribute("name")===this.btnElement_.getAttribute("name")&&t[s].MaterialRadio.updateClasses_()}},c.prototype.onFocus_=function(e){this.element_.classList.add(this.CssClasses_.IS_FOCUSED)},c.prototype.onBlur_=function(e){this.element_.classList.remove(this.CssClasses_.IS_FOCUSED)},c.prototype.onMouseup_=function(e){this.blur_()},c.prototype.updateClasses_=function(){this.checkDisabled(),this.checkToggleState()},c.prototype.blur_=function(){window.setTimeout(function(){this.btnElement_.blur()}.bind(this),this.Constant_.TINY_TIMEOUT)},c.prototype.checkDisabled=function(){this.btnElement_.disabled?this.element_.classList.add(this.CssClasses_.IS_DISABLED):this.element_.classList.remove(this.CssClasses_.IS_DISABLED)},c.prototype.checkDisabled=c.prototype.checkDisabled,c.prototype.checkToggleState=function(){this.btnElement_.checked?this.element_.classList.add(this.CssClasses_.IS_CHECKED):this.element_.classList.remove(this.CssClasses_.IS_CHECKED)},c.prototype.checkToggleState=c.prototype.checkToggleState,c.prototype.disable=function(){this.btnElement_.disabled=!0,this.updateClasses_()},c.prototype.disable=c.prototype.disable,c.prototype.enable=function(){this.btnElement_.disabled=!1,this.updateClasses_()},c.prototype.enable=c.prototype.enable,c.prototype.check=function(){this.btnElement_.checked=!0,this.onChange_(null)},c.prototype.check=c.prototype.check,c.prototype.uncheck=function(){this.btnElement_.checked=!1,this.onChange_(null)},c.prototype.uncheck=c.prototype.uncheck,c.prototype.init=function(){if(this.element_){this.btnElement_=this.element_.querySelector("."+this.CssClasses_.RADIO_BTN),this.boundChangeHandler_=this.onChange_.bind(this),this.boundFocusHandler_=this.onChange_.bind(this),this.boundBlurHandler_=this.onBlur_.bind(this),this.boundMouseUpHandler_=this.onMouseup_.bind(this);var e=document.createElement("span");e.classList.add(this.CssClasses_.RADIO_OUTER_CIRCLE);var t=document.createElement("span");t.classList.add(this.CssClasses_.RADIO_INNER_CIRCLE),this.element_.appendChild(e),this.element_.appendChild(t);var s;if(this.element_.classList.contains(this.CssClasses_.RIPPLE_EFFECT)){this.element_.classList.add(this.CssClasses_.RIPPLE_IGNORE_EVENTS),s=document.createElement("span"),s.classList.add(this.CssClasses_.RIPPLE_CONTAINER),s.classList.add(this.CssClasses_.RIPPLE_EFFECT),s.classList.add(this.CssClasses_.RIPPLE_CENTER),s.addEventListener("mouseup",this.boundMouseUpHandler_);var i=document.createElement("span");i.classList.add(this.CssClasses_.RIPPLE),s.appendChild(i),this.element_.appendChild(s)}this.btnElement_.addEventListener("change",this.boundChangeHandler_),this.btnElement_.addEventListener("focus",this.boundFocusHandler_),this.btnElement_.addEventListener("blur",this.boundBlurHandler_),this.element_.addEventListener("mouseup",this.boundMouseUpHandler_),this.updateClasses_(),this.element_.classList.add(this.CssClasses_.IS_UPGRADED)}},s.register({constructor:c,classAsString:"MaterialRadio",cssClass:"mdl-js-radio",widget:!0});var p=function(e){this.element_=e,this.isIE_=window.navigator.msPointerEnabled,this.init()};window.MaterialSlider=p,p.prototype.Constant_={},p.prototype.CssClasses_={IE_CONTAINER:"mdl-slider__ie-container",SLIDER_CONTAINER:"mdl-slider__container",BACKGROUND_FLEX:"mdl-slider__background-flex",BACKGROUND_LOWER:"mdl-slider__background-lower",BACKGROUND_UPPER:"mdl-slider__background-upper",IS_LOWEST_VALUE:"is-lowest-value",IS_UPGRADED:"is-upgraded"},p.prototype.onInput_=function(e){this.updateValueStyles_()},p.prototype.onChange_=function(e){this.updateValueStyles_()},p.prototype.onMouseUp_=function(e){e.target.blur()},p.prototype.onContainerMouseDown_=function(e){if(e.target===this.element_.parentElement){e.preventDefault();var t=new MouseEvent("mousedown",{target:e.target,buttons:e.buttons,clientX:e.clientX,clientY:this.element_.getBoundingClientRect().y});this.element_.dispatchEvent(t)}},p.prototype.updateValueStyles_=function(){var e=(this.element_.value-this.element_.min)/(this.element_.max-this.element_.min);0===e?this.element_.classList.add(this.CssClasses_.IS_LOWEST_VALUE):this.element_.classList.remove(this.CssClasses_.IS_LOWEST_VALUE),this.isIE_||(this.backgroundLower_.style.flex=e,this.backgroundLower_.style.webkitFlex=e,this.backgroundUpper_.style.flex=1-e,this.backgroundUpper_.style.webkitFlex=1-e)},p.prototype.disable=function(){this.element_.disabled=!0},p.prototype.disable=p.prototype.disable,p.prototype.enable=function(){this.element_.disabled=!1},p.prototype.enable=p.prototype.enable,p.prototype.change=function(e){"undefined"!=typeof e&&(this.element_.value=e),this.updateValueStyles_()},p.prototype.change=p.prototype.change,p.prototype.init=function(){if(this.element_){if(this.isIE_){var e=document.createElement("div");e.classList.add(this.CssClasses_.IE_CONTAINER),this.element_.parentElement.insertBefore(e,this.element_),this.element_.parentElement.removeChild(this.element_),e.appendChild(this.element_)}else{var t=document.createElement("div");t.classList.add(this.CssClasses_.SLIDER_CONTAINER),this.element_.parentElement.insertBefore(t,this.element_),this.element_.parentElement.removeChild(this.element_),t.appendChild(this.element_);var s=document.createElement("div");s.classList.add(this.CssClasses_.BACKGROUND_FLEX),t.appendChild(s),this.backgroundLower_=document.createElement("div"),this.backgroundLower_.classList.add(this.CssClasses_.BACKGROUND_LOWER),s.appendChild(this.backgroundLower_),this.backgroundUpper_=document.createElement("div"),this.backgroundUpper_.classList.add(this.CssClasses_.BACKGROUND_UPPER),s.appendChild(this.backgroundUpper_)}this.boundInputHandler=this.onInput_.bind(this),this.boundChangeHandler=this.onChange_.bind(this),this.boundMouseUpHandler=this.onMouseUp_.bind(this),this.boundContainerMouseDownHandler=this.onContainerMouseDown_.bind(this),this.element_.addEventListener("input",this.boundInputHandler),this.element_.addEventListener("change",this.boundChangeHandler),this.element_.addEventListener("mouseup",this.boundMouseUpHandler),this.element_.parentElement.addEventListener("mousedown",this.boundContainerMouseDownHandler),this.updateValueStyles_(),this.element_.classList.add(this.CssClasses_.IS_UPGRADED)}},s.register({constructor:p,classAsString:"MaterialSlider",cssClass:"mdl-js-slider",widget:!0});var C=function(e){if(this.element_=e,this.textElement_=this.element_.querySelector("."+this.cssClasses_.MESSAGE),this.actionElement_=this.element_.querySelector("."+this.cssClasses_.ACTION),!this.textElement_)throw new Error("There must be a message element for a snackbar.");if(!this.actionElement_)throw new Error("There must be an action element for a snackbar.");this.active=!1,this.actionHandler_=void 0,this.message_=void 0,this.actionText_=void 0,this.queuedNotifications_=[],this.setActionHidden_(!0)};window.MaterialSnackbar=C,C.prototype.Constant_={ANIMATION_LENGTH:250},C.prototype.cssClasses_={SNACKBAR:"mdl-snackbar",MESSAGE:"mdl-snackbar__text",ACTION:"mdl-snackbar__action",ACTIVE:"mdl-snackbar--active"},C.prototype.displaySnackbar_=function(){this.element_.setAttribute("aria-hidden","true"),this.actionHandler_&&(this.actionElement_.textContent=this.actionText_,
this.actionElement_.addEventListener("click",this.actionHandler_),this.setActionHidden_(!1)),this.textElement_.textContent=this.message_,this.element_.classList.add(this.cssClasses_.ACTIVE),this.element_.setAttribute("aria-hidden","false"),setTimeout(this.cleanup_.bind(this),this.timeout_)},C.prototype.showSnackbar=function(e){if(void 0===e)throw new Error("Please provide a data object with at least a message to display.");if(void 0===e.message)throw new Error("Please provide a message to be displayed.");if(e.actionHandler&&!e.actionText)throw new Error("Please provide action text with the handler.");this.active?this.queuedNotifications_.push(e):(this.active=!0,this.message_=e.message,e.timeout?this.timeout_=e.timeout:this.timeout_=2750,e.actionHandler&&(this.actionHandler_=e.actionHandler),e.actionText&&(this.actionText_=e.actionText),this.displaySnackbar_())},C.prototype.showSnackbar=C.prototype.showSnackbar,C.prototype.checkQueue_=function(){this.queuedNotifications_.length>0&&this.showSnackbar(this.queuedNotifications_.shift())},C.prototype.cleanup_=function(){this.element_.classList.remove(this.cssClasses_.ACTIVE),setTimeout(function(){this.element_.setAttribute("aria-hidden","true"),this.textElement_.textContent="",Boolean(this.actionElement_.getAttribute("aria-hidden"))||(this.setActionHidden_(!0),this.actionElement_.textContent="",this.actionElement_.removeEventListener("click",this.actionHandler_)),this.actionHandler_=void 0,this.message_=void 0,this.actionText_=void 0,this.active=!1,this.checkQueue_()}.bind(this),this.Constant_.ANIMATION_LENGTH)},C.prototype.setActionHidden_=function(e){e?this.actionElement_.setAttribute("aria-hidden","true"):this.actionElement_.removeAttribute("aria-hidden")},s.register({constructor:C,classAsString:"MaterialSnackbar",cssClass:"mdl-js-snackbar",widget:!0});var u=function(e){this.element_=e,this.init()};window.MaterialSpinner=u,u.prototype.Constant_={MDL_SPINNER_LAYER_COUNT:4},u.prototype.CssClasses_={MDL_SPINNER_LAYER:"mdl-spinner__layer",MDL_SPINNER_CIRCLE_CLIPPER:"mdl-spinner__circle-clipper",MDL_SPINNER_CIRCLE:"mdl-spinner__circle",MDL_SPINNER_GAP_PATCH:"mdl-spinner__gap-patch",MDL_SPINNER_LEFT:"mdl-spinner__left",MDL_SPINNER_RIGHT:"mdl-spinner__right"},u.prototype.createLayer=function(e){var t=document.createElement("div");t.classList.add(this.CssClasses_.MDL_SPINNER_LAYER),t.classList.add(this.CssClasses_.MDL_SPINNER_LAYER+"-"+e);var s=document.createElement("div");s.classList.add(this.CssClasses_.MDL_SPINNER_CIRCLE_CLIPPER),s.classList.add(this.CssClasses_.MDL_SPINNER_LEFT);var i=document.createElement("div");i.classList.add(this.CssClasses_.MDL_SPINNER_GAP_PATCH);var n=document.createElement("div");n.classList.add(this.CssClasses_.MDL_SPINNER_CIRCLE_CLIPPER),n.classList.add(this.CssClasses_.MDL_SPINNER_RIGHT);for(var a=[s,i,n],l=0;l<a.length;l++){var o=document.createElement("div");o.classList.add(this.CssClasses_.MDL_SPINNER_CIRCLE),a[l].appendChild(o)}t.appendChild(s),t.appendChild(i),t.appendChild(n),this.element_.appendChild(t)},u.prototype.createLayer=u.prototype.createLayer,u.prototype.stop=function(){this.element_.classList.remove("is-active")},u.prototype.stop=u.prototype.stop,u.prototype.start=function(){this.element_.classList.add("is-active")},u.prototype.start=u.prototype.start,u.prototype.init=function(){if(this.element_){for(var e=1;e<=this.Constant_.MDL_SPINNER_LAYER_COUNT;e++)this.createLayer(e);this.element_.classList.add("is-upgraded")}},s.register({constructor:u,classAsString:"MaterialSpinner",cssClass:"mdl-js-spinner",widget:!0});var E=function(e){this.element_=e,this.init()};window.MaterialSwitch=E,E.prototype.Constant_={TINY_TIMEOUT:.001},E.prototype.CssClasses_={INPUT:"mdl-switch__input",TRACK:"mdl-switch__track",THUMB:"mdl-switch__thumb",FOCUS_HELPER:"mdl-switch__focus-helper",RIPPLE_EFFECT:"mdl-js-ripple-effect",RIPPLE_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events",RIPPLE_CONTAINER:"mdl-switch__ripple-container",RIPPLE_CENTER:"mdl-ripple--center",RIPPLE:"mdl-ripple",IS_FOCUSED:"is-focused",IS_DISABLED:"is-disabled",IS_CHECKED:"is-checked"},E.prototype.onChange_=function(e){this.updateClasses_()},E.prototype.onFocus_=function(e){this.element_.classList.add(this.CssClasses_.IS_FOCUSED)},E.prototype.onBlur_=function(e){this.element_.classList.remove(this.CssClasses_.IS_FOCUSED)},E.prototype.onMouseUp_=function(e){this.blur_()},E.prototype.updateClasses_=function(){this.checkDisabled(),this.checkToggleState()},E.prototype.blur_=function(){window.setTimeout(function(){this.inputElement_.blur()}.bind(this),this.Constant_.TINY_TIMEOUT)},E.prototype.checkDisabled=function(){this.inputElement_.disabled?this.element_.classList.add(this.CssClasses_.IS_DISABLED):this.element_.classList.remove(this.CssClasses_.IS_DISABLED)},E.prototype.checkDisabled=E.prototype.checkDisabled,E.prototype.checkToggleState=function(){this.inputElement_.checked?this.element_.classList.add(this.CssClasses_.IS_CHECKED):this.element_.classList.remove(this.CssClasses_.IS_CHECKED)},E.prototype.checkToggleState=E.prototype.checkToggleState,E.prototype.disable=function(){this.inputElement_.disabled=!0,this.updateClasses_()},E.prototype.disable=E.prototype.disable,E.prototype.enable=function(){this.inputElement_.disabled=!1,this.updateClasses_()},E.prototype.enable=E.prototype.enable,E.prototype.on=function(){this.inputElement_.checked=!0,this.updateClasses_()},E.prototype.on=E.prototype.on,E.prototype.off=function(){this.inputElement_.checked=!1,this.updateClasses_()},E.prototype.off=E.prototype.off,E.prototype.init=function(){if(this.element_){this.inputElement_=this.element_.querySelector("."+this.CssClasses_.INPUT);var e=document.createElement("div");e.classList.add(this.CssClasses_.TRACK);var t=document.createElement("div");t.classList.add(this.CssClasses_.THUMB);var s=document.createElement("span");if(s.classList.add(this.CssClasses_.FOCUS_HELPER),t.appendChild(s),this.element_.appendChild(e),this.element_.appendChild(t),this.boundMouseUpHandler=this.onMouseUp_.bind(this),this.element_.classList.contains(this.CssClasses_.RIPPLE_EFFECT)){this.element_.classList.add(this.CssClasses_.RIPPLE_IGNORE_EVENTS),this.rippleContainerElement_=document.createElement("span"),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_CONTAINER),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_EFFECT),this.rippleContainerElement_.classList.add(this.CssClasses_.RIPPLE_CENTER),this.rippleContainerElement_.addEventListener("mouseup",this.boundMouseUpHandler);var i=document.createElement("span");i.classList.add(this.CssClasses_.RIPPLE),this.rippleContainerElement_.appendChild(i),this.element_.appendChild(this.rippleContainerElement_)}this.boundChangeHandler=this.onChange_.bind(this),this.boundFocusHandler=this.onFocus_.bind(this),this.boundBlurHandler=this.onBlur_.bind(this),this.inputElement_.addEventListener("change",this.boundChangeHandler),this.inputElement_.addEventListener("focus",this.boundFocusHandler),this.inputElement_.addEventListener("blur",this.boundBlurHandler),this.element_.addEventListener("mouseup",this.boundMouseUpHandler),this.updateClasses_(),this.element_.classList.add("is-upgraded")}},s.register({constructor:E,classAsString:"MaterialSwitch",cssClass:"mdl-js-switch",widget:!0});var m=function(e){this.element_=e,this.init()};window.MaterialTabs=m,m.prototype.Constant_={},m.prototype.CssClasses_={TAB_CLASS:"mdl-tabs__tab",PANEL_CLASS:"mdl-tabs__panel",ACTIVE_CLASS:"is-active",UPGRADED_CLASS:"is-upgraded",MDL_JS_RIPPLE_EFFECT:"mdl-js-ripple-effect",MDL_RIPPLE_CONTAINER:"mdl-tabs__ripple-container",MDL_RIPPLE:"mdl-ripple",MDL_JS_RIPPLE_EFFECT_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events"},m.prototype.initTabs_=function(){this.element_.classList.contains(this.CssClasses_.MDL_JS_RIPPLE_EFFECT)&&this.element_.classList.add(this.CssClasses_.MDL_JS_RIPPLE_EFFECT_IGNORE_EVENTS),this.tabs_=this.element_.querySelectorAll("."+this.CssClasses_.TAB_CLASS),this.panels_=this.element_.querySelectorAll("."+this.CssClasses_.PANEL_CLASS);for(var t=0;t<this.tabs_.length;t++)new e(this.tabs_[t],this);this.element_.classList.add(this.CssClasses_.UPGRADED_CLASS)},m.prototype.resetTabState_=function(){for(var e=0;e<this.tabs_.length;e++)this.tabs_[e].classList.remove(this.CssClasses_.ACTIVE_CLASS)},m.prototype.resetPanelState_=function(){for(var e=0;e<this.panels_.length;e++)this.panels_[e].classList.remove(this.CssClasses_.ACTIVE_CLASS)},m.prototype.init=function(){this.element_&&this.initTabs_()},s.register({constructor:m,classAsString:"MaterialTabs",cssClass:"mdl-js-tabs"});var L=function(e){this.element_=e,this.maxRows=this.Constant_.NO_MAX_ROWS,this.init()};window.MaterialTextfield=L,L.prototype.Constant_={NO_MAX_ROWS:-1,MAX_ROWS_ATTRIBUTE:"maxrows"},L.prototype.CssClasses_={LABEL:"mdl-textfield__label",INPUT:"mdl-textfield__input",IS_DIRTY:"is-dirty",IS_FOCUSED:"is-focused",IS_DISABLED:"is-disabled",IS_INVALID:"is-invalid",IS_UPGRADED:"is-upgraded",HAS_PLACEHOLDER:"has-placeholder"},L.prototype.onKeyDown_=function(e){var t=e.target.value.split("\n").length;13===e.keyCode&&t>=this.maxRows&&e.preventDefault()},L.prototype.onFocus_=function(e){this.element_.classList.add(this.CssClasses_.IS_FOCUSED)},L.prototype.onBlur_=function(e){this.element_.classList.remove(this.CssClasses_.IS_FOCUSED)},L.prototype.onReset_=function(e){this.updateClasses_()},L.prototype.updateClasses_=function(){this.checkDisabled(),this.checkValidity(),this.checkDirty(),this.checkFocus()},L.prototype.checkDisabled=function(){this.input_.disabled?this.element_.classList.add(this.CssClasses_.IS_DISABLED):this.element_.classList.remove(this.CssClasses_.IS_DISABLED)},L.prototype.checkDisabled=L.prototype.checkDisabled,L.prototype.checkFocus=function(){Boolean(this.element_.querySelector(":focus"))?this.element_.classList.add(this.CssClasses_.IS_FOCUSED):this.element_.classList.remove(this.CssClasses_.IS_FOCUSED)},L.prototype.checkFocus=L.prototype.checkFocus,L.prototype.checkValidity=function(){this.input_.validity&&(this.input_.validity.valid?this.element_.classList.remove(this.CssClasses_.IS_INVALID):this.element_.classList.add(this.CssClasses_.IS_INVALID))},L.prototype.checkValidity=L.prototype.checkValidity,L.prototype.checkDirty=function(){this.input_.value&&this.input_.value.length>0?this.element_.classList.add(this.CssClasses_.IS_DIRTY):this.element_.classList.remove(this.CssClasses_.IS_DIRTY)},L.prototype.checkDirty=L.prototype.checkDirty,L.prototype.disable=function(){this.input_.disabled=!0,this.updateClasses_()},L.prototype.disable=L.prototype.disable,L.prototype.enable=function(){this.input_.disabled=!1,this.updateClasses_()},L.prototype.enable=L.prototype.enable,L.prototype.change=function(e){this.input_.value=e||"",this.updateClasses_()},L.prototype.change=L.prototype.change,L.prototype.init=function(){if(this.element_&&(this.label_=this.element_.querySelector("."+this.CssClasses_.LABEL),this.input_=this.element_.querySelector("."+this.CssClasses_.INPUT),this.input_)){this.input_.hasAttribute(this.Constant_.MAX_ROWS_ATTRIBUTE)&&(this.maxRows=parseInt(this.input_.getAttribute(this.Constant_.MAX_ROWS_ATTRIBUTE),10),isNaN(this.maxRows)&&(this.maxRows=this.Constant_.NO_MAX_ROWS)),this.input_.hasAttribute("placeholder")&&this.element_.classList.add(this.CssClasses_.HAS_PLACEHOLDER),this.boundUpdateClassesHandler=this.updateClasses_.bind(this),this.boundFocusHandler=this.onFocus_.bind(this),this.boundBlurHandler=this.onBlur_.bind(this),this.boundResetHandler=this.onReset_.bind(this),this.input_.addEventListener("input",this.boundUpdateClassesHandler),this.input_.addEventListener("focus",this.boundFocusHandler),this.input_.addEventListener("blur",this.boundBlurHandler),this.input_.addEventListener("reset",this.boundResetHandler),this.maxRows!==this.Constant_.NO_MAX_ROWS&&(this.boundKeyDownHandler=this.onKeyDown_.bind(this),this.input_.addEventListener("keydown",this.boundKeyDownHandler));var e=this.element_.classList.contains(this.CssClasses_.IS_INVALID);this.updateClasses_(),this.element_.classList.add(this.CssClasses_.IS_UPGRADED),e&&this.element_.classList.add(this.CssClasses_.IS_INVALID),this.input_.hasAttribute("autofocus")&&(this.element_.focus(),this.checkFocus())}},s.register({constructor:L,classAsString:"MaterialTextfield",cssClass:"mdl-js-textfield",widget:!0});var I=function(e){this.element_=e,this.init()};window.MaterialTooltip=I,I.prototype.Constant_={},I.prototype.CssClasses_={IS_ACTIVE:"is-active",BOTTOM:"mdl-tooltip--bottom",LEFT:"mdl-tooltip--left",RIGHT:"mdl-tooltip--right",TOP:"mdl-tooltip--top"},I.prototype.handleMouseEnter_=function(e){var t=e.target.getBoundingClientRect(),s=t.left+t.width/2,i=t.top+t.height/2,n=-1*(this.element_.offsetWidth/2),a=-1*(this.element_.offsetHeight/2);this.element_.classList.contains(this.CssClasses_.LEFT)||this.element_.classList.contains(this.CssClasses_.RIGHT)?(s=t.width/2,i+a<0?(this.element_.style.top="0",this.element_.style.marginTop="0"):(this.element_.style.top=i+"px",this.element_.style.marginTop=a+"px")):s+n<0?(this.element_.style.left="0",this.element_.style.marginLeft="0"):(this.element_.style.left=s+"px",this.element_.style.marginLeft=n+"px"),this.element_.classList.contains(this.CssClasses_.TOP)?this.element_.style.top=t.top-this.element_.offsetHeight-10+"px":this.element_.classList.contains(this.CssClasses_.RIGHT)?this.element_.style.left=t.left+t.width+10+"px":this.element_.classList.contains(this.CssClasses_.LEFT)?this.element_.style.left=t.left-this.element_.offsetWidth-10+"px":this.element_.style.top=t.top+t.height+10+"px",this.element_.classList.add(this.CssClasses_.IS_ACTIVE)},I.prototype.hideTooltip_=function(){this.element_.classList.remove(this.CssClasses_.IS_ACTIVE)},I.prototype.init=function(){if(this.element_){var e=this.element_.getAttribute("for")||this.element_.getAttribute("data-mdl-for");e&&(this.forElement_=document.getElementById(e)),this.forElement_&&(this.forElement_.hasAttribute("tabindex")||this.forElement_.setAttribute("tabindex","0"),this.boundMouseEnterHandler=this.handleMouseEnter_.bind(this),this.boundMouseLeaveAndScrollHandler=this.hideTooltip_.bind(this),this.forElement_.addEventListener("mouseenter",this.boundMouseEnterHandler,!1),this.forElement_.addEventListener("touchend",this.boundMouseEnterHandler,!1),this.forElement_.addEventListener("mouseleave",this.boundMouseLeaveAndScrollHandler,!1),window.addEventListener("scroll",this.boundMouseLeaveAndScrollHandler,!0),window.addEventListener("touchstart",this.boundMouseLeaveAndScrollHandler))}},s.register({constructor:I,classAsString:"MaterialTooltip",cssClass:"mdl-tooltip"});var f=function(e){this.element_=e,this.init()};window.MaterialLayout=f,f.prototype.Constant_={MAX_WIDTH:"(max-width: 1024px)",TAB_SCROLL_PIXELS:100,RESIZE_TIMEOUT:100,MENU_ICON:"&#xE5D2;",CHEVRON_LEFT:"chevron_left",CHEVRON_RIGHT:"chevron_right"},f.prototype.Keycodes_={ENTER:13,ESCAPE:27,SPACE:32},f.prototype.Mode_={STANDARD:0,SEAMED:1,WATERFALL:2,SCROLL:3},f.prototype.CssClasses_={CONTAINER:"mdl-layout__container",HEADER:"mdl-layout__header",DRAWER:"mdl-layout__drawer",CONTENT:"mdl-layout__content",DRAWER_BTN:"mdl-layout__drawer-button",ICON:"material-icons",JS_RIPPLE_EFFECT:"mdl-js-ripple-effect",RIPPLE_CONTAINER:"mdl-layout__tab-ripple-container",RIPPLE:"mdl-ripple",RIPPLE_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events",HEADER_SEAMED:"mdl-layout__header--seamed",HEADER_WATERFALL:"mdl-layout__header--waterfall",HEADER_SCROLL:"mdl-layout__header--scroll",FIXED_HEADER:"mdl-layout--fixed-header",OBFUSCATOR:"mdl-layout__obfuscator",TAB_BAR:"mdl-layout__tab-bar",TAB_CONTAINER:"mdl-layout__tab-bar-container",TAB:"mdl-layout__tab",TAB_BAR_BUTTON:"mdl-layout__tab-bar-button",TAB_BAR_LEFT_BUTTON:"mdl-layout__tab-bar-left-button",TAB_BAR_RIGHT_BUTTON:"mdl-layout__tab-bar-right-button",PANEL:"mdl-layout__tab-panel",HAS_DRAWER:"has-drawer",HAS_TABS:"has-tabs",HAS_SCROLLING_HEADER:"has-scrolling-header",CASTING_SHADOW:"is-casting-shadow",IS_COMPACT:"is-compact",IS_SMALL_SCREEN:"is-small-screen",IS_DRAWER_OPEN:"is-visible",IS_ACTIVE:"is-active",IS_UPGRADED:"is-upgraded",IS_ANIMATING:"is-animating",ON_LARGE_SCREEN:"mdl-layout--large-screen-only",ON_SMALL_SCREEN:"mdl-layout--small-screen-only"},f.prototype.contentScrollHandler_=function(){if(!this.header_.classList.contains(this.CssClasses_.IS_ANIMATING)){var e=!this.element_.classList.contains(this.CssClasses_.IS_SMALL_SCREEN)||this.element_.classList.contains(this.CssClasses_.FIXED_HEADER);this.content_.scrollTop>0&&!this.header_.classList.contains(this.CssClasses_.IS_COMPACT)?(this.header_.classList.add(this.CssClasses_.CASTING_SHADOW),this.header_.classList.add(this.CssClasses_.IS_COMPACT),e&&this.header_.classList.add(this.CssClasses_.IS_ANIMATING)):this.content_.scrollTop<=0&&this.header_.classList.contains(this.CssClasses_.IS_COMPACT)&&(this.header_.classList.remove(this.CssClasses_.CASTING_SHADOW),this.header_.classList.remove(this.CssClasses_.IS_COMPACT),e&&this.header_.classList.add(this.CssClasses_.IS_ANIMATING))}},f.prototype.keyboardEventHandler_=function(e){e.keyCode===this.Keycodes_.ESCAPE&&this.drawer_.classList.contains(this.CssClasses_.IS_DRAWER_OPEN)&&this.toggleDrawer()},f.prototype.screenSizeHandler_=function(){this.screenSizeMediaQuery_.matches?this.element_.classList.add(this.CssClasses_.IS_SMALL_SCREEN):(this.element_.classList.remove(this.CssClasses_.IS_SMALL_SCREEN),this.drawer_&&(this.drawer_.classList.remove(this.CssClasses_.IS_DRAWER_OPEN),this.obfuscator_.classList.remove(this.CssClasses_.IS_DRAWER_OPEN)))},f.prototype.drawerToggleHandler_=function(e){if(e&&"keydown"===e.type){if(e.keyCode!==this.Keycodes_.SPACE&&e.keyCode!==this.Keycodes_.ENTER)return;e.preventDefault()}this.toggleDrawer()},f.prototype.headerTransitionEndHandler_=function(){this.header_.classList.remove(this.CssClasses_.IS_ANIMATING)},f.prototype.headerClickHandler_=function(){this.header_.classList.contains(this.CssClasses_.IS_COMPACT)&&(this.header_.classList.remove(this.CssClasses_.IS_COMPACT),this.header_.classList.add(this.CssClasses_.IS_ANIMATING))},f.prototype.resetTabState_=function(e){for(var t=0;t<e.length;t++)e[t].classList.remove(this.CssClasses_.IS_ACTIVE)},f.prototype.resetPanelState_=function(e){for(var t=0;t<e.length;t++)e[t].classList.remove(this.CssClasses_.IS_ACTIVE)},f.prototype.toggleDrawer=function(){var e=this.element_.querySelector("."+this.CssClasses_.DRAWER_BTN);this.drawer_.classList.toggle(this.CssClasses_.IS_DRAWER_OPEN),this.obfuscator_.classList.toggle(this.CssClasses_.IS_DRAWER_OPEN),this.drawer_.classList.contains(this.CssClasses_.IS_DRAWER_OPEN)?(this.drawer_.setAttribute("aria-hidden","false"),e.setAttribute("aria-expanded","true")):(this.drawer_.setAttribute("aria-hidden","true"),e.setAttribute("aria-expanded","false"))},f.prototype.toggleDrawer=f.prototype.toggleDrawer,f.prototype.init=function(){if(this.element_){var e=document.createElement("div");e.classList.add(this.CssClasses_.CONTAINER);var s=this.element_.querySelector(":focus");this.element_.parentElement.insertBefore(e,this.element_),this.element_.parentElement.removeChild(this.element_),e.appendChild(this.element_),s&&s.focus();for(var i=this.element_.childNodes,n=i.length,a=0;a<n;a++){var l=i[a];l.classList&&l.classList.contains(this.CssClasses_.HEADER)&&(this.header_=l),l.classList&&l.classList.contains(this.CssClasses_.DRAWER)&&(this.drawer_=l),l.classList&&l.classList.contains(this.CssClasses_.CONTENT)&&(this.content_=l)}window.addEventListener("pageshow",function(e){e.persisted&&(this.element_.style.overflowY="hidden",requestAnimationFrame(function(){this.element_.style.overflowY=""}.bind(this)))}.bind(this),!1),this.header_&&(this.tabBar_=this.header_.querySelector("."+this.CssClasses_.TAB_BAR));var o=this.Mode_.STANDARD;if(this.header_&&(this.header_.classList.contains(this.CssClasses_.HEADER_SEAMED)?o=this.Mode_.SEAMED:this.header_.classList.contains(this.CssClasses_.HEADER_WATERFALL)?(o=this.Mode_.WATERFALL,this.header_.addEventListener("transitionend",this.headerTransitionEndHandler_.bind(this)),this.header_.addEventListener("click",this.headerClickHandler_.bind(this))):this.header_.classList.contains(this.CssClasses_.HEADER_SCROLL)&&(o=this.Mode_.SCROLL,e.classList.add(this.CssClasses_.HAS_SCROLLING_HEADER)),o===this.Mode_.STANDARD?(this.header_.classList.add(this.CssClasses_.CASTING_SHADOW),this.tabBar_&&this.tabBar_.classList.add(this.CssClasses_.CASTING_SHADOW)):o===this.Mode_.SEAMED||o===this.Mode_.SCROLL?(this.header_.classList.remove(this.CssClasses_.CASTING_SHADOW),this.tabBar_&&this.tabBar_.classList.remove(this.CssClasses_.CASTING_SHADOW)):o===this.Mode_.WATERFALL&&(this.content_.addEventListener("scroll",this.contentScrollHandler_.bind(this)),this.contentScrollHandler_())),this.drawer_){var r=this.element_.querySelector("."+this.CssClasses_.DRAWER_BTN);if(!r){r=document.createElement("div"),r.setAttribute("aria-expanded","false"),r.setAttribute("role","button"),r.setAttribute("tabindex","0"),r.classList.add(this.CssClasses_.DRAWER_BTN);var _=document.createElement("i");_.classList.add(this.CssClasses_.ICON),_.innerHTML=this.Constant_.MENU_ICON,r.appendChild(_)}this.drawer_.classList.contains(this.CssClasses_.ON_LARGE_SCREEN)?r.classList.add(this.CssClasses_.ON_LARGE_SCREEN):this.drawer_.classList.contains(this.CssClasses_.ON_SMALL_SCREEN)&&r.classList.add(this.CssClasses_.ON_SMALL_SCREEN),r.addEventListener("click",this.drawerToggleHandler_.bind(this)),r.addEventListener("keydown",this.drawerToggleHandler_.bind(this)),this.element_.classList.add(this.CssClasses_.HAS_DRAWER),this.element_.classList.contains(this.CssClasses_.FIXED_HEADER)?this.header_.insertBefore(r,this.header_.firstChild):this.element_.insertBefore(r,this.content_);var d=document.createElement("div");d.classList.add(this.CssClasses_.OBFUSCATOR),this.element_.appendChild(d),d.addEventListener("click",this.drawerToggleHandler_.bind(this)),this.obfuscator_=d,this.drawer_.addEventListener("keydown",this.keyboardEventHandler_.bind(this)),this.drawer_.setAttribute("aria-hidden","true")}if(this.screenSizeMediaQuery_=window.matchMedia(this.Constant_.MAX_WIDTH),this.screenSizeMediaQuery_.addListener(this.screenSizeHandler_.bind(this)),this.screenSizeHandler_(),this.header_&&this.tabBar_){this.element_.classList.add(this.CssClasses_.HAS_TABS);var h=document.createElement("div");h.classList.add(this.CssClasses_.TAB_CONTAINER),this.header_.insertBefore(h,this.tabBar_),this.header_.removeChild(this.tabBar_);var c=document.createElement("div");c.classList.add(this.CssClasses_.TAB_BAR_BUTTON),c.classList.add(this.CssClasses_.TAB_BAR_LEFT_BUTTON);var p=document.createElement("i");p.classList.add(this.CssClasses_.ICON),p.textContent=this.Constant_.CHEVRON_LEFT,c.appendChild(p),c.addEventListener("click",function(){this.tabBar_.scrollLeft-=this.Constant_.TAB_SCROLL_PIXELS}.bind(this));var C=document.createElement("div");C.classList.add(this.CssClasses_.TAB_BAR_BUTTON),C.classList.add(this.CssClasses_.TAB_BAR_RIGHT_BUTTON);var u=document.createElement("i");u.classList.add(this.CssClasses_.ICON),u.textContent=this.Constant_.CHEVRON_RIGHT,C.appendChild(u),C.addEventListener("click",function(){this.tabBar_.scrollLeft+=this.Constant_.TAB_SCROLL_PIXELS}.bind(this)),h.appendChild(c),h.appendChild(this.tabBar_),h.appendChild(C);var E=function(){this.tabBar_.scrollLeft>0?c.classList.add(this.CssClasses_.IS_ACTIVE):c.classList.remove(this.CssClasses_.IS_ACTIVE),this.tabBar_.scrollLeft<this.tabBar_.scrollWidth-this.tabBar_.offsetWidth?C.classList.add(this.CssClasses_.IS_ACTIVE):C.classList.remove(this.CssClasses_.IS_ACTIVE)}.bind(this);this.tabBar_.addEventListener("scroll",E),E();var m=function(){this.resizeTimeoutId_&&clearTimeout(this.resizeTimeoutId_),this.resizeTimeoutId_=setTimeout(function(){E(),this.resizeTimeoutId_=null}.bind(this),this.Constant_.RESIZE_TIMEOUT)}.bind(this);window.addEventListener("resize",m),this.tabBar_.classList.contains(this.CssClasses_.JS_RIPPLE_EFFECT)&&this.tabBar_.classList.add(this.CssClasses_.RIPPLE_IGNORE_EVENTS);for(var L=this.tabBar_.querySelectorAll("."+this.CssClasses_.TAB),I=this.content_.querySelectorAll("."+this.CssClasses_.PANEL),f=0;f<L.length;f++)new t(L[f],L,I,this)}this.element_.classList.add(this.CssClasses_.IS_UPGRADED)}},window.MaterialLayoutTab=t,s.register({constructor:f,classAsString:"MaterialLayout",cssClass:"mdl-js-layout"});var b=function(e){this.element_=e,this.init()};window.MaterialDataTable=b,b.prototype.Constant_={},b.prototype.CssClasses_={DATA_TABLE:"mdl-data-table",SELECTABLE:"mdl-data-table--selectable",SELECT_ELEMENT:"mdl-data-table__select",IS_SELECTED:"is-selected",IS_UPGRADED:"is-upgraded"},b.prototype.selectRow_=function(e,t,s){return t?function(){e.checked?t.classList.add(this.CssClasses_.IS_SELECTED):t.classList.remove(this.CssClasses_.IS_SELECTED)}.bind(this):s?function(){var t,i;if(e.checked)for(t=0;t<s.length;t++)i=s[t].querySelector("td").querySelector(".mdl-checkbox"),i.MaterialCheckbox.check(),s[t].classList.add(this.CssClasses_.IS_SELECTED);else for(t=0;t<s.length;t++)i=s[t].querySelector("td").querySelector(".mdl-checkbox"),i.MaterialCheckbox.uncheck(),s[t].classList.remove(this.CssClasses_.IS_SELECTED)}.bind(this):void 0},b.prototype.createCheckbox_=function(e,t){var i=document.createElement("label"),n=["mdl-checkbox","mdl-js-checkbox","mdl-js-ripple-effect",this.CssClasses_.SELECT_ELEMENT];i.className=n.join(" ");var a=document.createElement("input");return a.type="checkbox",a.classList.add("mdl-checkbox__input"),e?(a.checked=e.classList.contains(this.CssClasses_.IS_SELECTED),a.addEventListener("change",this.selectRow_(a,e))):t&&a.addEventListener("change",this.selectRow_(a,null,t)),i.appendChild(a),s.upgradeElement(i,"MaterialCheckbox"),i},b.prototype.init=function(){if(this.element_){var e=this.element_.querySelector("th"),t=Array.prototype.slice.call(this.element_.querySelectorAll("tbody tr")),s=Array.prototype.slice.call(this.element_.querySelectorAll("tfoot tr")),i=t.concat(s);if(this.element_.classList.contains(this.CssClasses_.SELECTABLE)){var n=document.createElement("th"),a=this.createCheckbox_(null,i);n.appendChild(a),e.parentElement.insertBefore(n,e);for(var l=0;l<i.length;l++){var o=i[l].querySelector("td");if(o){var r=document.createElement("td");if("TBODY"===i[l].parentNode.nodeName.toUpperCase()){var _=this.createCheckbox_(i[l]);r.appendChild(_)}i[l].insertBefore(r,o)}}this.element_.classList.add(this.CssClasses_.IS_UPGRADED)}}},s.register({constructor:b,classAsString:"MaterialDataTable",cssClass:"mdl-js-data-table"});var y=function(e){this.element_=e,this.init()};window.MaterialRipple=y,y.prototype.Constant_={INITIAL_SCALE:"scale(0.0001, 0.0001)",INITIAL_SIZE:"1px",INITIAL_OPACITY:"0.4",FINAL_OPACITY:"0",FINAL_SCALE:""},y.prototype.CssClasses_={RIPPLE_CENTER:"mdl-ripple--center",RIPPLE_EFFECT_IGNORE_EVENTS:"mdl-js-ripple-effect--ignore-events",RIPPLE:"mdl-ripple",IS_ANIMATING:"is-animating",IS_VISIBLE:"is-visible"},y.prototype.downHandler_=function(e){if(!this.rippleElement_.style.width&&!this.rippleElement_.style.height){var t=this.element_.getBoundingClientRect();this.boundHeight=t.height,this.boundWidth=t.width,this.rippleSize_=2*Math.sqrt(t.width*t.width+t.height*t.height)+2,this.rippleElement_.style.width=this.rippleSize_+"px",this.rippleElement_.style.height=this.rippleSize_+"px"}if(this.rippleElement_.classList.add(this.CssClasses_.IS_VISIBLE),"mousedown"===e.type&&this.ignoringMouseDown_)this.ignoringMouseDown_=!1;else{"touchstart"===e.type&&(this.ignoringMouseDown_=!0);var s=this.getFrameCount();if(s>0)return;this.setFrameCount(1);var i,n,a=e.currentTarget.getBoundingClientRect();if(0===e.clientX&&0===e.clientY)i=Math.round(a.width/2),n=Math.round(a.height/2);else{var l=e.clientX?e.clientX:e.touches[0].clientX,o=e.clientY?e.clientY:e.touches[0].clientY;i=Math.round(l-a.left),n=Math.round(o-a.top)}this.setRippleXY(i,n),this.setRippleStyles(!0),window.requestAnimationFrame(this.animFrameHandler.bind(this))}},y.prototype.upHandler_=function(e){e&&2!==e.detail&&window.setTimeout(function(){this.rippleElement_.classList.remove(this.CssClasses_.IS_VISIBLE)}.bind(this),0)},y.prototype.init=function(){if(this.element_){var e=this.element_.classList.contains(this.CssClasses_.RIPPLE_CENTER);this.element_.classList.contains(this.CssClasses_.RIPPLE_EFFECT_IGNORE_EVENTS)||(this.rippleElement_=this.element_.querySelector("."+this.CssClasses_.RIPPLE),this.frameCount_=0,this.rippleSize_=0,this.x_=0,this.y_=0,this.ignoringMouseDown_=!1,this.boundDownHandler=this.downHandler_.bind(this),this.element_.addEventListener("mousedown",this.boundDownHandler),this.element_.addEventListener("touchstart",this.boundDownHandler),this.boundUpHandler=this.upHandler_.bind(this),this.element_.addEventListener("mouseup",this.boundUpHandler),this.element_.addEventListener("mouseleave",this.boundUpHandler),this.element_.addEventListener("touchend",this.boundUpHandler),this.element_.addEventListener("blur",this.boundUpHandler),this.getFrameCount=function(){return this.frameCount_},this.setFrameCount=function(e){this.frameCount_=e},this.getRippleElement=function(){return this.rippleElement_},this.setRippleXY=function(e,t){this.x_=e,this.y_=t},this.setRippleStyles=function(t){if(null!==this.rippleElement_){var s,i,n,a="translate("+this.x_+"px, "+this.y_+"px)";t?(i=this.Constant_.INITIAL_SCALE,n=this.Constant_.INITIAL_SIZE):(i=this.Constant_.FINAL_SCALE,n=this.rippleSize_+"px",e&&(a="translate("+this.boundWidth/2+"px, "+this.boundHeight/2+"px)")),s="translate(-50%, -50%) "+a+i,this.rippleElement_.style.webkitTransform=s,this.rippleElement_.style.msTransform=s,this.rippleElement_.style.transform=s,t?this.rippleElement_.classList.remove(this.CssClasses_.IS_ANIMATING):this.rippleElement_.classList.add(this.CssClasses_.IS_ANIMATING)}},this.animFrameHandler=function(){this.frameCount_-- >0?window.requestAnimationFrame(this.animFrameHandler.bind(this)):this.setRippleStyles(!1)})}},s.register({constructor:y,classAsString:"MaterialRipple",cssClass:"mdl-js-ripple-effect",widget:!1})}();
//# sourceMappingURL=material.min.js.map

"use strict";window.onload=function(){getmdlSelect.init(".getmdl-select"),document.addEventListener("DOMNodeInserted",function(e){e.relatedNode.querySelectorAll(".getmdl-select").length>0&&componentHandler.upgradeDom()},!1)};var getmdlSelect={defaultValue:{width:300},addEventListeners:function(e){var t=e.querySelector("input"),n=e.querySelectorAll("li"),l=e.querySelector(".mdl-js-menu");t.onkeydown=function(e){38!=e.keyCode&&40!=e.keyCode||l.MaterialMenu.show()},l.onkeydown=function(e){13==e.keyCode&&t.focus()},[].forEach.call(n,function(n){n.onclick=function(){if(t.value=n.textContent,e.MaterialTextfield.change(n.textContent),setTimeout(function(){e.MaterialTextfield.updateClasses_()},250),t.dataset.val=n.dataset.val||"","createEvent"in document){var l=document.createEvent("HTMLEvents");l.initEvent("change",!1,!0),t.dispatchEvent(l)}else t.fireEvent("onchange")}})},init:function(e,t){var n=document.querySelectorAll(e);[].forEach.call(n,function(e){getmdlSelect.addEventListeners(e);var n=t?t:e.querySelector(".mdl-menu").offsetWidth?e.querySelector(".mdl-menu").offsetWidth:getmdlSelect.defaultValue.width;e.style.width=n+"px"})}};
//# sourceMappingURL=getmdl-select.min.js.map
/**
 * Simply compares two string version values.
 * 
 * Example:
 * versionCompare('1.1', '1.2') => -1
 * versionCompare('1.1', '1.1') =>  0
 * versionCompare('1.2', '1.1') =>  1
 * versionCompare('2.23.3', '2.22.3') => 1
 * 
 * Returns:
 * -1 = left is LOWER than right
 *  0 = they are equal
 *  1 = left is GREATER = right is LOWER
 *  And FALSE if one of input versions are not valid
 *
 * @function
 * @param {String} left  Version #1
 * @param {String} right Version #2
 * @return {Integer|Boolean}
 * @author Alexey Bass (albass)
 * @since 2011-07-14
 */
versionCompare = function(left, right) {
    if (typeof left + typeof right != 'stringstring')
        return false;
    
    var a = left.split('.')
    ,   b = right.split('.')
    ,   i = 0, len = Math.max(a.length, b.length);
        
    for (; i < len; i++) {
        if ((a[i] && !b[i] && parseInt(a[i]) > 0) || (parseInt(a[i]) > parseInt(b[i]))) {
            return 1;
        } else if ((b[i] && !a[i] && parseInt(b[i]) > 0) || (parseInt(a[i]) < parseInt(b[i]))) {
            return -1;
        }
    }
    
    return 0;
}

/*! foreach.js v1.1.0 | (c) 2014 @toddmotto | https://github.com/toddmotto/foreach */
var forEach=function(t,o,r){if("[object Object]"===Object.prototype.toString.call(t))for(var c in t)Object.prototype.hasOwnProperty.call(t,c)&&o.call(r,t[c],c,t);else for(var e=0,l=t.length;l>e;e++)o.call(r,t[e],e,t)};
// LightRange.js - A simple and lightweight selection, range and caret information library in native JavaScript, with an additional selection save & restore system. - https://github.com/n457/LightRange.js
// Version 2.2.0
// MIT License - Copyright (c) 2015 Bertrand Vignaud-Lerouge / n457 - https://github.com/n457


// https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Classes
class LightRange {

  getSelectionInfo() {
    // Info data that will be returned by the method.
    const data = {};

    // Modern browsers.
    if (window.getSelection) {
      const selection = window.getSelection();

      const bodyScrollTop = document.body.scrollTop;
      const bodyScrollLeft = document.body.scrollLeft;

      // If something is selected.
      if (selection.rangeCount > 0) {
        // With cloneRange() we create a perfect abstract copy of the range. We do not want to modify the real one.
        const range = selection.getRangeAt(0).cloneRange();

        // http://stackoverflow.com/questions/6846230/coordinates-of-selected-text-in-browser-page/6847328#6847328
        // http://stackoverflow.com/questions/12603397/calculate-width-height-of-the-selected-text-javascript/12603796#12603796
        // getBoundingClientRect() gives us correct information about a range but not about a caret (returns 0 as coordinates (here we test a height of 0) ).
        // getClientRects() gives us correct information about a caret but not about a range (returns wrong coordinates).
        let rect = range.getBoundingClientRect();
        if (rect.height === 0) {
          rect = range.getClientRects()[0];
        }

        // If the caret is on an empty line or if the range contains noting or new lines only, 'rect' will be undefined.
        if (rect) {
          data.width = rect.width;
          data.height = rect.height;

          // By default, x and y are calculated at the beginning of the range.
          // We have to add body scroll values
          data.xStart = rect.left + bodyScrollLeft;
          data.yStart = rect.top + bodyScrollTop;
        }

        data.text = selection.toString();

        data.charStart = range.startOffset;
        data.charEnd = range.endOffset;

        // Collapse the range to its end.
        range.collapse(false);
        // We have to update the rect with getClientRects() because the range became a caret.
        rect = range.getClientRects()[0];

        if (rect) {
          data.xEnd = rect.left + bodyScrollLeft;
          data.yEnd = rect.top + bodyScrollTop;
        }

      }
    }

    // IE 8 and other old browsers.
    else if (document.selection) {
      const selection = document.selection;
      const range = selection.createRange();

      const bodyScrollTop = document.documentElement.scrollTop;
      const bodyScrollLeft = document.documentElement.scrollLeft;

      data.width = range.boundingWidth;
      data.height = range.boundingHeight;

      data.xStart = range.boundingLeft + bodyScrollLeft;
      data.yStart = range.boundingTop + bodyScrollTop;

      data.text = range.text;

      // startOffset and endOffset for IE 8 and below are not natively supported and are not so easy to implement.

      range.collapse(false);

      data.xEnd = range.boundingLeft + bodyScrollLeft;
      data.yEnd = range.boundingTop + bodyScrollTop;
    }

    // The browser doesn't support the feature
    else {
      return null;
    }

    if (data.text) {
      // From Countable JS lib : https://github.com/RadLikeWhoa/Countable
      // https://github.com/RadLikeWhoa/Countable/blob/master/Countable.js#L210
      data.characters = data.text.replace(/\s/g, '').length;
      data.charactersAll = data.text.replace(/[\n\r]/g, '').length;
    } else {
      data.characters = 0;
      data.charactersAll = 0;
    }


    // Some properties can be undefined. This is fine, it's easier to handle special cases.
    return data;
  }



  // http://stackoverflow.com/questions/4687808/contenteditable-selected-text-save-and-restore/4690057#4690057
  // http://jsfiddle.net/timdown/cCAWC/3/
  saveSelection() {
    // Modern browsers.
    if (window.getSelection) {
      const selection = window.getSelection();
      if (selection.getRangeAt && selection.rangeCount) {
        return selection.getRangeAt(0);
      }
    }
    // IE 8 and other old browsers.
    else if (document.selection && document.selection.createRange) {
      return document.selection.createRange();
    }
    // The browser doesn't support the feature
    else {
      return null;
    }
  }


  restoreSelection(rangeToRestore) {
    if (rangeToRestore) {
      // Modern browsers.
      if (window.getSelection) {
        const selection = window.getSelection();
        selection.removeAllRanges();
        selection.addRange(rangeToRestore);
      }
      // IE 8 and other old browsers.
      else if (document.selection && rangeToRestore.select) {
        rangeToRestore.select();
      }
      // The browser doesn't support the feature
      else {
        return null;
      }

      return rangeToRestore;
    }
  }


}

const lightrange = new LightRange();

!function(e){"use strict";"function"==typeof define&&define.amd?define([],function(){return e(window,document)}):"undefined"!=typeof exports?module.exports=e(window,document):window.wysiwyg=e(window,document)}(function(e,t){"use strict";var n=function(e,t,n){var r;return function(){if(r){if(!n)return;clearTimeout(r)}var o=this,i=arguments;r=setTimeout(function(){r=null,e.apply(o,i)},t)}},r=function(t,n,r,o){t.addEventListener?t.addEventListener(n,r,!!o):t.attachEvent?t.attachEvent("on"+n,r):t!=e&&(t["on"+n]=r)},o=function(t,n,r,o){t.removeEventListener?t.removeEventListener(n,r,!!o):t.detachEvent?t.detachEvent("on"+n,r):t!=e&&(t["on"+n]=null)},i=function(e,n,r,o){if(t.createEvent){var i=t.createEvent("Event");i.initEvent(n,void 0!==r?r:!0,void 0!==o?o:!1),e.dispatchEvent(i)}else if(t.createEventObject){var i=t.createEventObject();e.fireEvent("on"+n,i)}else"function"==typeof e["on"+n]&&e["on"+n]()},a=function(e){return e.preventDefault?e.preventDefault():e.returnValue=!1,e.stopPropagation?e.stopPropagation():e.cancelBubble=!0,!1},l="undefined"!=typeof Node?Node.ELEMENT_NODE:1,u="undefined"!=typeof Node?Node.TEXT_NODE:3,f=function(e,t){for(var n=t;n;){if(n===e)return!0;n=n.parentNode}return!1},c=function(e,t){if(e.firstChild)return e.firstChild;for(;e;){if(e==t)return null;if(e.nextSibling)return e.nextSibling;e=e.parentNode}return null},s=function(n){if(e.getSelection){var r=e.getSelection();if(r.rangeCount>0)return r.getRangeAt(0)}else if(t.selection){var r=t.selection;return r.createRange()}return null},d=function(n,r){if(r)if(e.getSelection){var o=e.getSelection();o.removeAllRanges(),o.addRange(r)}else t.selection&&r.select()},p=function(){if(e.getSelection){var n=e.getSelection();if(!n.rangeCount)return!1;var r=n.getRangeAt(0).cloneRange();if(r.getBoundingClientRect){var o=r.getBoundingClientRect();if(o&&o.left&&o.top&&o.right&&o.bottom)return{left:parseInt(o.left),top:parseInt(o.top),width:parseInt(o.right-o.left),height:parseInt(o.bottom-o.top)};for(var i=r.getClientRects?r.getClientRects():[],a=0;a<i.length;++a){var o=i[a];if(o.left&&o.top&&o.right&&o.bottom)return{left:parseInt(o.left),top:parseInt(o.top),width:parseInt(o.right-o.left),height:parseInt(o.bottom-o.top)}}}}else if(t.selection){var n=t.selection;if("Control"!=n.type){var r=n.createRange();if(r.boundingLeft||r.boundingTop||r.boundingWidth||r.boundingHeight)return{left:r.boundingLeft,top:r.boundingTop,width:r.boundingWidth,height:r.boundingHeight}}}return!1},g=function(n){if(e.getSelection){var r=e.getSelection();return!!r.isCollapsed}if(t.selection){var r=t.selection;if("Text"==r.type){var o=t.selection.createRange(),i=t.body.createTextRange();return i.moveToElementText(n),i.setEndPoint("EndToStart",o),0==o.htmlText.length}if("Control"==r.type)return!1}return!0},v=function(n){if(e.getSelection){var r=e.getSelection();if(!r.rangeCount)return[];for(var o=[],i=0;i<r.rangeCount;++i)for(var a=r.getRangeAt(i),u=a.startContainer,s=a.endContainer;u;){if(u!=n){var d=!1;if(r.containsNode)d=r.containsNode(u,!0);else{var p=t.createRange();p.selectNodeContents(u);for(var i=0;i<r.rangeCount;++i){var a=r.getRangeAt(i);if(a.compareBoundaryPoints(a.END_TO_START,p)>=0&&a.compareBoundaryPoints(a.START_TO_END,p)<=0){d=!0;break}}}d&&o.push(u)}u=c(u,u==s?s:n)}return 0==o.length&&f(n,r.focusNode)&&r.focusNode!=n&&o.push(r.focusNode),o}if(t.selection){var r=t.selection;if("Text"==r.type){for(var o=[],g=r.createRangeCollection(),i=0;i<g.length;++i)for(var a=g[i],v=a.parentElement(),u=v;u;){var p=a.duplicate();if(p.moveToElementText(u.nodeType!=l?u.parentNode:u),p.compareEndPoints("EndToStart",a)>=0&&p.compareEndPoints("StartToEnd",a)<=0){for(var h=!1,m=0;m<o.length;++m)if(o[m]===u){h=!0;break}h||o.push(u)}u=c(u,v)}return 0==o.length&&f(n,t.activeElement)&&t.activeElement!=n&&o.push(t.activeElement),o}if("Control"==r.type){for(var o=[],a=r.createRange(),i=0;i<a.length;++i)o.push(a(i));return o}}return[]},h=function(){if(e.getSelection){var n=e.getSelection();if(!n.isCollapsed)try{n.collapseToEnd()}catch(r){}}else if(t.selection){var n=t.selection;if("Control"!=n.type){var o=n.createRange();o.collapse(!1),o.select()}}},m=function(n,r,o){if(e.getSelection){var i=e.getSelection();if(i.modify){for(var a=0;r>a;++a)i.modify("extend","backward","character");for(var a=0;o>a;++a)i.modify("extend","forward","character")}else{var l=i.getRangeAt(0);l.setStart(l.startContainer,l.startOffset-r),l.setEnd(l.endContainer,l.endOffset+o),i.removeAllRanges(),i.addRange(l)}}else if(t.selection){var i=t.selection;if("Control"!=i.type){var l=i.createRange();l.collapse(!0),l.moveStart("character",-r),l.moveEnd("character",o),l.select()}}},y=function(n){if(g(n))return null;if(e.getSelection){var r=e.getSelection();if(r.rangeCount){for(var o=t.createElement("div"),i=r.rangeCount,a=0;i>a;++a){var l=r.getRangeAt(a).cloneContents();o.appendChild(l)}return o.innerHTML}}else if(t.selection){var r=t.selection;if("Text"==r.type){var u=r.createRange();return u.htmlText}}return null},T=function(n,r){if(e.getSelection){var o=e.getSelection();if(f(n,o.anchorNode)&&f(n,o.focusNode))return!0;if(!r)return!1;var i=t.createRange();i.selectNodeContents(n),i.collapse(!1),o.removeAllRanges(),o.addRange(i)}else if(t.selection){var o=t.selection;if("Control"==o.type){var i=o.createRange();if(0!=i.length&&f(n,i(0)))return!0}else{var a=t.body.createTextRange();a.moveToElementText(n);var i=o.createRange();if(a.inRange(i))return!0}if(!r)return!1;var i=t.body.createTextRange();i.moveToElementText(n),i.setEndPoint("StartToEnd",i),i.select()}return!0},b=function(n,r){if(e.getSelection){var o=e.getSelection();if(o.getRangeAt&&o.rangeCount){var i=o.getRangeAt(0),a=t.createElement("div");a.innerHTML=r;for(var l,u,c=t.createDocumentFragment();l=a.firstChild;)u=c.appendChild(l);f(n,i.commonAncestorContainer)?(i.deleteContents(),i.insertNode(c)):n.appendChild(c),u&&(i=i.cloneRange(),i.setStartAfter(u),i.collapse(!0),o.removeAllRanges(),o.addRange(i))}}else if(t.selection){var o=t.selection;if("Control"!=o.type){var s=o.createRange();s.collapse(!0);var i=o.createRange();if(f(n,i.parentElement()))i.pasteHTML(r);else{var d=t.body.createTextRange();d.moveToElementText(n),d.collapse(!1),d.select(),d.pasteHTML(r)}i=o.createRange(),i.setEndPoint("StartToEnd",s),i.select()}}},E=function(E){E=E||{};var C=E.element||null;"string"==typeof C&&(C=t.getElementById(C));var R=E.contenteditable||null;"string"==typeof R&&(R=t.getElementById(R));var S=E.onKeyDown||null,L=E.onKeyPress||null,N=E.onKeyUp||null,A=E.onSelection||null,x=E.onPlaceholder||null,M=E.onOpenpopup||null,w=E.onClosepopup||null,I=E.hijackContextmenu||!1,H=E.readOnly||!1,k="TEXTAREA"==C.nodeName||"INPUT"==C.nodeName;if(k){var O="contentEditable"in t.body;if(O){var P=navigator.userAgent.match(/(?:iPad|iPhone|Android).* AppleWebKit\/([^ ]+)/);P&&420<=parseInt(P[1])&&parseInt(P[1])<534&&(O=!1)}if(!O){var D=C,B=function(e){return e.replace(/<br[ \/]*>\n?/gi,"<br>\n")};D.value=B(D.value);var j=function(){return this},K=function(){return null};return{legacy:!0,getElement:function(){return D},getHTML:function(){return D.value},setHTML:function(e){return D.value=B(e),this},getSelectedHTML:K,sync:j,readOnly:function(e){return void 0===e?D.hasAttribute?D.hasAttribute("readonly"):!!D.getAttribute("readonly"):(e?D.setAttribute("readonly","readonly"):D.removeAttribute("readonly"),this)},collapseSelection:j,expandSelection:j,openPopup:K,closePopup:j,removeFormat:j,bold:j,italic:j,underline:j,strikethrough:j,forecolor:j,highlight:j,fontName:j,fontSize:j,subscript:j,superscript:j,align:j,format:j,indent:j,insertLink:j,insertImage:j,insertHTML:j,insertList:j}}}var D=null,X=null;if(k)if(D=C,D.style.display="none",R)X=R;else{X=t.createElement("DIV"),X.innerHTML=D.value||"";var W=D.parentNode,Y=D.nextSibling;Y?W.insertBefore(X,Y):W.appendChild(X)}else X=C;H||X.setAttribute("contentEditable","true");var _,F=t.all&&(!t.documentMode||t.documentMode<=8)?t:e,V=null;if(k){var q=X.innerHTML;V=function(){var e=X.innerHTML;e!=q&&(D.value=e,q=e,i(D,"change",!1))};var z=D.form;z&&r(z,"reset",function(){X.innerHTML="",V(),_(!0)})}var U;if(x){var G=!1;U=function(){for(var e=!0,t=X;t;)if(t=c(t,X)){if(t.nodeType==l){if("IMG"==t.nodeName){e=!1;break}}else if(t.nodeType==u){var n=t.nodeValue;if(n&&-1!=n.search(/[^\s]/)){e=!1;break}}}else;G!=e&&(x(e),G=e)},U()}var J=null,Q=null,Z=null;A&&(Q=function(t,n,r){var o=g(X),i=v(X),a=null===t||null===n?null:{left:t,top:n,width:0,height:0},u=p();if(u&&(a=u),a){if(X.getBoundingClientRect){var f=X.getBoundingClientRect();a.left-=parseInt(f.left),a.top-=parseInt(f.top)}else{var c=X,s=0,d=0,h=!1;do s+=c.offsetLeft?parseInt(c.offsetLeft):0,d+=c.offsetTop?parseInt(c.offsetTop):0,"fixed"==c.style.position&&(h=!0);while(c=c.offsetParent);a.left-=s-(h?0:e.pageXOffset),a.top-=d-(h?0:e.pageYOffset)}a.left<0&&(a.left=0),a.top<0&&(a.top=0),a.width>X.offsetWidth&&(a.width=X.offsetWidth),a.height>X.offsetHeight&&(a.height=X.offsetHeight)}else if(i.length)for(var m=0;m<i.length;++m){var c=i[m];if(c.nodeType==l){a={left:c.offsetLeft,top:c.offsetTop,width:c.offsetWidth,height:c.offsetHeight};break}}A(o,a,i,r)},Z=n(Q,1));var $=null,ee=function(t){if(!t)var t=e.event;var n=t.target||t.srcElement;n.nodeType==u&&(n=n.parentNode),f($,n)||ne()},te=function(){if($)return $;r(F,"mousedown",ee,!0),$=t.createElement("DIV");var e=X.parentNode,n=X.nextSibling;return n?e.insertBefore($,n):e.appendChild($),M&&M(),$},ne=function(){$&&($.parentNode.removeChild($),$=null,o(F,"mousedown",ee,!0),w&&w())};r(X,"focus",function(){D&&i(D,"focus",!1)}),r(X,"blur",function(){V&&V(),D&&i(D,"blur",!1)});var re=null;if(U||V){var oe=V?n(V,250,!0):null,ie=function(e){U&&U(),oe&&oe()};re=n(ie,1),r(X,"input",re),r(X,"DOMNodeInserted",re),r(X,"DOMNodeRemoved",re),r(X,"DOMSubtreeModified",re),r(X,"DOMCharacterDataModified",re),r(X,"propertychange",re),r(X,"textInput",re),r(X,"paste",re),r(X,"cut",re),r(X,"drop",re)}var ae=function(t,n){if(!t)var t=e.event;var r=t.which||t.keyCode,o=String.fromCharCode(r||t.charCode),i=t.shiftKey||!1,l=t.altKey||!1,u=t.ctrlKey||!1,f=t.metaKey||!1;if(1==n){if(S&&S(r,o,i,l,u,f)===!1)return a(t)}else if(2==n){if(L&&L(r,o,i,l,u,f)===!1)return a(t)}else if(3==n&&N&&N(r,o,i,l,u,f)===!1)return a(t);if(2!=n&&3!=n||(J=null,Z&&Z(null,null,!1)),2==n&&re)switch(r){case 33:case 34:case 35:case 36:case 37:case 38:case 39:case 40:break;default:re()}};r(X,"keydown",function(e){return ae(e,1)}),r(X,"keypress",function(e){return ae(e,2)}),r(X,"keyup",function(e){return ae(e,3)});var le=function(t,n){if(!t)var t=e.event;var r=null,i=null;t.clientX&&t.clientY?(r=t.clientX,i=t.clientY):t.pageX&&t.pageY&&(r=t.pageX-e.pageXOffset,i=t.pageY-e.pageYOffset),t.which&&3==t.which?n=!0:t.button&&2==t.button&&(n=!0),o(F,"mouseup",le),J=null,!I&&n||Z&&Z(r,i,n)};r(X,"mousedown",function(e){o(F,"mouseup",le),r(F,"mouseup",le)}),r(X,"mouseup",function(e){le(e),re&&re()}),r(X,"dblclick",function(e){le(e)}),r(X,"selectionchange",function(e){le(e)}),I&&r(X,"contextmenu",function(e){return le(e,!0),a(e)});var ue=function(n,r,o){if(d(X,J),X.focus(),!T(X,o))return!1;if(e.getSelection)try{return t.queryCommandSupported&&!t.queryCommandSupported(n)?!1:t.execCommand(n,!1,r)}catch(i){}else if(t.selection){var a=t.selection;if("None"!=a.type){var l=a.createRange();try{return l.queryCommandEnabled(n)?l.execCommand(n,!1,r):!1}catch(i){}}}return!1},fe=null,ce=function(){(t.all||e.MSInputMethodContext)&&(fe=t.createElement("DIV"),X.appendChild(fe))};return _=function(e){fe&&(X.removeChild(fe),fe=null),re&&re(),e?(h(),J=null):J&&(J=s(X))},{getElement:function(){return X},getHTML:function(){return X.innerHTML},setHTML:function(e){return X.innerHTML=e||"<br>",_(!0),this},getSelectedHTML:function(){return d(X,J),T(X)?y(X):null},sync:function(){return V&&V(),this},readOnly:function(e){return void 0===e?X.hasAttribute?!X.hasAttribute("contentEditable"):!X.getAttribute("contentEditable"):(e?X.removeAttribute("contentEditable"):X.setAttribute("contentEditable","true"),this)},collapseSelection:function(){return h(),J=null,this},expandSelection:function(e,t){return d(X,J),T(X)?(m(X,e,t),J=s(X),this):this},openPopup:function(){return J||(J=s(X)),te()},closePopup:function(){return ne(),this},removeFormat:function(){return ue("removeFormat"),ue("unlink"),_(),this},bold:function(){return ue("bold"),_(),this},italic:function(){return ue("italic"),_(),this},underline:function(){return ue("underline"),_(),this},strikethrough:function(){return ue("strikeThrough"),_(),this},forecolor:function(e){return ue("foreColor",e),_(),this},highlight:function(e){return ue("hiliteColor",e)||ue("backColor",e),_(),this},fontName:function(e){return ue("fontName",e),_(),this},fontSize:function(e){return ue("fontSize",e),_(),this},subscript:function(){return ue("subscript"),_(),this},superscript:function(){return ue("superscript"),_(),this},align:function(e){return ce(),"left"==e?ue("justifyLeft"):"center"==e?ue("justifyCenter"):"right"==e?ue("justifyRight"):"justify"==e&&ue("justifyFull"),_(),this},format:function(e){return ce(),ue("formatBlock",e),_(),this},indent:function(e){return ce(),ue(e?"outdent":"indent"),_(),this},insertLink:function(e){return ue("createLink",e),_(!0),this},insertImage:function(e){return ue("insertImage",e,!0),_(!0),this},insertHTML:function(e){return ue("insertHTML",e,!0)||(d(X,J),T(X,!0),b(X,e)),_(!0),this},insertList:function(e){return ce(),ue(e?"insertOrderedList":"insertUnorderedList"),_(),this}}};return E});

/*! Sortable 1.4.2 - MIT | git://github.com/rubaxa/Sortable.git */
!function(a){"use strict";"function"==typeof define&&define.amd?define(a):"undefined"!=typeof module&&"undefined"!=typeof module.exports?window.Sortable=a():"undefined"!=typeof Package?Sortable=a():window.Sortable=a()}(function(){"use strict";function a(a,b){if(!a||!a.nodeType||1!==a.nodeType)throw"Sortable: `el` must be HTMLElement, and not "+{}.toString.call(a);this.el=a,this.options=b=t({},b),a[Q]=this;var c={group:Math.random(),sort:!0,disabled:!1,store:null,handle:null,scroll:!0,scrollSensitivity:30,scrollSpeed:10,draggable:/[uo]l/i.test(a.nodeName)?"li":">*",ghostClass:"sortable-ghost",chosenClass:"sortable-chosen",dragClass:"sortable-drag",ignore:"a, img",filter:null,animation:0,setData:function(a,b){a.setData("Text",b.textContent)},dropBubble:!1,dragoverBubble:!1,dataIdAttr:"data-id",delay:0,forceFallback:!1,fallbackClass:"sortable-fallback",fallbackOnBody:!1,fallbackTolerance:0,fallbackOffset:{x:0,y:0}};for(var d in c)!(d in b)&&(b[d]=c[d]);ba(b);for(var e in this)"_"===e.charAt(0)&&"function"==typeof this[e]&&(this[e]=this[e].bind(this));this.nativeDraggable=!b.forceFallback&&W,f(a,"mousedown",this._onTapStart),f(a,"touchstart",this._onTapStart),this.nativeDraggable&&(f(a,"dragover",this),f(a,"dragenter",this)),_.push(this._onDragOver),b.store&&this.sort(b.store.get(this))}function b(a){y&&y.state!==a&&(i(y,"display",a?"none":""),!a&&y.state&&z.insertBefore(y,v),y.state=a)}function c(a,b,c){if(a){c=c||S;do if(">*"===b&&a.parentNode===c||r(a,b))return a;while(a=d(a))}return null}function d(a){var b=a.host;return b&&b.nodeType?b:a.parentNode}function e(a){a.dataTransfer&&(a.dataTransfer.dropEffect="move"),a.preventDefault()}function f(a,b,c){a.addEventListener(b,c,!1)}function g(a,b,c){a.removeEventListener(b,c,!1)}function h(a,b,c){if(a)if(a.classList)a.classList[c?"add":"remove"](b);else{var d=(" "+a.className+" ").replace(P," ").replace(" "+b+" "," ");a.className=(d+(c?" "+b:"")).replace(P," ")}}function i(a,b,c){var d=a&&a.style;if(d){if(void 0===c)return S.defaultView&&S.defaultView.getComputedStyle?c=S.defaultView.getComputedStyle(a,""):a.currentStyle&&(c=a.currentStyle),void 0===b?c:c[b];b in d||(b="-webkit-"+b),d[b]=c+("string"==typeof c?"":"px")}}function j(a,b,c){if(a){var d=a.getElementsByTagName(b),e=0,f=d.length;if(c)for(;e<f;e++)c(d[e],e);return d}return[]}function k(a,b,c,d,e,f,g){a=a||b[Q];var h=S.createEvent("Event"),i=a.options,j="on"+c.charAt(0).toUpperCase()+c.substr(1);h.initEvent(c,!0,!0),h.to=b,h.from=e||b,h.item=d||b,h.clone=y,h.oldIndex=f,h.newIndex=g,b.dispatchEvent(h),i[j]&&i[j].call(a,h)}function l(a,b,c,d,e,f,g){var h,i,j=a[Q],k=j.options.onMove;return h=S.createEvent("Event"),h.initEvent("move",!0,!0),h.to=b,h.from=a,h.dragged=c,h.draggedRect=d,h.related=e||b,h.relatedRect=f||b.getBoundingClientRect(),a.dispatchEvent(h),k&&(i=k.call(j,h,g)),i}function m(a){a.draggable=!1}function n(){Y=!1}function o(a,b){var c=a.lastElementChild,d=c.getBoundingClientRect();return(b.clientY-(d.top+d.height)>5||b.clientX-(d.right+d.width)>5)&&c}function p(a){for(var b=a.tagName+a.className+a.src+a.href+a.textContent,c=b.length,d=0;c--;)d+=b.charCodeAt(c);return d.toString(36)}function q(a,b){var c=0;if(!a||!a.parentNode)return-1;for(;a&&(a=a.previousElementSibling);)"TEMPLATE"===a.nodeName.toUpperCase()||">*"!==b&&!r(a,b)||c++;return c}function r(a,b){if(a){b=b.split(".");var c=b.shift().toUpperCase(),d=new RegExp("\\s("+b.join("|")+")(?=\\s)","g");return!(""!==c&&a.nodeName.toUpperCase()!=c||b.length&&((" "+a.className+" ").match(d)||[]).length!=b.length)}return!1}function s(a,b){var c,d;return function(){void 0===c&&(c=arguments,d=this,setTimeout(function(){1===c.length?a.call(d,c[0]):a.apply(d,c),c=void 0},b))}}function t(a,b){if(a&&b)for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c]);return a}function u(a){return U?U(a).clone(!0)[0]:V&&V.dom?V.dom(a).cloneNode(!0):a.cloneNode(!0)}if("undefined"==typeof window||!window.document)return function(){throw new Error("Sortable.js requires a window with a document")};var v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O={},P=/\s+/g,Q="Sortable"+(new Date).getTime(),R=window,S=R.document,T=R.parseInt,U=R.jQuery||R.Zepto,V=R.Polymer,W=!!("draggable"in S.createElement("div")),X=function(a){return!navigator.userAgent.match(/Trident.*rv[ :]?11\./)&&(a=S.createElement("x"),a.style.cssText="pointer-events:auto","auto"===a.style.pointerEvents)}(),Y=!1,Z=Math.abs,$=Math.min,_=([].slice,[]),aa=s(function(a,b,c){if(c&&b.scroll){var d,e,f,g,h,i,j=b.scrollSensitivity,k=b.scrollSpeed,l=a.clientX,m=a.clientY,n=window.innerWidth,o=window.innerHeight;if(C!==c&&(B=b.scroll,C=c,D=b.scrollFn,B===!0)){B=c;do if(B.offsetWidth<B.scrollWidth||B.offsetHeight<B.scrollHeight)break;while(B=B.parentNode)}B&&(d=B,e=B.getBoundingClientRect(),f=(Z(e.right-l)<=j)-(Z(e.left-l)<=j),g=(Z(e.bottom-m)<=j)-(Z(e.top-m)<=j)),f||g||(f=(n-l<=j)-(l<=j),g=(o-m<=j)-(m<=j),(f||g)&&(d=R)),O.vx===f&&O.vy===g&&O.el===d||(O.el=d,O.vx=f,O.vy=g,clearInterval(O.pid),d&&(O.pid=setInterval(function(){return i=g?g*k:0,h=f?f*k:0,"function"==typeof D?D.call(_this,h,i,a):void(d===R?R.scrollTo(R.pageXOffset+h,R.pageYOffset+i):(d.scrollTop+=i,d.scrollLeft+=h))},24)))}},30),ba=function(a){function b(a,b){return void 0!==a&&a!==!0||(a=c.name),"function"==typeof a?a:function(c,d){var e=d.options.group.name;return b?a:a&&(a.join?a.indexOf(e)>-1:e==a)}}var c={},d=a.group;d&&"object"==typeof d||(d={name:d}),c.name=d.name,c.checkPull=b(d.pull,!0),c.checkPut=b(d.put),a.group=c};return a.prototype={constructor:a,_onTapStart:function(a){var b,d=this,e=this.el,f=this.options,g=a.type,h=a.touches&&a.touches[0],i=(h||a).target,j=a.target.shadowRoot&&a.path[0]||i,l=f.filter;if(!v&&!("mousedown"===g&&0!==a.button||f.disabled)&&(!f.handle||c(j,f.handle,e))&&(i=c(i,f.draggable,e))){if(b=q(i,f.draggable),"function"==typeof l){if(l.call(this,a,i,this))return k(d,j,"filter",i,e,b),void a.preventDefault()}else if(l&&(l=l.split(",").some(function(a){if(a=c(j,a.trim(),e))return k(d,a,"filter",i,e,b),!0})))return void a.preventDefault();this._prepareDragStart(a,h,i,b)}},_prepareDragStart:function(a,b,c,d){var e,g=this,i=g.el,l=g.options,n=i.ownerDocument;c&&!v&&c.parentNode===i&&(L=a,z=i,v=c,w=v.parentNode,A=v.nextSibling,J=l.group,H=d,this._lastX=(b||a).clientX,this._lastY=(b||a).clientY,v.style["will-change"]="transform",e=function(){g._disableDelayedDrag(),v.draggable=g.nativeDraggable,h(v,l.chosenClass,!0),g._triggerDragStart(b),k(g,z,"choose",v,z,H)},l.ignore.split(",").forEach(function(a){j(v,a.trim(),m)}),f(n,"mouseup",g._onDrop),f(n,"touchend",g._onDrop),f(n,"touchcancel",g._onDrop),l.delay?(f(n,"mouseup",g._disableDelayedDrag),f(n,"touchend",g._disableDelayedDrag),f(n,"touchcancel",g._disableDelayedDrag),f(n,"mousemove",g._disableDelayedDrag),f(n,"touchmove",g._disableDelayedDrag),g._dragStartTimer=setTimeout(e,l.delay)):e())},_disableDelayedDrag:function(){var a=this.el.ownerDocument;clearTimeout(this._dragStartTimer),g(a,"mouseup",this._disableDelayedDrag),g(a,"touchend",this._disableDelayedDrag),g(a,"touchcancel",this._disableDelayedDrag),g(a,"mousemove",this._disableDelayedDrag),g(a,"touchmove",this._disableDelayedDrag)},_triggerDragStart:function(a){a?(L={target:v,clientX:a.clientX,clientY:a.clientY},this._onDragStart(L,"touch")):this.nativeDraggable?(f(v,"dragend",this),f(z,"dragstart",this._onDragStart)):this._onDragStart(L,!0);try{S.selection?setTimeout(function(){S.selection.empty()}):window.getSelection().removeAllRanges()}catch(a){}},_dragStarted:function(){if(z&&v){var b=this.options;h(v,b.ghostClass,!0),h(v,b.dragClass,!1),a.active=this,k(this,z,"start",v,z,H)}},_emulateDragOver:function(){if(M){if(this._lastX===M.clientX&&this._lastY===M.clientY)return;this._lastX=M.clientX,this._lastY=M.clientY,X||i(x,"display","none");var a=S.elementFromPoint(M.clientX,M.clientY),b=a,c=_.length;if(b)do{if(b[Q]){for(;c--;)_[c]({clientX:M.clientX,clientY:M.clientY,target:a,rootEl:b});break}a=b}while(b=b.parentNode);X||i(x,"display","")}},_onTouchMove:function(b){if(L){var c=this.options,d=c.fallbackTolerance,e=c.fallbackOffset,f=b.touches?b.touches[0]:b,g=f.clientX-L.clientX+e.x,h=f.clientY-L.clientY+e.y,j=b.touches?"translate3d("+g+"px,"+h+"px,0)":"translate("+g+"px,"+h+"px)";if(!a.active){if(d&&$(Z(f.clientX-this._lastX),Z(f.clientY-this._lastY))<d)return;this._dragStarted()}this._appendGhost(),N=!0,M=f,i(x,"webkitTransform",j),i(x,"mozTransform",j),i(x,"msTransform",j),i(x,"transform",j),b.preventDefault()}},_appendGhost:function(){if(!x){var a,b=v.getBoundingClientRect(),c=i(v),d=this.options;x=v.cloneNode(!0),h(x,d.ghostClass,!1),h(x,d.fallbackClass,!0),h(x,d.dragClass,!0),i(x,"top",b.top-T(c.marginTop,10)),i(x,"left",b.left-T(c.marginLeft,10)),i(x,"width",b.width),i(x,"height",b.height),i(x,"opacity","0.8"),i(x,"position","fixed"),i(x,"zIndex","100000"),i(x,"pointerEvents","none"),d.fallbackOnBody&&S.body.appendChild(x)||z.appendChild(x),a=x.getBoundingClientRect(),i(x,"width",2*b.width-a.width),i(x,"height",2*b.height-a.height)}},_onDragStart:function(a,b){var c=a.dataTransfer,d=this.options;this._offUpEvents(),"clone"==J.checkPull(this,this,v,a)&&(y=u(v),i(y,"display","none"),z.insertBefore(y,v),k(this,z,"clone",v)),h(v,d.dragClass,!0),b?("touch"===b?(f(S,"touchmove",this._onTouchMove),f(S,"touchend",this._onDrop),f(S,"touchcancel",this._onDrop)):(f(S,"mousemove",this._onTouchMove),f(S,"mouseup",this._onDrop)),this._loopId=setInterval(this._emulateDragOver,50)):(c&&(c.effectAllowed="move",d.setData&&d.setData.call(this,c,v)),f(S,"drop",this),setTimeout(this._dragStarted,0))},_onDragOver:function(d){var e,f,g,h,j=this.el,k=this.options,m=k.group,p=a.active,q=J===m,r=k.sort;if(void 0!==d.preventDefault&&(d.preventDefault(),!k.dragoverBubble&&d.stopPropagation()),N=!0,J&&!k.disabled&&(q?r||(h=!z.contains(v)):K===this||J.checkPull(this,p,v,d)&&m.checkPut(this,p,v,d))&&(void 0===d.rootEl||d.rootEl===this.el)){if(aa(d,k,this.el),Y)return;if(e=c(d.target,k.draggable,j),f=v.getBoundingClientRect(),K=this,h)return b(!0),w=z,void(y||A?z.insertBefore(v,y||A):r||z.appendChild(v));if(0===j.children.length||j.children[0]===x||j===d.target&&(e=o(j,d))){if(e){if(e.animated)return;g=e.getBoundingClientRect()}b(q),l(z,j,v,f,e,g,d)!==!1&&(v.contains(j)||(j.appendChild(v),w=j),this._animate(f,v),e&&this._animate(g,e))}else if(e&&!e.animated&&e!==v&&void 0!==e.parentNode[Q]){E!==e&&(E=e,F=i(e),G=i(e.parentNode)),g=e.getBoundingClientRect();var s,t=g.right-g.left,u=g.bottom-g.top,B=/left|right|inline/.test(F.cssFloat+F.display)||"flex"==G.display&&0===G["flex-direction"].indexOf("row"),C=e.offsetWidth>v.offsetWidth,D=e.offsetHeight>v.offsetHeight,H=(B?(d.clientX-g.left)/t:(d.clientY-g.top)/u)>.5,I=e.nextElementSibling,L=l(z,j,v,f,e,g,d);if(L!==!1){if(Y=!0,setTimeout(n,30),b(q),1===L||L===-1)s=1===L;else if(B){var M=v.offsetTop,O=e.offsetTop;s=M===O?e.previousElementSibling===v&&!C||H&&C:e.previousElementSibling===v||v.previousElementSibling===e?(d.clientY-g.top)/u>.5:O>M}else s=I!==v&&!D||H&&D;v.contains(j)||(s&&!I?j.appendChild(v):e.parentNode.insertBefore(v,s?I:e)),w=v.parentNode,this._animate(f,v),this._animate(g,e)}}}},_animate:function(a,b){var c=this.options.animation;if(c){var d=b.getBoundingClientRect();i(b,"transition","none"),i(b,"transform","translate3d("+(a.left-d.left)+"px,"+(a.top-d.top)+"px,0)"),b.offsetWidth,i(b,"transition","all "+c+"ms"),i(b,"transform","translate3d(0,0,0)"),clearTimeout(b.animated),b.animated=setTimeout(function(){i(b,"transition",""),i(b,"transform",""),b.animated=!1},c)}},_offUpEvents:function(){var a=this.el.ownerDocument;g(S,"touchmove",this._onTouchMove),g(a,"mouseup",this._onDrop),g(a,"touchend",this._onDrop),g(a,"touchcancel",this._onDrop)},_onDrop:function(b){var c=this.el,d=this.options;clearInterval(this._loopId),clearInterval(O.pid),clearTimeout(this._dragStartTimer),g(S,"mousemove",this._onTouchMove),this.nativeDraggable&&(g(S,"drop",this),g(c,"dragstart",this._onDragStart)),this._offUpEvents(),b&&(N&&(b.preventDefault(),!d.dropBubble&&b.stopPropagation()),x&&x.parentNode.removeChild(x),v&&(this.nativeDraggable&&g(v,"dragend",this),m(v),v.style["will-change"]="",h(v,this.options.ghostClass,!1),h(v,this.options.chosenClass,!1),z!==w?(I=q(v,d.draggable),I>=0&&(k(null,w,"add",v,z,H,I),k(this,z,"remove",v,z,H,I),k(null,w,"sort",v,z,H,I),k(this,z,"sort",v,z,H,I))):(y&&y.parentNode.removeChild(y),v.nextSibling!==A&&(I=q(v,d.draggable),I>=0&&(k(this,z,"update",v,z,H,I),k(this,z,"sort",v,z,H,I)))),a.active&&(null!=I&&I!==-1||(I=H),k(this,z,"end",v,z,H,I),this.save()))),this._nulling()},_nulling:function(){z=v=w=x=A=y=B=C=L=M=N=I=E=F=K=J=a.active=null},handleEvent:function(a){var b=a.type;"dragover"===b||"dragenter"===b?v&&(this._onDragOver(a),e(a)):"drop"!==b&&"dragend"!==b||this._onDrop(a)},toArray:function(){for(var a,b=[],d=this.el.children,e=0,f=d.length,g=this.options;e<f;e++)a=d[e],c(a,g.draggable,this.el)&&b.push(a.getAttribute(g.dataIdAttr)||p(a));return b},sort:function(a){var b={},d=this.el;this.toArray().forEach(function(a,e){var f=d.children[e];c(f,this.options.draggable,d)&&(b[a]=f)},this),a.forEach(function(a){b[a]&&(d.removeChild(b[a]),d.appendChild(b[a]))})},save:function(){var a=this.options.store;a&&a.set(this)},closest:function(a,b){return c(a,b||this.options.draggable,this.el)},option:function(a,b){var c=this.options;return void 0===b?c[a]:(c[a]=b,void("group"===a&&ba(c)))},destroy:function(){var a=this.el;a[Q]=null,g(a,"mousedown",this._onTapStart),g(a,"touchstart",this._onTapStart),this.nativeDraggable&&(g(a,"dragover",this),g(a,"dragenter",this)),Array.prototype.forEach.call(a.querySelectorAll("[draggable]"),function(a){a.removeAttribute("draggable")}),_.splice(_.indexOf(this._onDragOver),1),this._onDrop(),this.el=a=null}},a.utils={on:f,off:g,css:i,find:j,is:function(a,b){return!!c(a,b,a)},extend:t,throttle:s,closest:c,toggleClass:h,clone:u,index:q},a.create=function(b,c){return new a(b,c)},a.version="1.4.2",a});

/* mousetrap v1.6.0 craig.is/killing/mice */
(function(r,t,g){function u(a,b,h){a.addEventListener?a.addEventListener(b,h,!1):a.attachEvent("on"+b,h)}function y(a){if("keypress"==a.type){var b=String.fromCharCode(a.which);a.shiftKey||(b=b.toLowerCase());return b}return k[a.which]?k[a.which]:p[a.which]?p[a.which]:String.fromCharCode(a.which).toLowerCase()}function D(a){var b=[];a.shiftKey&&b.push("shift");a.altKey&&b.push("alt");a.ctrlKey&&b.push("ctrl");a.metaKey&&b.push("meta");return b}function v(a){return"shift"==a||"ctrl"==a||"alt"==a||
"meta"==a}function z(a,b){var h,c,e,g=[];h=a;"+"===h?h=["+"]:(h=h.replace(/\+{2}/g,"+plus"),h=h.split("+"));for(e=0;e<h.length;++e)c=h[e],A[c]&&(c=A[c]),b&&"keypress"!=b&&B[c]&&(c=B[c],g.push("shift")),v(c)&&g.push(c);h=c;e=b;if(!e){if(!n){n={};for(var l in k)95<l&&112>l||k.hasOwnProperty(l)&&(n[k[l]]=l)}e=n[h]?"keydown":"keypress"}"keypress"==e&&g.length&&(e="keydown");return{key:c,modifiers:g,action:e}}function C(a,b){return null===a||a===t?!1:a===b?!0:C(a.parentNode,b)}function c(a){function b(a){a=
a||{};var b=!1,m;for(m in n)a[m]?b=!0:n[m]=0;b||(w=!1)}function h(a,b,m,f,c,h){var g,e,k=[],l=m.type;if(!d._callbacks[a])return[];"keyup"==l&&v(a)&&(b=[a]);for(g=0;g<d._callbacks[a].length;++g)if(e=d._callbacks[a][g],(f||!e.seq||n[e.seq]==e.level)&&l==e.action){var q;(q="keypress"==l&&!m.metaKey&&!m.ctrlKey)||(q=e.modifiers,q=b.sort().join(",")===q.sort().join(","));q&&(q=f&&e.seq==f&&e.level==h,(!f&&e.combo==c||q)&&d._callbacks[a].splice(g,1),k.push(e))}return k}function g(a,b,m,f){d.stopCallback(b,
b.target||b.srcElement,m,f)||!1!==a(b,m)||(b.preventDefault?b.preventDefault():b.returnValue=!1,b.stopPropagation?b.stopPropagation():b.cancelBubble=!0)}function e(a){"number"!==typeof a.which&&(a.which=a.keyCode);var b=y(a);b&&("keyup"==a.type&&x===b?x=!1:d.handleKey(b,D(a),a))}function k(a,c,m,f){function e(c){return function(){w=c;++n[a];clearTimeout(r);r=setTimeout(b,1E3)}}function h(c){g(m,c,a);"keyup"!==f&&(x=y(c));setTimeout(b,10)}for(var d=n[a]=0;d<c.length;++d){var p=d+1===c.length?h:e(f||
z(c[d+1]).action);l(c[d],p,f,a,d)}}function l(a,b,c,f,e){d._directMap[a+":"+c]=b;a=a.replace(/\s+/g," ");var g=a.split(" ");1<g.length?k(a,g,b,c):(c=z(a,c),d._callbacks[c.key]=d._callbacks[c.key]||[],h(c.key,c.modifiers,{type:c.action},f,a,e),d._callbacks[c.key][f?"unshift":"push"]({callback:b,modifiers:c.modifiers,action:c.action,seq:f,level:e,combo:a}))}var d=this;a=a||t;if(!(d instanceof c))return new c(a);d.target=a;d._callbacks={};d._directMap={};var n={},r,x=!1,p=!1,w=!1;d._handleKey=function(a,
c,e){var f=h(a,c,e),d;c={};var k=0,l=!1;for(d=0;d<f.length;++d)f[d].seq&&(k=Math.max(k,f[d].level));for(d=0;d<f.length;++d)f[d].seq?f[d].level==k&&(l=!0,c[f[d].seq]=1,g(f[d].callback,e,f[d].combo,f[d].seq)):l||g(f[d].callback,e,f[d].combo);f="keypress"==e.type&&p;e.type!=w||v(a)||f||b(c);p=l&&"keydown"==e.type};d._bindMultiple=function(a,b,c){for(var d=0;d<a.length;++d)l(a[d],b,c)};u(a,"keypress",e);u(a,"keydown",e);u(a,"keyup",e)}if(r){var k={8:"backspace",9:"tab",13:"enter",16:"shift",17:"ctrl",
18:"alt",20:"capslock",27:"esc",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"ins",46:"del",91:"meta",93:"meta",224:"meta"},p={106:"*",107:"+",109:"-",110:".",111:"/",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'"},B={"~":"`","!":"1","@":"2","#":"3",$:"4","%":"5","^":"6","&":"7","*":"8","(":"9",")":"0",_:"-","+":"=",":":";",'"':"'","<":",",">":".","?":"/","|":"\\"},A={option:"alt",command:"meta","return":"enter",
escape:"esc",plus:"+",mod:/Mac|iPod|iPhone|iPad/.test(navigator.platform)?"meta":"ctrl"},n;for(g=1;20>g;++g)k[111+g]="f"+g;for(g=0;9>=g;++g)k[g+96]=g;c.prototype.bind=function(a,b,c){a=a instanceof Array?a:[a];this._bindMultiple.call(this,a,b,c);return this};c.prototype.unbind=function(a,b){return this.bind.call(this,a,function(){},b)};c.prototype.trigger=function(a,b){if(this._directMap[a+":"+b])this._directMap[a+":"+b]({},a);return this};c.prototype.reset=function(){this._callbacks={};this._directMap=
{};return this};c.prototype.stopCallback=function(a,b){return-1<(" "+b.className+" ").indexOf(" mousetrap ")||C(b,this.target)?!1:"INPUT"==b.tagName||"SELECT"==b.tagName||"TEXTAREA"==b.tagName||b.isContentEditable};c.prototype.handleKey=function(){return this._handleKey.apply(this,arguments)};c.addKeycodes=function(a){for(var b in a)a.hasOwnProperty(b)&&(k[b]=a[b]);n=null};c.init=function(){var a=c(t),b;for(b in a)"_"!==b.charAt(0)&&(c[b]=function(b){return function(){return a[b].apply(a,arguments)}}(b))};
c.init();r.Mousetrap=c;"undefined"!==typeof module&&module.exports&&(module.exports=c);"function"===typeof define&&define.amd&&define(function(){return c})}})("undefined"!==typeof window?window:null,"undefined"!==typeof window?document:null);

(function(a){var c={},d=a.prototype.stopCallback;a.prototype.stopCallback=function(e,b,a,f){return this.paused?!0:c[a]||c[f]?!1:d.call(this,e,b,a)};a.prototype.bindGlobal=function(a,b,d){this.bind(a,b,d);if(a instanceof Array)for(b=0;b<a.length;b++)c[a[b]]=!0;else c[a]=!0};a.init()})(Mousetrap);

(function(e){"use strict";var t=typeof window==="undefined"?null:window;if(typeof define==="function"&&define.amd){define(function(){return e(t)})}else if(typeof module!=="undefined"){t.DOMPurify=e(t)}else{t.DOMPurify=e(t)}})(function e(t){"use strict";var r=function(t){return e(t)};r.version="0.8.3";r.removed=[];if(!t||!t.document||t.document.nodeType!==9){r.isSupported=false;return r}var n=t.document;var a=n;var i=t.DocumentFragment;var o=t.HTMLTemplateElement;var l=t.NodeFilter;var s=t.NamedNodeMap||t.MozNamedAttrMap;var f=t.Text;var c=t.Comment;var u=t.DOMParser;if(typeof o==="function"){var d=n.createElement("template");if(d.content&&d.content.ownerDocument){n=d.content.ownerDocument}}var m=n.implementation;var p=n.createNodeIterator;var v=n.getElementsByTagName;var h=n.createDocumentFragment;var g=a.importNode;var y={};r.isSupported=typeof m.createHTMLDocument!=="undefined"&&n.documentMode!==9;var b=function(e,t){var r=t.length;while(r--){if(typeof t[r]==="string"){t[r]=t[r].toLowerCase()}e[t[r]]=true}return e};var T=function(e){var t={};var r;for(r in e){if(e.hasOwnProperty(r)){t[r]=e[r]}}return t};var x=null;var k=b({},["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr","svg","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","switch","symbol","text","textpath","title","tref","tspan","view","vkern","feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","feSpecularLighting","feTile","feTurbulence","math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmuliscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mpspace","msqrt","mystyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","#text"]);var A=null;var w=b({},["accept","action","align","alt","autocomplete","background","bgcolor","border","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","coords","datetime","default","dir","disabled","download","enctype","face","for","headers","height","hidden","high","href","hreflang","id","ismap","label","lang","list","loop","low","max","maxlength","media","method","min","multiple","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","rows","rowspan","spellcheck","scope","selected","shape","size","span","srclang","start","src","step","style","summary","tabindex","title","type","usemap","valign","value","width","xmlns","accent-height","accumulate","additivive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","clip","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","mode","min","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","surfacescale","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","u1","u2","unicode","values","viewbox","visibility","vert-adv-y","vert-origin-x","vert-origin-y","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","y","y1","y2","z","zoomandpan","accent","accentunder","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","display","displaystyle","fence","frame","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]);var E=null;var S=null;var M=true;var O=false;var N=false;var L=false;var D=/\{\{[\s\S]*|[\s\S]*\}\}/gm;var _=/<%[\s\S]*|[\s\S]*%>/gm;var C=false;var z=false;var R=false;var F=false;var H=true;var B=true;var W=b({},["audio","head","math","script","style","svg","video"]);var j=b({},["audio","video","img","source"]);var G=b({},["alt","class","for","id","label","name","pattern","placeholder","summary","title","value","style","xmlns"]);var I=null;var q=n.createElement("form");var P=function(e){if(typeof e!=="object"){e={}}x="ALLOWED_TAGS"in e?b({},e.ALLOWED_TAGS):k;A="ALLOWED_ATTR"in e?b({},e.ALLOWED_ATTR):w;E="FORBID_TAGS"in e?b({},e.FORBID_TAGS):{};S="FORBID_ATTR"in e?b({},e.FORBID_ATTR):{};M=e.ALLOW_DATA_ATTR!==false;O=e.ALLOW_UNKNOWN_PROTOCOLS||false;N=e.SAFE_FOR_JQUERY||false;L=e.SAFE_FOR_TEMPLATES||false;C=e.WHOLE_DOCUMENT||false;z=e.RETURN_DOM||false;R=e.RETURN_DOM_FRAGMENT||false;F=e.RETURN_DOM_IMPORT||false;H=e.SANITIZE_DOM!==false;B=e.KEEP_CONTENT!==false;if(L){M=false}if(R){z=true}if(e.ADD_TAGS){if(x===k){x=T(x)}b(x,e.ADD_TAGS)}if(e.ADD_ATTR){if(A===w){A=T(A)}b(A,e.ADD_ATTR)}if(B){x["#text"]=true}if(Object&&"freeze"in Object){Object.freeze(e)}I=e};var U=function(e){r.removed.push({element:e});try{e.parentNode.removeChild(e)}catch(t){e.outerHTML=""}};var V=function(e,t){r.removed.push({attribute:t.getAttributeNode(e),from:t});t.removeAttribute(e)};var K=function(e){var t,r;try{t=(new u).parseFromString(e,"text/html")}catch(n){}if(!t||!t.documentElement){t=m.createHTMLDocument("");r=t.body;r.parentNode.removeChild(r.parentNode.firstElementChild);r.outerHTML=e}if(typeof t.getElementsByTagName==="function"){return t.getElementsByTagName(C?"html":"body")[0]}return v.call(t,C?"html":"body")[0]};var J=function(e){return p.call(e.ownerDocument||e,e,l.SHOW_ELEMENT|l.SHOW_COMMENT|l.SHOW_TEXT,function(){return l.FILTER_ACCEPT},false)};var Q=function(e){if(e instanceof f||e instanceof c){return false}if(typeof e.nodeName!=="string"||typeof e.textContent!=="string"||typeof e.removeChild!=="function"||!(e.attributes instanceof s)||typeof e.removeAttribute!=="function"||typeof e.setAttribute!=="function"){return true}return false};var X=function(e){var t,n;ne("beforeSanitizeElements",e,null);if(Q(e)){U(e);return true}t=e.nodeName.toLowerCase();ne("uponSanitizeElement",e,{tagName:t});if(!x[t]||E[t]){if(B&&!W[t]&&typeof e.insertAdjacentHTML==="function"){try{e.insertAdjacentHTML("AfterEnd",e.innerHTML)}catch(a){}}U(e);return true}if(N&&!e.firstElementChild&&(!e.content||!e.content.firstElementChild)&&/</g.test(e.textContent)){r.removed.push({element:e.cloneNode()});e.innerHTML=e.textContent.replace(/</g,"&lt;")}if(L&&e.nodeType===3){n=e.textContent;n=n.replace(D," ");n=n.replace(_," ");if(e.textContent!==n){r.removed.push({element:e.cloneNode()});e.textContent=n}}ne("afterSanitizeElements",e,null);return false};var Y=/^data-[\-\w.\u00B7-\uFFFF]/;var Z=/^(?:(?:(?:f|ht)tps?|mailto|tel):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i;var $=/^(?:\w+script|data):/i;var ee=/[\x00-\x20\xA0\u1680\u180E\u2000-\u2029\u205f\u3000]/g;var te=function(e){var a,i,o,l,s,f,c,u;ne("beforeSanitizeAttributes",e,null);f=e.attributes;if(!f){return}c={attrName:"",attrValue:"",keepAttr:true};u=f.length;while(u--){a=f[u];i=a.name;o=a.value;l=i.toLowerCase();c.attrName=l;c.attrValue=o;c.keepAttr=true;ne("uponSanitizeAttribute",e,c);o=c.attrValue;if(l==="name"&&e.nodeName==="IMG"&&f.id){s=f.id;f=Array.prototype.slice.apply(f);V("id",e);V(i,e);if(f.indexOf(s)>u){e.setAttribute("id",s.value)}}else{if(i==="id"){e.setAttribute(i,"")}V(i,e)}if(!c.keepAttr){continue}if(H&&(l==="id"||l==="name")&&(o in t||o in n||o in q)){continue}if(L){o=o.replace(D," ");o=o.replace(_," ")}if(M&&Y.test(l)){}else if(!A[l]||S[l]){continue}else if(G[l]){}else if(Z.test(o.replace(ee,""))){}else if(l==="src"&&o.indexOf("data:")===0&&j[e.nodeName.toLowerCase()]){}else if(O&&!$.test(o.replace(ee,""))){}else if(!o){}else{continue}try{e.setAttribute(i,o);r.removed.pop()}catch(d){}}ne("afterSanitizeAttributes",e,null)};var re=function(e){var t;var r=J(e);ne("beforeSanitizeShadowDOM",e,null);while(t=r.nextNode()){ne("uponSanitizeShadowNode",t,null);if(X(t)){continue}if(t.content instanceof i){re(t.content)}te(t)}ne("afterSanitizeShadowDOM",e,null)};var ne=function(e,t,n){if(!y[e]){return}y[e].forEach(function(e){e.call(r,t,n,I)})};r.sanitize=function(e,n){var o,l,s,f,c;if(!e){e=""}if(typeof e!=="string"){if(typeof e.toString!=="function"){throw new TypeError("toString is not a function")}else{e=e.toString()}}if(!r.isSupported){if(typeof t.toStaticHTML==="object"||typeof t.toStaticHTML==="function"){return t.toStaticHTML(e)}return e}P(n);r.removed=[];if(!z&&!C&&e.indexOf("<")===-1){return e}o=K(e);if(!o){return z?null:""}f=J(o);while(l=f.nextNode()){if(l.nodeType===3&&l===s){continue}if(X(l)){continue}if(l.content instanceof i){re(l.content)}te(l);s=l}if(z){if(R){c=h.call(o.ownerDocument);while(o.firstChild){c.appendChild(o.firstChild)}}else{c=o}if(F){c=g.call(a,c,true)}return c}return C?o.outerHTML:o.innerHTML};r.addHook=function(e,t){if(typeof t!=="function"){return}y[e]=y[e]||[];y[e].push(t)};r.removeHook=function(e){if(y[e]){y[e].pop()}};r.removeHooks=function(e){if(y[e]){y[e]=[]}};r.removeAllHooks=function(){y={}};return r});
//# sourceMappingURL=purify.min.js.map

/**
 * Countable is a script to allow for live paragraph-, word- and character-
 * counting on an HTML element.
 *
 * @author   Sacha Schmid (<https://github.com/RadLikeWhoa>)
 * @version  2.1.1
 * @license  MIT
 * @see      <http://radlikewhoa.github.io/Countable/>
 */

/**
 * Note: For the purpose of this internal documentation, arguments of the type
 * {Nodes} are to be interpreted as either {NodeList} or {Element}.
 */

;(function (global) {
  'use strict'

  /**
   * @private
   *
   * `_liveElements` holds all elements that have the live-counting
   * functionality bound to them.
   *
   * `_event` holds the event to handle the live counting, based on the
   * browser's capabilities.
   */

  var _liveElements = [],
      _event = 'oninput' in document ? 'input' : 'keyup'

  /**
   * IE9 is a special case. It does not fire an 'input' event when
   * characters are deleted (via DEL key, BACKSPACE key, and CUT).
   * If we want support for those actions we need to use the 'keyup'
   * event instead.
   * more info: http://www.matts411.com/post/internet-explorer-9-oninput/
   */

  if (navigator.userAgent.match(/MSIE 9.0/)) {
    _event = 'keyup'
  }

  /**
   * `String.trim()` polyfill for non-supporting browsers. This is the
   * recommended polyfill on MDN.
   *
   * @see     <http://goo.gl/uYveB>
   * @see     <http://goo.gl/xjIxJ>
   *
   * @return  {String}  The original string with leading and trailing
   *                    whitespace removed.
   */

  if (!String.prototype.trim) {
    String.prototype.trim = function () {
      return this.replace(/^\s+|\s+$/g, '')
    }
  }

  /**
   * `ucs2decode` function from the punycode.js library.
   *
   * Creates an array containing the decimal code points of each Unicode
   * character in the string. While JavaScript uses UCS-2 internally, this
   * function will convert a pair of surrogate halves (each of which UCS-2
   * exposes as separate characters) into a single code point, matching
   * UTF-16.
   *
   * @see     <http://goo.gl/8M09r>
   * @see     <http://goo.gl/u4UUC>
   *
   * @param   {String}  string   The Unicode input string (UCS-2).
   *
   * @return  {Array}   The new array of code points.
   */

  function _decode (string) {
    var output = [],
        counter = 0,
        length = string.length,
        value, extra

    while (counter < length) {
      value = string.charCodeAt(counter++)

      if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
        // High surrogate, and there is a next character.
        extra = string.charCodeAt(counter++)

        if ((extra & 0xFC00) == 0xDC00) {
          // Low surrogate.
          output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000)
        } else {
          // unmatched surrogate; only append this code unit, in case the next
          // code unit is the high surrogate of a surrogate pair
          output.push(value, extra)
          counter--
        }
      } else {
        output.push(value)
      }
    }

    return output
  }

  /**
   * `_validateArguments` validates the arguments given to each function call.
   * Errors are logged to the console as warnings, but Countable fails
   * silently.
   *
   * @private
   *
   * @param   {Nodes}     elements  The (collection of) element(s) to
   *                                validate.
   *
   * @param   {Function}  callback  The callback function to validate.
   *
   * @return  {Boolean}   Returns whether all arguments are vaild.
   */

  function _validateArguments (elements, callback) {
    var nodes = Object.prototype.toString.call(elements),
        elementsValid = elements && (((nodes === '[object NodeList]' || nodes === '[object HTMLCollection]') && elements.length) || (elements.nodeType === 1)),
        callbackValid = callback && typeof callback === 'function'

    if ('console' in window && 'warn' in console) {
      if (!elementsValid) console.warn('Countable: No valid elements were found')
      if (!callbackValid) console.warn('Countable: "' + callback + '" is not a valid callback function')
    }

    return elementsValid && callbackValid
  }

  /**
   * `_extendDefaults` is a function to extend a set of default options with
   * the ones given in the function call. Available options are described
   * below.
   *
   * {Boolean}  hardReturns      Use two returns to seperate a paragraph
   *                             instead of one.
   * {Boolean}  stripTags        Strip HTML tags before counting the values.
   * {Boolean}  ignoreReturns    Ignore returns when calculating the `all`
   *                             property.
   * {Boolean}  ignoreZeroWidth  Ignore zero-width space characters.
   *
   * @private
   *
   * @param   {Object}  options  Countable allows the options described above.
   *                             They can be used in a function call to
   *                             override the default behaviour.
   *
   * @return  {Object}  The new options object.
   */

  function _extendDefaults (options) {
    var defaults = {
      hardReturns: false,
      stripTags: false,
      ignoreReturns: false,
      ignoreZeroWidth: true
    }

    for (var prop in options) {
      if (defaults.hasOwnProperty(prop)) defaults[prop] = options[prop]
    }

    return defaults
  }

  /**
   * `_count` trims an element's value, optionally strips HTML tags and counts
   * paragraphs, sentences, words, characters and characters plus spaces.
   *
   * @private
   *
   * @param   {Element}  element  The element whose value is to be counted.
   *
   * @param   {Object}   options  The options to use for the counting.
   *
   * @return  {Object}   The object containing the number of paragraphs,
   *                     sentences, words, characters and characters plus
   *                     spaces.
   */

  function _count (element, options) {
    var original = '' + ('value' in element ? element.value : element.innerText || element.textContent),
        trimmed

    /**
     * The initial implementation to allow for HTML tags stripping was created
     * @craniumslows while the current one was created by @Rob--W.
     *
     * @see <http://goo.gl/Exmlr>
     * @see <http://goo.gl/gFQQh>
     */

    if (options.stripTags) original = original.replace(/<\/?[a-z][^>]*>/gi, '')
    if (options.ignoreZeroWidth) original = original.replace(/[\u200B]+/, '')

    trimmed = original.trim()

    /**
     * Most of the performance improvements are based on the works of @epmatsw.
     *
     * @see <http://goo.gl/SWOLB>
     */

    return {
      paragraphs: trimmed ? (trimmed.match(options.hardReturns ? /\n{2,}/g : /\n+/g) || []).length + 1 : 0,
      sentences: trimmed ? (trimmed.match(/[.?!…]+./g) || []).length + 1 : 0,
      words: trimmed ? (trimmed.replace(/['";:,.?¿\-!¡]+/g, '').match(/\S+/g) || []).length : 0,
      characters: trimmed ? _decode(trimmed.replace(/\s/g, '')).length : 0,
      all: _decode(options.ignoreReturns ? original.replace(/[\n\r]/g, '') : original).length
    }
  }

  /**
   * `_loop` is a helper function to iterate over a collection, e.g. a NodeList
   * or an Array. The callback receives the current element as the single
   * parameter.
   *
   * @private
   *
   * @param  {Array}     which     The collection to iterate over.
   *
   * @param  {Function}  callback  The callback function to call on each
   *                               iteration.
   */

  function _loop (which, callback) {
    var len = which.length

    if (typeof len !== 'undefined') {
      while (len--) {
        callback(which[len])
      }
    } else {
      callback(which)
    }
  }

  /**
   * This is the main object that will later be exposed to other scripts. It
   * holds all the public methods that can be used to enable the Countable
   * functionality.
   */

  var Countable = {

    /**
     * The `live` method binds the counting handler to all given elements. The
     * event is either `oninput` or `onkeydown`, based on the capabilities of
     * the browser.
     *
     * @param   {Nodes}     elements   All elements that should receive the
     *                                 Countable functionality.
     *
     * @param   {Function}  callback   The callback to fire whenever the
     *                                 element's value changes. The callback is
     *                                 called with the relevant element bound
     *                                 to `this` and the counted values as the
     *                                 single parameter.
     *
     * @param   {Object}    [options]  An object to modify Countable's
     *                                 behaviour. Refer to `_extendDefaults`
     *                                 for a list of available options.
     *
     * @return  {Object}    Returns the Countable object to allow for chaining.
     */

    live: function (elements, callback, options) {
      var ops = _extendDefaults(options),
          bind = function (element) {
            var handler = function () {
                  callback.call(element, _count(element, ops))
                }

            _liveElements.push({ element: element, handler: handler })

            handler()

            if (element.addEventListener) {
              element.addEventListener(_event, handler, false)
            } else if (element.attachEvent) {
              element.attachEvent('on' + _event, handler)
            }
          }

      if (!_validateArguments(elements, callback)) return

      if (elements.length) {
        _loop(elements, bind)
      } else {
        bind(elements)
      }

      return this
    },

    /**
     * The `die` method removes the Countable functionality from all given
     * elements.
     *
     * @param   {Nodes}  elements  All elements whose Countable functionality
     *                             should be unbound.
     *
     * @return  {Object}  Returns the Countable object to allow for chaining.
     */

    die: function (elements) {
      if (!_validateArguments(elements, function () {})) return

      _loop(elements, function (element) {
        var liveElement

        _loop(_liveElements, function (live) {
          if (live.element === element) liveElement = live
        })

        if (!liveElement) return

        if (element.removeEventListener) {
          element.removeEventListener(_event, liveElement.handler, false)
        } else if (element.detachEvent) {
          element.detachEvent('on' + _event, liveElement.handler)
        }

        _liveElements.splice(_liveElements.indexOf(liveElement), 1)
      })

      return this
    },

    /**
     * The `once` method works mostly like the `live` method, but no events are
     * bound, the functionality is only executed once.
     *
     * @alias   Countable.count
     *
     * @param   {Nodes}     elements   All elements that should receive the
     *                                 Countable functionality.
     *
     * @param   {Function}  callback   The callback to fire whenever the
     *                                 element's value changes. The callback is
     *                                 called with the relevant element bound
     *                                 to `this` and the counted values as the
     *                                 single parameter.
     *
     * @param   {Object}    [options]  An object to modify Countable's
     *                                 behaviour. Refer to `_extendDefaults`
     *                                 for a list of available options.
     *
     * @return  {Object}    Returns the Countable object to allow for chaining.
     */

    once: function (elements, callback, options) {
      if (!_validateArguments(elements, callback)) return

      _loop(elements, function (element) {
        callback.call(element, _count(element, _extendDefaults(options)))
      })

      return this
    },

    count: function (elements, callback, options) {
      return this.once(elements, callback, options)
    },

    /**
     * The `enabled` method checks if the live-counting functionality is bound
     * to an element.
     *
     * @param   {Element}  element  A single Element.
     *
     * @return  {Boolean}  A boolean value representing whether Countable
     *                     functionality is bound to the given element.
     */

    enabled: function (element) {
      var isEnabled = false

      if (element && element.nodeType === 1) {
        _loop(_liveElements, function (live) {
          if (live.element === element) isEnabled = true
        })
      }

      return isEnabled
    }

  }

  /**
   * Expose Countable depending on the module system used across the
   * application. (Node / CommonJS, AMD, global)
   */

  if (typeof exports === 'object') {
    module.exports = Countable
  } else if (typeof define === 'function' && define.amd) {
    define(function () { return Countable })
  } else {
    global.Countable = Countable
  }
}(this));

/**
 * findAndReplaceDOMText v 0.4.3
 * @author James Padolsey http://james.padolsey.com
 * @license http://unlicense.org/UNLICENSE
 *
 * Matches the text of a DOM node against a regular expression
 * and replaces each match (or node-separated portions of the match)
 * in the specified element.
 */
 (function (root, factory) {
     /*if (typeof module === 'object' && module.exports) {
         // Node/CommonJS
         module.exports = factory();
     } else */if (typeof define === 'function' && define.amd) {
         // AMD. Register as an anonymous module.
         define(factory);
     } else {
         // Browser globals
         root.findAndReplaceDOMText = factory();
     }
 }(this, function factory() {

	var PORTION_MODE_RETAIN = 'retain';
	var PORTION_MODE_FIRST = 'first';

	var doc = document;
	var hasOwn = {}.hasOwnProperty;

	function escapeRegExp(s) {
		return String(s).replace(/([.*+?^=!:${}()|[\]\/\\])/g, '\\$1');
	}

	function exposed() {
		// Try deprecated arg signature first:
		return deprecated.apply(null, arguments) || findAndReplaceDOMText.apply(null, arguments);
	}

	function deprecated(regex, node, replacement, captureGroup, elFilter) {
		if ((node && !node.nodeType) && arguments.length <= 2) {
			return false;
		}
		var isReplacementFunction = typeof replacement == 'function';

		if (isReplacementFunction) {
			replacement = (function(original) {
				return function(portion, match) {
					return original(portion.text, match.startIndex);
				};
			}(replacement));
		}

		// Awkward support for deprecated argument signature (<0.4.0)
		var instance = findAndReplaceDOMText(node, {

			find: regex,

			wrap: isReplacementFunction ? null : replacement,
			replace: isReplacementFunction ? replacement : '$' + (captureGroup || '&'),

			prepMatch: function(m, mi) {

				// Support captureGroup (a deprecated feature)

				if (!m[0]) throw 'findAndReplaceDOMText cannot handle zero-length matches';

				if (captureGroup > 0) {
					var cg = m[captureGroup];
					m.index += m[0].indexOf(cg);
					m[0] = cg;
				}

				m.endIndex = m.index + m[0].length;
				m.startIndex = m.index;
				m.index = mi;

				return m;
			},
			filterElements: elFilter
		});

		exposed.revert = function() {
			return instance.revert();
		};

		return true;
	}

	/**
	 * findAndReplaceDOMText
	 *
	 * Locates matches and replaces with replacementNode
	 *
	 * @param {Node} node Element or Text node to search within
	 * @param {RegExp} options.find The regular expression to match
	 * @param {String|Element} [options.wrap] A NodeName, or a Node to clone
	 * @param {String|Function} [options.replace='$&'] What to replace each match with
	 * @param {Function} [options.filterElements] A Function to be called to check whether to
	 *	process an element. (returning true = process element,
	 *	returning false = avoid element)
	 */
	function findAndReplaceDOMText(node, options) {
		return new Finder(node, options);
	}

	exposed.NON_PROSE_ELEMENTS = {
		br:1, hr:1,
		// Media / Source elements:
		script:1, style:1, img:1, video:1, audio:1, canvas:1, svg:1, map:1, object:1,
		// Input elements
		input:1, textarea:1, select:1, option:1, optgroup: 1, button:1
	};

	exposed.NON_CONTIGUOUS_PROSE_ELEMENTS = {

		// Elements that will not contain prose or block elements where we don't
		// want prose to be matches across element borders:

		// Block Elements
		address:1, article:1, aside:1, blockquote:1, dd:1, div:1,
		dl:1, fieldset:1, figcaption:1, figure:1, footer:1, form:1, h1:1, h2:1, h3:1,
		h4:1, h5:1, h6:1, header:1, hgroup:1, hr:1, main:1, nav:1, noscript:1, ol:1,
		output:1, p:1, pre:1, section:1, ul:1,
		// Other misc. elements that are not part of continuous inline prose:
		br:1, li: 1, summary: 1, dt:1, details:1, rp:1, rt:1, rtc:1,
		// Media / Source elements:
		script:1, style:1, img:1, video:1, audio:1, canvas:1, svg:1, map:1, object:1,
		// Input elements
		input:1, textarea:1, select:1, option:1, optgroup:1, button:1,
		// Table related elements:
		table:1, tbody:1, thead:1, th:1, tr:1, td:1, caption:1, col:1, tfoot:1, colgroup:1

	};

	exposed.NON_INLINE_PROSE = function(el) {
		return hasOwn.call(exposed.NON_CONTIGUOUS_PROSE_ELEMENTS, el.nodeName.toLowerCase());
	};

	// Presets accessed via `options.preset` when calling findAndReplaceDOMText():
	exposed.PRESETS = {
		prose: {
			forceContext: exposed.NON_INLINE_PROSE,
			filterElements: function(el) {
				return !hasOwn.call(exposed.NON_PROSE_ELEMENTS, el.nodeName.toLowerCase());
			}
		}
	};

	exposed.Finder = Finder;

	/**
	 * Finder -- encapsulates logic to find and replace.
	 */
	function Finder(node, options) {

		var preset = options.preset && exposed.PRESETS[options.preset];

		options.portionMode = options.portionMode || PORTION_MODE_RETAIN;

		if (preset) {
			for (var i in preset) {
				if (hasOwn.call(preset, i) && !hasOwn.call(options, i)) {
					options[i] = preset[i];
				}
			}
		}

		this.node = node;
		this.options = options;

		// Enable match-preparation method to be passed as option:
		this.prepMatch = options.prepMatch || this.prepMatch;

		this.reverts = [];

		this.matches = this.search();

		if (this.matches.length) {
			this.processMatches();
		}

	}

	Finder.prototype = {

		/**
		 * Searches for all matches that comply with the instance's 'match' option
		 */
		search: function() {

			var match;
			var matchIndex = 0;
			var offset = 0;
			var regex = this.options.find;
			var textAggregation = this.getAggregateText();
			var matches = [];
			var self = this;

			regex = typeof regex === 'string' ? RegExp(escapeRegExp(regex), 'g') : regex;

			matchAggregation(textAggregation);

			function matchAggregation(textAggregation) {
				for (var i = 0, l = textAggregation.length; i < l; ++i) {

					var text = textAggregation[i];

					if (typeof text !== 'string') {
						// Deal with nested contexts: (recursive)
						matchAggregation(text);
						continue;
					}

					if (regex.global) {
						while (match = regex.exec(text)) {
							matches.push(self.prepMatch(match, matchIndex++, offset));
						}
					} else {
						if (match = text.match(regex)) {
							matches.push(self.prepMatch(match, 0, offset));
						}
					}

					offset += text.length;
				}
			}

			return matches;

		},

		/**
		 * Prepares a single match with useful meta info:
		 */
		prepMatch: function(match, matchIndex, characterOffset) {

			if (!match[0]) {
				throw new Error('findAndReplaceDOMText cannot handle zero-length matches');
			}

			match.endIndex = characterOffset + match.index + match[0].length;
			match.startIndex = characterOffset + match.index;
			match.index = matchIndex;

			return match;
		},

		/**
		 * Gets aggregate text within subject node
		 */
		getAggregateText: function() {

			var elementFilter = this.options.filterElements;
			var forceContext = this.options.forceContext;

			return getText(this.node);

			/**
			 * Gets aggregate text of a node without resorting
			 * to broken innerText/textContent
			 */
			function getText(node) {

				if (node.nodeType === 3) {
					return [node.data];
				}

				if (elementFilter && !elementFilter(node)) {
					return [];
				}

				var txt = [''];
				var i = 0;

				if (node = node.firstChild) do {

					if (node.nodeType === 3) {
						txt[i] += node.data;
						continue;
					}

					var innerText = getText(node);

					if (
						forceContext &&
						node.nodeType === 1 &&
						(forceContext === true || forceContext(node))
					) {
						txt[++i] = innerText;
						txt[++i] = '';
					} else {
						if (typeof innerText[0] === 'string') {
							// Bridge nested text-node data so that they're
							// not considered their own contexts:
							// I.e. ['some', ['thing']] -> ['something']
							txt[i] += innerText.shift();
						}
						if (innerText.length) {
							txt[++i] = innerText;
							txt[++i] = '';
						}
					}
				} while (node = node.nextSibling);

				return txt;

			}

		},

		/**
		 * Steps through the target node, looking for matches, and
		 * calling replaceFn when a match is found.
		 */
		processMatches: function() {

			var matches = this.matches;
			var node = this.node;
			var elementFilter = this.options.filterElements;

			var startPortion,
				endPortion,
				innerPortions = [],
				curNode = node,
				match = matches.shift(),
				atIndex = 0, // i.e. nodeAtIndex
				matchIndex = 0,
				portionIndex = 0,
				doAvoidNode,
				nodeStack = [node];

			out: while (true) {

				if (curNode.nodeType === 3) {

					if (!endPortion && curNode.length + atIndex >= match.endIndex) {

						// We've found the ending
						endPortion = {
							node: curNode,
							index: portionIndex++,
							text: curNode.data.substring(match.startIndex - atIndex, match.endIndex - atIndex),
							indexInMatch: atIndex - match.startIndex,
							indexInNode: match.startIndex - atIndex, // always zero for end-portions
							endIndexInNode: match.endIndex - atIndex,
							isEnd: true
						};

					} else if (startPortion) {
						// Intersecting node
						innerPortions.push({
							node: curNode,
							index: portionIndex++,
							text: curNode.data,
							indexInMatch: atIndex - match.startIndex,
							indexInNode: 0 // always zero for inner-portions
						});
					}

					if (!startPortion && curNode.length + atIndex > match.startIndex) {
						// We've found the match start
						startPortion = {
							node: curNode,
							index: portionIndex++,
							indexInMatch: 0,
							indexInNode: match.startIndex - atIndex,
							endIndexInNode: match.endIndex - atIndex,
							text: curNode.data.substring(match.startIndex - atIndex, match.endIndex - atIndex)
						};
					}

					atIndex += curNode.data.length;

				}

				doAvoidNode = curNode.nodeType === 1 && elementFilter && !elementFilter(curNode);

				if (startPortion && endPortion) {

					curNode = this.replaceMatch(match, startPortion, innerPortions, endPortion);

					// processMatches has to return the node that replaced the endNode
					// and then we step back so we can continue from the end of the
					// match:

					atIndex -= (endPortion.node.data.length - endPortion.endIndexInNode);

					startPortion = null;
					endPortion = null;
					innerPortions = [];
					match = matches.shift();
					portionIndex = 0;
					matchIndex++;

					if (!match) {
						break; // no more matches
					}

				} else if (
					!doAvoidNode &&
					(curNode.firstChild || curNode.nextSibling)
				) {
					// Move down or forward:
					if (curNode.firstChild) {
						nodeStack.push(curNode);
						curNode = curNode.firstChild;
					} else {
						curNode = curNode.nextSibling;
					}
					continue;
				}

				// Move forward or up:
				while (true) {
					if (curNode.nextSibling) {
						curNode = curNode.nextSibling;
						break;
					}
					curNode = nodeStack.pop();
					if (curNode === node) {
						break out;
					}
				}

			}

		},

		/**
		 * Reverts ... TODO
		 */
		revert: function() {
			// Reversion occurs backwards so as to avoid nodes subsequently
			// replaced during the matching phase (a forward process):
			for (var l = this.reverts.length; l--;) {
				this.reverts[l]();
			}
			this.reverts = [];
		},

		prepareReplacementString: function(string, portion, match) {
			var portionMode = this.options.portionMode;
			if (
				portionMode === PORTION_MODE_FIRST &&
				portion.indexInMatch > 0
			) {
				return '';
			}
			string = string.replace(/\$(\d+|&|`|')/g, function($0, t) {
				var replacement;
				switch(t) {
					case '&':
						replacement = match[0];
						break;
					case '`':
						replacement = match.input.substring(0, match.startIndex);
						break;
					case '\'':
						replacement = match.input.substring(match.endIndex);
						break;
					default:
						replacement = match[+t];
				}
				return replacement;
			});

			if (portionMode === PORTION_MODE_FIRST) {
				return string;
			}

			if (portion.isEnd) {
				return string.substring(portion.indexInMatch);
			}

			return string.substring(portion.indexInMatch, portion.indexInMatch + portion.text.length);
		},

		getPortionReplacementNode: function(portion, match) {

			var replacement = this.options.replace || '$&';
			var wrapper = this.options.wrap;

			if (wrapper && wrapper.nodeType) {
				// Wrapper has been provided as a stencil-node for us to clone:
				var clone = doc.createElement('div');
				clone.innerHTML = wrapper.outerHTML || new XMLSerializer().serializeToString(wrapper);
				wrapper = clone.firstChild;
			}

			if (typeof replacement == 'function') {
				replacement = replacement(portion, match);
				if (replacement && replacement.nodeType) {
					return replacement;
				}
				return doc.createTextNode(String(replacement));
			}

			var el = typeof wrapper == 'string' ? doc.createElement(wrapper) : wrapper;

			replacement = doc.createTextNode(
				this.prepareReplacementString(
					replacement, portion, match
				)
			);

			if (!replacement.data) {
				return replacement;
			}

			if (!el) {
				return replacement;
			}

			el.appendChild(replacement);

			return el;
		},

		replaceMatch: function(match, startPortion, innerPortions, endPortion) {

			var matchStartNode = startPortion.node;
			var matchEndNode = endPortion.node;

			var precedingTextNode;
			var followingTextNode;

			if (matchStartNode === matchEndNode) {

				var node = matchStartNode;

				if (startPortion.indexInNode > 0) {
					// Add `before` text node (before the match)
					precedingTextNode = doc.createTextNode(node.data.substring(0, startPortion.indexInNode));
					node.parentNode.insertBefore(precedingTextNode, node);
				}

				// Create the replacement node:
				var newNode = this.getPortionReplacementNode(
					endPortion,
					match
				);

				node.parentNode.insertBefore(newNode, node);

				if (endPortion.endIndexInNode < node.length) { // ?????
					// Add `after` text node (after the match)
					followingTextNode = doc.createTextNode(node.data.substring(endPortion.endIndexInNode));
					node.parentNode.insertBefore(followingTextNode, node);
				}

				node.parentNode.removeChild(node);

				this.reverts.push(function() {
					if (precedingTextNode === newNode.previousSibling) {
						precedingTextNode.parentNode.removeChild(precedingTextNode);
					}
					if (followingTextNode === newNode.nextSibling) {
						followingTextNode.parentNode.removeChild(followingTextNode);
					}
					newNode.parentNode.replaceChild(node, newNode);
				});

				return newNode;

			} else {
				// Replace matchStartNode -> [innerMatchNodes...] -> matchEndNode (in that order)


				precedingTextNode = doc.createTextNode(
					matchStartNode.data.substring(0, startPortion.indexInNode)
				);

				followingTextNode = doc.createTextNode(
					matchEndNode.data.substring(endPortion.endIndexInNode)
				);

				var firstNode = this.getPortionReplacementNode(
					startPortion,
					match
				);

				var innerNodes = [];

				for (var i = 0, l = innerPortions.length; i < l; ++i) {
					var portion = innerPortions[i];
					var innerNode = this.getPortionReplacementNode(
						portion,
						match
					);
					portion.node.parentNode.replaceChild(innerNode, portion.node);
					this.reverts.push((function(portion, innerNode) {
						return function() {
							innerNode.parentNode.replaceChild(portion.node, innerNode);
						};
					}(portion, innerNode)));
					innerNodes.push(innerNode);
				}

				var lastNode = this.getPortionReplacementNode(
					endPortion,
					match
				);

				matchStartNode.parentNode.insertBefore(precedingTextNode, matchStartNode);
				matchStartNode.parentNode.insertBefore(firstNode, matchStartNode);
				matchStartNode.parentNode.removeChild(matchStartNode);

				matchEndNode.parentNode.insertBefore(lastNode, matchEndNode);
				matchEndNode.parentNode.insertBefore(followingTextNode, matchEndNode);
				matchEndNode.parentNode.removeChild(matchEndNode);

				this.reverts.push(function() {
					precedingTextNode.parentNode.removeChild(precedingTextNode);
					firstNode.parentNode.replaceChild(matchStartNode, firstNode);
					followingTextNode.parentNode.removeChild(followingTextNode);
					lastNode.parentNode.replaceChild(matchEndNode, lastNode);
				});

				return lastNode;
			}
		}

	};

	return exposed;

}));

/*! emojify.js - v1.0.5 - 
 * Copyright (c) Hassan Khan 2015
 */
!function(e,a){"use strict";"function"==typeof define&&define.amd?define([],a):"object"==typeof exports?module.exports=a():e.emojify=a()}(this,function(){"use strict";var e=function(){function e(){var e={named:/:([a-z0-9A-Z_-]+):/,smile:/:-?\)/g,open_mouth:/:o/gi,scream:/:-o/gi,smirk:/[:;]-?]/g,grinning:/[:;]-?d/gi,stuck_out_tongue_closed_eyes:/x-d/gi,stuck_out_tongue_winking_eye:/[:;]-?p/gi,rage:/:-?[\[@]/g,frowning:/:-?\(/g,sob:/:['’]-?\(|:&#x27;\(/g,kissing_heart:/:-?\*/g,wink:/;-?\)/g,pensive:/:-?\//g,confounded:/:-?s/gi,flushed:/:-?\|/g,relaxed:/:-?\$/g,mask:/:-x/gi,heart:/<3|&lt;3/g,broken_heart:/<\/3|&lt;&#x2F;3/g,thumbsup:/:\+1:/g,thumbsdown:/:\-1:/g};return d.ignore_emoticons&&(e={named:/:([a-z0-9A-Z_-]+):/,thumbsup:/:\+1:/g,thumbsdown:/:\-1:/g}),Object.keys(e).map(function(a){return[e[a],a]})}function a(){var e=_.map(function(e){var a=e[0],o=a.source||a;return o=o.replace(/(^|[^\[])\^/g,"$1"),"("+o+")"}).join("|");return new RegExp(e,"gi")}function o(e){return" "===e||"	"===e||"\r"===e||"\n"===e||""===e||e===String.fromCharCode(160)}function r(e){var a=null;if(e.replacer)a=e.replacer.apply({config:d},[":"+e.emojiName+":",e.emojiName]);else{var o=d.tag_type||h[d.mode];a=e.win.document.createElement(o),"img"!==o?a.setAttribute("class","emoji emoji-"+e.emojiName):(a.setAttribute("align","absmiddle"),a.setAttribute("alt",":"+e.emojiName+":"),a.setAttribute("class","emoji"),a.setAttribute("src",d.img_dir+"/"+e.emojiName+".png")),a.setAttribute("title",":"+e.emojiName+":")}e.node.splitText(e.match.index),e.node.nextSibling.nodeValue=e.node.nextSibling.nodeValue.substr(e.match[0].length,e.node.nextSibling.nodeValue.length),a.appendChild(e.node.splitText(e.match.index)),e.node.parentNode.insertBefore(a,e.node.nextSibling)}function t(e){if(e[1]&&e[2]){var a=e[2];if(m[a])return a}else for(var o=3;o<e.length-1;o++)if(e[o])return _[o-2][1]}function i(e,a){var o=this.config.tag_type||h[this.config.mode];return"img"!==o?"<"+o+" class='emoji emoji-"+a+"' title=':"+a+":'></"+o+">":"<img align='absmiddle' alt=':"+a+":' class='emoji' src='"+this.config.img_dir+"/"+a+".png' title=':"+a+":' />"}function n(){this.lastEmojiTerminatedAt=-1}function s(o,r){if(!o)return o;r||(r=i),_=e(),c=a();var t=new n;return o.replace(c,function(){var e=Array.prototype.slice.call(arguments,0,-2),a=arguments[arguments.length-2],o=arguments[arguments.length-1],i=t.validate(e,a,o);return i?r.apply({config:d},[arguments[0],i]):arguments[0]})}function l(o,i){"undefined"==typeof o&&(o=d.only_crawl_id?document.getElementById(d.only_crawl_id):document.body);var s=o.ownerDocument,l=s.defaultView||s.parentWindow,u=function(e,a){var o;if(e.hasChildNodes())for(o=e.firstChild;o;)a(o)&&u(o,a),o=o.nextSibling},g=function(e){for(var a,o=[],s=new n;null!==(a=c.exec(e.data));)s.validate(a,a.index,a.input)&&o.push(a);for(var _=o.length;_-->0;){var u=t(o[_]);r({node:e,match:o[_],emojiName:u,replacer:i,win:l})}};_=e(),c=a();var m=[],h=new RegExp(d.blacklist.elements.join("|"),"i"),p=new RegExp(d.blacklist.classes.join("|"),"i");if("undefined"!=typeof l.document.createTreeWalker)for(var b,f=l.document.createTreeWalker(o,l.NodeFilter.SHOW_TEXT|l.NodeFilter.SHOW_ELEMENT,function(e){return 1!==e.nodeType?l.NodeFilter.FILTER_ACCEPT:e.tagName.match(h)||"svg"===e.tagName||e.className.match(p)?l.NodeFilter.FILTER_REJECT:l.NodeFilter.FILTER_SKIP},!1);null!==(b=f.nextNode());)m.push(b);else u(o,function(e){return"undefined"!=typeof e.tagName&&e.tagName.match(h)||"undefined"!=typeof e.className&&e.className.match(p)?!1:1===e.nodeType?!0:(m.push(e),!0)});m.forEach(g)}var _,c,u="+1,-1,100,1234,8ball,a,ab,abc,abcd,accept,aerial_tramway,airplane,alarm_clock,alien,ambulance,anchor,angel,anger,angry,anguished,ant,apple,aquarius,aries,arrow_backward,arrow_double_down,arrow_double_up,arrow_down,arrow_down_small,arrow_forward,arrow_heading_down,arrow_heading_up,arrow_left,arrow_lower_left,arrow_lower_right,arrow_right,arrow_right_hook,arrow_up,arrow_up_down,arrow_up_small,arrow_upper_left,arrow_upper_right,arrows_clockwise,arrows_counterclockwise,art,articulated_lorry,astonished,atm,b,baby,baby_bottle,baby_chick,baby_symbol,back,baggage_claim,balloon,ballot_box_with_check,bamboo,banana,bangbang,bank,bar_chart,barber,baseball,basketball,bath,bathtub,battery,bear,bee,beer,beers,beetle,beginner,bell,bento,bicyclist,bike,bikini,bird,birthday,black_circle,black_joker,black_medium_small_square,black_medium_square,black_nib,black_small_square,black_square,black_square_button,blossom,blowfish,blue_book,blue_car,blue_heart,blush,boar,boat,bomb,book,bookmark,bookmark_tabs,books,boom,boot,bouquet,bow,bowling,bowtie,boy,bread,bride_with_veil,bridge_at_night,briefcase,broken_heart,bug,bulb,bullettrain_front,bullettrain_side,bus,busstop,bust_in_silhouette,busts_in_silhouette,cactus,cake,calendar,calling,camel,camera,cancer,candy,capital_abcd,capricorn,car,card_index,carousel_horse,cat,cat2,cd,chart,chart_with_downwards_trend,chart_with_upwards_trend,checkered_flag,cherries,cherry_blossom,chestnut,chicken,children_crossing,chocolate_bar,christmas_tree,church,cinema,circus_tent,city_sunrise,city_sunset,cl,clap,clapper,clipboard,clock1,clock10,clock1030,clock11,clock1130,clock12,clock1230,clock130,clock2,clock230,clock3,clock330,clock4,clock430,clock5,clock530,clock6,clock630,clock7,clock730,clock8,clock830,clock9,clock930,closed_book,closed_lock_with_key,closed_umbrella,cloud,clubs,cn,cocktail,coffee,cold_sweat,collision,computer,confetti_ball,confounded,confused,congratulations,construction,construction_worker,convenience_store,cookie,cool,cop,copyright,corn,couple,couple_with_heart,couplekiss,cow,cow2,credit_card,crescent_moon,crocodile,crossed_flags,crown,cry,crying_cat_face,crystal_ball,cupid,curly_loop,currency_exchange,curry,custard,customs,cyclone,dancer,dancers,dango,dart,dash,date,de,deciduous_tree,department_store,diamond_shape_with_a_dot_inside,diamonds,disappointed,disappointed_relieved,dizzy,dizzy_face,do_not_litter,dog,dog2,dollar,dolls,dolphin,donut,door,doughnut,dragon,dragon_face,dress,dromedary_camel,droplet,dvd,e-mail,ear,ear_of_rice,earth_africa,earth_americas,earth_asia,egg,eggplant,eight,eight_pointed_black_star,eight_spoked_asterisk,electric_plug,elephant,email,end,envelope,es,euro,european_castle,european_post_office,evergreen_tree,exclamation,expressionless,eyeglasses,eyes,facepunch,factory,fallen_leaf,family,fast_forward,fax,fearful,feelsgood,feet,ferris_wheel,file_folder,finnadie,fire,fire_engine,fireworks,first_quarter_moon,first_quarter_moon_with_face,fish,fish_cake,fishing_pole_and_fish,fist,five,flags,flashlight,floppy_disk,flower_playing_cards,flushed,foggy,football,fork_and_knife,fountain,four,four_leaf_clover,fr,free,fried_shrimp,fries,frog,frowning,fu,fuelpump,full_moon,full_moon_with_face,game_die,gb,gem,gemini,ghost,gift,gift_heart,girl,globe_with_meridians,goat,goberserk,godmode,golf,grapes,green_apple,green_book,green_heart,grey_exclamation,grey_question,grimacing,grin,grinning,guardsman,guitar,gun,haircut,hamburger,hammer,hamster,hand,handbag,hankey,hash,hatched_chick,hatching_chick,headphones,hear_no_evil,heart,heart_decoration,heart_eyes,heart_eyes_cat,heartbeat,heartpulse,hearts,heavy_check_mark,heavy_division_sign,heavy_dollar_sign,heavy_exclamation_mark,heavy_minus_sign,heavy_multiplication_x,heavy_plus_sign,helicopter,herb,hibiscus,high_brightness,high_heel,hocho,honey_pot,honeybee,horse,horse_racing,hospital,hotel,hotsprings,hourglass,hourglass_flowing_sand,house,house_with_garden,hurtrealbad,hushed,ice_cream,icecream,id,ideograph_advantage,imp,inbox_tray,incoming_envelope,information_desk_person,information_source,innocent,interrobang,iphone,it,izakaya_lantern,jack_o_lantern,japan,japanese_castle,japanese_goblin,japanese_ogre,jeans,joy,joy_cat,jp,key,keycap_ten,kimono,kiss,kissing,kissing_cat,kissing_closed_eyes,kissing_face,kissing_heart,kissing_smiling_eyes,koala,koko,kr,large_blue_circle,large_blue_diamond,large_orange_diamond,last_quarter_moon,last_quarter_moon_with_face,laughing,leaves,ledger,left_luggage,left_right_arrow,leftwards_arrow_with_hook,lemon,leo,leopard,libra,light_rail,link,lips,lipstick,lock,lock_with_ink_pen,lollipop,loop,loudspeaker,love_hotel,love_letter,low_brightness,m,mag,mag_right,mahjong,mailbox,mailbox_closed,mailbox_with_mail,mailbox_with_no_mail,man,man_with_gua_pi_mao,man_with_turban,mans_shoe,maple_leaf,mask,massage,meat_on_bone,mega,melon,memo,mens,metal,metro,microphone,microscope,milky_way,minibus,minidisc,mobile_phone_off,money_with_wings,moneybag,monkey,monkey_face,monorail,mortar_board,mount_fuji,mountain_bicyclist,mountain_cableway,mountain_railway,mouse,mouse2,movie_camera,moyai,muscle,mushroom,musical_keyboard,musical_note,musical_score,mute,nail_care,name_badge,neckbeard,necktie,negative_squared_cross_mark,neutral_face,new,new_moon,new_moon_with_face,newspaper,ng,nine,no_bell,no_bicycles,no_entry,no_entry_sign,no_good,no_mobile_phones,no_mouth,no_pedestrians,no_smoking,non-potable_water,nose,notebook,notebook_with_decorative_cover,notes,nut_and_bolt,o,o2,ocean,octocat,octopus,oden,office,ok,ok_hand,ok_woman,older_man,older_woman,on,oncoming_automobile,oncoming_bus,oncoming_police_car,oncoming_taxi,one,open_file_folder,open_hands,open_mouth,ophiuchus,orange_book,outbox_tray,ox,package,page_facing_up,page_with_curl,pager,palm_tree,panda_face,paperclip,parking,part_alternation_mark,partly_sunny,passport_control,paw_prints,peach,pear,pencil,pencil2,penguin,pensive,performing_arts,persevere,person_frowning,person_with_blond_hair,person_with_pouting_face,phone,pig,pig2,pig_nose,pill,pineapple,pisces,pizza,plus1,point_down,point_left,point_right,point_up,point_up_2,police_car,poodle,poop,post_office,postal_horn,postbox,potable_water,pouch,poultry_leg,pound,pouting_cat,pray,princess,punch,purple_heart,purse,pushpin,put_litter_in_its_place,question,rabbit,rabbit2,racehorse,radio,radio_button,rage,rage1,rage2,rage3,rage4,railway_car,rainbow,raised_hand,raised_hands,raising_hand,ram,ramen,rat,recycle,red_car,red_circle,registered,relaxed,relieved,repeat,repeat_one,restroom,revolving_hearts,rewind,ribbon,rice,rice_ball,rice_cracker,rice_scene,ring,rocket,roller_coaster,rooster,rose,rotating_light,round_pushpin,rowboat,ru,rugby_football,runner,running,running_shirt_with_sash,sa,sagittarius,sailboat,sake,sandal,santa,satellite,satisfied,saxophone,school,school_satchel,scissors,scorpius,scream,scream_cat,scroll,seat,secret,see_no_evil,seedling,seven,shaved_ice,sheep,shell,ship,shipit,shirt,shit,shoe,shower,signal_strength,six,six_pointed_star,ski,skull,sleeping,sleepy,slot_machine,small_blue_diamond,small_orange_diamond,small_red_triangle,small_red_triangle_down,smile,smile_cat,smiley,smiley_cat,smiling_imp,smirk,smirk_cat,smoking,snail,snake,snowboarder,snowflake,snowman,sob,soccer,soon,sos,sound,space_invader,spades,spaghetti,sparkle,sparkler,sparkles,sparkling_heart,speak_no_evil,speaker,speech_balloon,speedboat,squirrel,star,star2,stars,station,statue_of_liberty,steam_locomotive,stew,straight_ruler,strawberry,stuck_out_tongue,stuck_out_tongue_closed_eyes,stuck_out_tongue_winking_eye,sun_with_face,sunflower,sunglasses,sunny,sunrise,sunrise_over_mountains,surfer,sushi,suspect,suspension_railway,sweat,sweat_drops,sweat_smile,sweet_potato,swimmer,symbols,syringe,tada,tanabata_tree,tangerine,taurus,taxi,tea,telephone,telephone_receiver,telescope,tennis,tent,thought_balloon,three,thumbsdown,thumbsup,ticket,tiger,tiger2,tired_face,tm,toilet,tokyo_tower,tomato,tongue,top,tophat,tractor,traffic_light,train,train2,tram,triangular_flag_on_post,triangular_ruler,trident,triumph,trolleybus,trollface,trophy,tropical_drink,tropical_fish,truck,trumpet,tshirt,tulip,turtle,tv,twisted_rightwards_arrows,two,two_hearts,two_men_holding_hands,two_women_holding_hands,u5272,u5408,u55b6,u6307,u6708,u6709,u6e80,u7121,u7533,u7981,u7a7a,uk,umbrella,unamused,underage,unlock,up,us,v,vertical_traffic_light,vhs,vibration_mode,video_camera,video_game,violin,virgo,volcano,vs,walking,waning_crescent_moon,waning_gibbous_moon,warning,watch,water_buffalo,watermelon,wave,wavy_dash,waxing_crescent_moon,waxing_gibbous_moon,wc,weary,wedding,whale,whale2,wheelchair,white_check_mark,white_circle,white_flower,white_large_square,white_medium_small_square,white_medium_square,white_small_square,white_square_button,wind_chime,wine_glass,wink,wolf,woman,womans_clothes,womans_hat,womens,worried,wrench,x,yellow_heart,yen,yum,zap,zero,zzz",g=u.split(/,/),m=g.reduce(function(e,a){return e[a]=!0,e},{}),d={blacklist:{ids:[],classes:["no-emojify"],elements:["script","textarea","a","pre","code"]},tag_type:null,only_crawl_id:null,img_dir:"images/emoji",ignore_emoticons:!1,mode:"img"},h={img:"img",sprite:"span","data-uri":"span"};return n.prototype={validate:function(e,a,r){function i(){return n.lastEmojiTerminatedAt=_+a,s}var n=this,s=t(e);if(s){var l=e[0],_=l.length;if(0===a)return i();if(r.length===l.length+a)return i();var c=this.lastEmojiTerminatedAt===a;if(c)return i();if(o(r.charAt(a-1)))return i();var u=o(r.charAt(l.length+a));return u&&c?i():void 0}}},{defaultConfig:d,emojiNames:g,setConfig:function(e){Object.keys(d).forEach(function(a){a in e&&(d[a]=e[a])})},replace:s,run:l}}();return e});
!function(t,e){"function"==typeof define&&define.amd?define([],e()):"object"==typeof module&&module.exports?t.zenscroll=e():t.zenscroll=e()}(this,function(){"use strict";if("undefined"==typeof window||!("document"in window))return{};var t=function(t,e,n){e=e||999,n||0===n||(n=9);var o,i=document.documentElement,r=function(){return"getComputedStyle"in window&&"smooth"===window.getComputedStyle(t?t:document.body)["scroll-behavior"]},c=function(){return t?t.scrollTop:window.scrollY||i.scrollTop},u=function(){return t?Math.min(t.offsetHeight,window.innerHeight):window.innerHeight||i.clientHeight},f=function(e){return t?e.offsetTop:e.getBoundingClientRect().top+c()-i.offsetTop},l=function(){clearTimeout(o),o=0},a=function(n,f,a){if(l(),r())(t||window).scrollTo(0,n),a&&a();else{var d=c(),s=Math.max(n,0)-d;f=f||Math.min(Math.abs(s),e);var m=(new Date).getTime();!function e(){o=setTimeout(function(){var n=Math.min(((new Date).getTime()-m)/f,1),o=Math.max(Math.floor(d+s*(n<.5?2*n*n:n*(4-2*n)-1)),0);t?t.scrollTop=o:window.scrollTo(0,o),n<1&&u()+o<(t||i).scrollHeight?e():(setTimeout(l,99),a&&a())},9)}()}},d=function(t,e,o){a(f(t)-n,e,o)},s=function(t,e,o){var i=t.getBoundingClientRect().height,r=f(t),l=r+i,s=u(),m=c(),h=m+s;r-n<m||i+n>s?d(t,e,o):l+n>h?a(l-s+n,e,o):o&&o()},m=function(t,e,n,o){a(Math.max(f(t)-u()/2+(n||t.getBoundingClientRect().height/2),0),e,o)},h=function(t,o){t&&(e=t),(0===o||o)&&(n=o)};return{setup:h,to:d,toY:a,intoView:s,center:m,stop:l,moving:function(){return!!o}}},e=t();if("addEventListener"in window&&"smooth"!==document.body.style.scrollBehavior&&!window.noZensmooth){var n=function(t){try{history.replaceState({},"",window.location.href.split("#")[0]+t)}catch(t){}};window.addEventListener("click",function(t){for(var o=t.target;o&&"A"!==o.tagName;)o=o.parentNode;if(!(!o||1!==t.which||t.shiftKey||t.metaKey||t.ctrlKey||t.altKey)){var i=o.getAttribute("href")||"";if(0===i.indexOf("#"))if("#"===i)t.preventDefault(),e.toY(0),n("");else{var r=o.hash.substring(1),c=document.getElementById(r);c&&(t.preventDefault(),e.to(c),n("#"+r))}}},!1)}return{createScroller:t,setup:e.setup,to:e.to,toY:e.toY,intoView:e.intoView,center:e.center,stop:e.stop,moving:e.moving}});

/*!
  * Reqwest! A general purpose XHR connection manager
  * license MIT (c) Dustin Diaz 2015
  * https://github.com/ded/reqwest
  */
!function(e,t,n){typeof module!="undefined"&&module.exports?t[e]=n():typeof define=="function"&&define.amd?define(n):t[e]=n()}("reqwest",this,function(){function succeed(e){var t=protocolRe.exec(e.url);return t=t&&t[1]||context.location.protocol,httpsRe.test(t)?twoHundo.test(e.request.status):!!e.request.response}function handleReadyState(e,t,n){return function(){if(e._aborted)return n(e.request);if(e._timedOut)return n(e.request,"Request is aborted: timeout");e.request&&e.request[readyState]==4&&(e.request.onreadystatechange=noop,succeed(e)?t(e.request):n(e.request))}}function setHeaders(e,t){var n=t.headers||{},r;n.Accept=n.Accept||defaultHeaders.accept[t.type]||defaultHeaders.accept["*"];var i=typeof FormData!="undefined"&&t.data instanceof FormData;!t.crossOrigin&&!n[requestedWith]&&(n[requestedWith]=defaultHeaders.requestedWith),!n[contentType]&&!i&&(n[contentType]=t.contentType||defaultHeaders.contentType);for(r in n)n.hasOwnProperty(r)&&"setRequestHeader"in e&&e.setRequestHeader(r,n[r])}function setCredentials(e,t){typeof t.withCredentials!="undefined"&&typeof e.withCredentials!="undefined"&&(e.withCredentials=!!t.withCredentials)}function generalCallback(e){lastValue=e}function urlappend(e,t){return e+(/\?/.test(e)?"&":"?")+t}function handleJsonp(e,t,n,r){var i=uniqid++,s=e.jsonpCallback||"callback",o=e.jsonpCallbackName||reqwest.getcallbackPrefix(i),u=new RegExp("((^|\\?|&)"+s+")=([^&]+)"),a=r.match(u),f=doc.createElement("script"),l=0,c=navigator.userAgent.indexOf("MSIE 10.0")!==-1;return a?a[3]==="?"?r=r.replace(u,"$1="+o):o=a[3]:r=urlappend(r,s+"="+o),context[o]=generalCallback,f.type="text/javascript",f.src=r,f.async=!0,typeof f.onreadystatechange!="undefined"&&!c&&(f.htmlFor=f.id="_reqwest_"+i),f.onload=f.onreadystatechange=function(){if(f[readyState]&&f[readyState]!=="complete"&&f[readyState]!=="loaded"||l)return!1;f.onload=f.onreadystatechange=null,f.onclick&&f.onclick(),t(lastValue),lastValue=undefined,head.removeChild(f),l=1},head.appendChild(f),{abort:function(){f.onload=f.onreadystatechange=null,n({},"Request is aborted: timeout",{}),lastValue=undefined,head.removeChild(f),l=1}}}function getRequest(e,t){var n=this.o,r=(n.method||"GET").toUpperCase(),i=typeof n=="string"?n:n.url,s=n.processData!==!1&&n.data&&typeof n.data!="string"?reqwest.toQueryString(n.data):n.data||null,o,u=!1;return(n["type"]=="jsonp"||r=="GET")&&s&&(i=urlappend(i,s),s=null),n["type"]=="jsonp"?handleJsonp(n,e,t,i):(o=n.xhr&&n.xhr(n)||xhr(n),o.open(r,i,n.async===!1?!1:!0),setHeaders(o,n),setCredentials(o,n),context[xDomainRequest]&&o instanceof context[xDomainRequest]?(o.onload=e,o.onerror=t,o.onprogress=function(){},u=!0):o.onreadystatechange=handleReadyState(this,e,t),n.before&&n.before(o),u?setTimeout(function(){o.send(s)},200):o.send(s),o)}function Reqwest(e,t){this.o=e,this.fn=t,init.apply(this,arguments)}function setType(e){if(e===null)return undefined;if(e.match("json"))return"json";if(e.match("javascript"))return"js";if(e.match("text"))return"html";if(e.match("xml"))return"xml"}function init(o,fn){function complete(e){o.timeout&&clearTimeout(self.timeout),self.timeout=null;while(self._completeHandlers.length>0)self._completeHandlers.shift()(e)}function success(resp){var type=o.type||resp&&setType(resp.getResponseHeader("Content-Type"));resp=type!=="jsonp"?self.request:resp;var filteredResponse=globalSetupOptions.dataFilter(resp.responseText,type),r=filteredResponse;try{resp.responseText=r}catch(e){}if(r)switch(type){case"json":try{resp=context.JSON?context.JSON.parse(r):eval("("+r+")")}catch(err){return error(resp,"Could not parse JSON in response",err)}break;case"js":resp=eval(r);break;case"html":resp=r;break;case"xml":resp=resp.responseXML&&resp.responseXML.parseError&&resp.responseXML.parseError.errorCode&&resp.responseXML.parseError.reason?null:resp.responseXML}self._responseArgs.resp=resp,self._fulfilled=!0,fn(resp),self._successHandler(resp);while(self._fulfillmentHandlers.length>0)resp=self._fulfillmentHandlers.shift()(resp);complete(resp)}function timedOut(){self._timedOut=!0,self.request.abort()}function error(e,t,n){e=self.request,self._responseArgs.resp=e,self._responseArgs.msg=t,self._responseArgs.t=n,self._erred=!0;while(self._errorHandlers.length>0)self._errorHandlers.shift()(e,t,n);complete(e)}this.url=typeof o=="string"?o:o.url,this.timeout=null,this._fulfilled=!1,this._successHandler=function(){},this._fulfillmentHandlers=[],this._errorHandlers=[],this._completeHandlers=[],this._erred=!1,this._responseArgs={};var self=this;fn=fn||function(){},o.timeout&&(this.timeout=setTimeout(function(){timedOut()},o.timeout)),o.success&&(this._successHandler=function(){o.success.apply(o,arguments)}),o.error&&this._errorHandlers.push(function(){o.error.apply(o,arguments)}),o.complete&&this._completeHandlers.push(function(){o.complete.apply(o,arguments)}),this.request=getRequest.call(this,success,error)}function reqwest(e,t){return new Reqwest(e,t)}function normalize(e){return e?e.replace(/\r?\n/g,"\r\n"):""}function serial(e,t){var n=e.name,r=e.tagName.toLowerCase(),i=function(e){e&&!e.disabled&&t(n,normalize(e.attributes.value&&e.attributes.value.specified?e.value:e.text))},s,o,u,a;if(e.disabled||!n)return;switch(r){case"input":/reset|button|image|file/i.test(e.type)||(s=/checkbox/i.test(e.type),o=/radio/i.test(e.type),u=e.value,(!s&&!o||e.checked)&&t(n,normalize(s&&u===""?"on":u)));break;case"textarea":t(n,normalize(e.value));break;case"select":if(e.type.toLowerCase()==="select-one")i(e.selectedIndex>=0?e.options[e.selectedIndex]:null);else for(a=0;e.length&&a<e.length;a++)e.options[a].selected&&i(e.options[a])}}function eachFormElement(){var e=this,t,n,r=function(t,n){var r,i,s;for(r=0;r<n.length;r++){s=t[byTag](n[r]);for(i=0;i<s.length;i++)serial(s[i],e)}};for(n=0;n<arguments.length;n++)t=arguments[n],/input|select|textarea/i.test(t.tagName)&&serial(t,e),r(t,["input","select","textarea"])}function serializeQueryString(){return reqwest.toQueryString(reqwest.serializeArray.apply(null,arguments))}function serializeHash(){var e={};return eachFormElement.apply(function(t,n){t in e?(e[t]&&!isArray(e[t])&&(e[t]=[e[t]]),e[t].push(n)):e[t]=n},arguments),e}function buildParams(e,t,n,r){var i,s,o,u=/\[\]$/;if(isArray(t))for(s=0;t&&s<t.length;s++)o=t[s],n||u.test(e)?r(e,o):buildParams(e+"["+(typeof o=="object"?s:"")+"]",o,n,r);else if(t&&t.toString()==="[object Object]")for(i in t)buildParams(e+"["+i+"]",t[i],n,r);else r(e,t)}var context=this;if("window"in context)var doc=document,byTag="getElementsByTagName",head=doc[byTag]("head")[0];else{var XHR2;try{XHR2=require("xhr2")}catch(ex){throw new Error("Peer dependency `xhr2` required! Please npm install xhr2")}}var httpsRe=/^http/,protocolRe=/(^\w+):\/\//,twoHundo=/^(20\d|1223)$/,readyState="readyState",contentType="Content-Type",requestedWith="X-Requested-With",uniqid=0,callbackPrefix="reqwest_"+ +(new Date),lastValue,xmlHttpRequest="XMLHttpRequest",xDomainRequest="XDomainRequest",noop=function(){},isArray=typeof Array.isArray=="function"?Array.isArray:function(e){return e instanceof Array},defaultHeaders={contentType:"application/x-www-form-urlencoded",requestedWith:xmlHttpRequest,accept:{"*":"text/javascript, text/html, application/xml, text/xml, */*",xml:"application/xml, text/xml",html:"text/html",text:"text/plain",json:"application/json, text/javascript",js:"application/javascript, text/javascript"}},xhr=function(e){if(e.crossOrigin===!0){var t=context[xmlHttpRequest]?new XMLHttpRequest:null;if(t&&"withCredentials"in t)return t;if(context[xDomainRequest])return new XDomainRequest;throw new Error("Browser does not support cross-origin requests")}return context[xmlHttpRequest]?new XMLHttpRequest:XHR2?new XHR2:new ActiveXObject("Microsoft.XMLHTTP")},globalSetupOptions={dataFilter:function(e){return e}};return Reqwest.prototype={abort:function(){this._aborted=!0,this.request.abort()},retry:function(){init.call(this,this.o,this.fn)},then:function(e,t){return e=e||function(){},t=t||function(){},this._fulfilled?this._responseArgs.resp=e(this._responseArgs.resp):this._erred?t(this._responseArgs.resp,this._responseArgs.msg,this._responseArgs.t):(this._fulfillmentHandlers.push(e),this._errorHandlers.push(t)),this},always:function(e){return this._fulfilled||this._erred?e(this._responseArgs.resp):this._completeHandlers.push(e),this},fail:function(e){return this._erred?e(this._responseArgs.resp,this._responseArgs.msg,this._responseArgs.t):this._errorHandlers.push(e),this},"catch":function(e){return this.fail(e)}},reqwest.serializeArray=function(){var e=[];return eachFormElement.apply(function(t,n){e.push({name:t,value:n})},arguments),e},reqwest.serialize=function(){if(arguments.length===0)return"";var e,t,n=Array.prototype.slice.call(arguments,0);return e=n.pop(),e&&e.nodeType&&n.push(e)&&(e=null),e&&(e=e.type),e=="map"?t=serializeHash:e=="array"?t=reqwest.serializeArray:t=serializeQueryString,t.apply(null,n)},reqwest.toQueryString=function(e,t){var n,r,i=t||!1,s=[],o=encodeURIComponent,u=function(e,t){t="function"==typeof t?t():t==null?"":t,s[s.length]=o(e)+"="+o(t)};if(isArray(e))for(r=0;e&&r<e.length;r++)u(e[r].name,e[r].value);else for(n in e)e.hasOwnProperty(n)&&buildParams(n,e[n],i,u);return s.join("&").replace(/%20/g,"+")},reqwest.getcallbackPrefix=function(){return callbackPrefix},reqwest.compat=function(e,t){return e&&(e.type&&(e.method=e.type)&&delete e.type,e.dataType&&(e.type=e.dataType),e.jsonpCallback&&(e.jsonpCallbackName=e.jsonpCallback)&&delete e.jsonpCallback,e.jsonp&&(e.jsonpCallback=e.jsonp)),new Reqwest(e,t)},reqwest.ajaxSetup=function(e){e=e||{};for(var t in e)globalSetupOptions[t]=e[t]},reqwest})

// NOTE : CUSTOM EDIT : Added a "!" just before the function below. Else, it can trigger an error in production code due to concatenation.
!(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.toMarkdown = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
/*
 * to-markdown - an HTML to Markdown converter
 *
 * Copyright 2011+, Dom Christie
 * Licenced under the MIT licence
 *
 */

'use strict'

var toMarkdown
var converters
var mdConverters = require('./lib/md-converters')
var gfmConverters = require('./lib/gfm-converters')
var HtmlParser = require('./lib/html-parser')
var collapse = require('collapse-whitespace')

/*
 * Utilities
 */

var blocks = ['address', 'article', 'aside', 'audio', 'blockquote', 'body',
  'canvas', 'center', 'dd', 'dir', 'div', 'dl', 'dt', 'fieldset', 'figcaption',
  'figure', 'footer', 'form', 'frameset', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6',
  'header', 'hgroup', 'hr', 'html', 'isindex', 'li', 'main', 'menu', 'nav',
  'noframes', 'noscript', 'ol', 'output', 'p', 'pre', 'section', 'table',
  'tbody', 'td', 'tfoot', 'th', 'thead', 'tr', 'ul'
]

function isBlock (node) {
  return blocks.indexOf(node.nodeName.toLowerCase()) !== -1
}

var voids = [
  'area', 'base', 'br', 'col', 'command', 'embed', 'hr', 'img', 'input',
  'keygen', 'link', 'meta', 'param', 'source', 'track', 'wbr'
]

function isVoid (node) {
  return voids.indexOf(node.nodeName.toLowerCase()) !== -1
}

function htmlToDom (string) {
  var tree = new HtmlParser().parseFromString(string, 'text/html')
  collapse(tree.documentElement, isBlock)
  return tree
}

/*
 * Flattens DOM tree into single array
 */

function bfsOrder (node) {
  var inqueue = [node]
  var outqueue = []
  var elem
  var children
  var i

  while (inqueue.length > 0) {
    elem = inqueue.shift()
    outqueue.push(elem)
    children = elem.childNodes
    for (i = 0; i < children.length; i++) {
      if (children[i].nodeType === 1) inqueue.push(children[i])
    }
  }
  outqueue.shift()
  return outqueue
}

/*
 * Contructs a Markdown string of replacement text for a given node
 */

function getContent (node) {
  var text = ''
  for (var i = 0; i < node.childNodes.length; i++) {
    if (node.childNodes[i].nodeType === 1) {
      text += node.childNodes[i]._replacement
    } else if (node.childNodes[i].nodeType === 3) {
      text += node.childNodes[i].data
    } else continue
  }
  return text
}

/*
 * Returns the HTML string of an element with its contents converted
 */

function outer (node, content) {
  return node.cloneNode(false).outerHTML.replace('><', '>' + content + '<')
}

function canConvert (node, filter) {
  if (typeof filter === 'string') {
    return filter === node.nodeName.toLowerCase()
  }
  if (Array.isArray(filter)) {
    return filter.indexOf(node.nodeName.toLowerCase()) !== -1
  } else if (typeof filter === 'function') {
    return filter.call(toMarkdown, node)
  } else {
    throw new TypeError('`filter` needs to be a string, array, or function')
  }
}

function isFlankedByWhitespace (side, node) {
  var sibling
  var regExp
  var isFlanked

  if (side === 'left') {
    sibling = node.previousSibling
    regExp = / $/
  } else {
    sibling = node.nextSibling
    regExp = /^ /
  }

  if (sibling) {
    if (sibling.nodeType === 3) {
      isFlanked = regExp.test(sibling.nodeValue)
    } else if (sibling.nodeType === 1 && !isBlock(sibling)) {
      isFlanked = regExp.test(sibling.textContent)
    }
  }
  return isFlanked
}

function flankingWhitespace (node, content) {
  var leading = ''
  var trailing = ''

  if (!isBlock(node)) {
    var hasLeading = /^[ \r\n\t]/.test(content)
    var hasTrailing = /[ \r\n\t]$/.test(content)

    if (hasLeading && !isFlankedByWhitespace('left', node)) {
      leading = ' '
    }
    if (hasTrailing && !isFlankedByWhitespace('right', node)) {
      trailing = ' '
    }
  }

  return { leading: leading, trailing: trailing }
}

/*
 * Finds a Markdown converter, gets the replacement, and sets it on
 * `_replacement`
 */

function process (node) {
  var replacement
  var content = getContent(node)

  // Remove blank nodes
  if (!isVoid(node) && !/A|TH|TD/.test(node.nodeName) && /^\s*$/i.test(content)) {
    node._replacement = ''
    return
  }

  for (var i = 0; i < converters.length; i++) {
    var converter = converters[i]

    if (canConvert(node, converter.filter)) {
      if (typeof converter.replacement !== 'function') {
        throw new TypeError(
          '`replacement` needs to be a function that returns a string'
        )
      }

      var whitespace = flankingWhitespace(node, content)

      if (whitespace.leading || whitespace.trailing) {
        content = content.trim()
      }
      replacement = whitespace.leading +
        converter.replacement.call(toMarkdown, content, node) +
        whitespace.trailing
      break
    }
  }

  node._replacement = replacement
}

toMarkdown = function (input, options) {
  options = options || {}

  if (typeof input !== 'string') {
    throw new TypeError(input + ' is not a string')
  }

  // Escape potential ol triggers
  input = input.replace(/(\d+)\. /g, '$1\\. ')

  var clone = htmlToDom(input).body
  var nodes = bfsOrder(clone)
  var output

  converters = mdConverters.slice(0)
  if (options.gfm) {
    converters = gfmConverters.concat(converters)
  }

  if (options.converters) {
    converters = options.converters.concat(converters)
  }

  // Process through nodes in reverse (so deepest child elements are first).
  for (var i = nodes.length - 1; i >= 0; i--) {
    process(nodes[i])
  }
  output = getContent(clone)

  return output.replace(/^[\t\r\n]+|[\t\r\n\s]+$/g, '')
    .replace(/\n\s+\n/g, '\n\n')
    .replace(/\n{3,}/g, '\n\n')
}

toMarkdown.isBlock = isBlock
toMarkdown.isVoid = isVoid
toMarkdown.outer = outer

module.exports = toMarkdown

},{"./lib/gfm-converters":2,"./lib/html-parser":3,"./lib/md-converters":4,"collapse-whitespace":7}],2:[function(require,module,exports){
'use strict'

function cell (content, node) {
  var index = Array.prototype.indexOf.call(node.parentNode.childNodes, node)
  var prefix = ' '
  if (index === 0) prefix = '| '
  return prefix + content + ' |'
}

var highlightRegEx = /highlight highlight-(\S+)/

module.exports = [
  {
    filter: 'br',
    replacement: function () {
      return '\n'
    }
  },
  {
    filter: ['del', 's', 'strike'],
    replacement: function (content) {
      return '~~' + content + '~~'
    }
  },

  {
    filter: function (node) {
      return node.type === 'checkbox' && node.parentNode.nodeName === 'LI'
    },
    replacement: function (content, node) {
      return (node.checked ? '[x]' : '[ ]') + ' '
    }
  },

  {
    filter: ['th', 'td'],
    replacement: function (content, node) {
      return cell(content, node)
    }
  },

  {
    filter: 'tr',
    replacement: function (content, node) {
      var borderCells = ''
      var alignMap = { left: ':--', right: '--:', center: ':-:' }

      if (node.parentNode.nodeName === 'THEAD') {
        for (var i = 0; i < node.childNodes.length; i++) {
          var align = node.childNodes[i].attributes.align
          var border = '---'

          if (align) border = alignMap[align.value] || border

          borderCells += cell(border, node.childNodes[i])
        }
      }
      return '\n' + content + (borderCells ? '\n' + borderCells : '')
    }
  },

  {
    filter: 'table',
    replacement: function (content) {
      return '\n\n' + content + '\n\n'
    }
  },

  {
    filter: ['thead', 'tbody', 'tfoot'],
    replacement: function (content) {
      return content
    }
  },

  // Fenced code blocks
  {
    filter: function (node) {
      return node.nodeName === 'PRE' &&
      node.firstChild &&
      node.firstChild.nodeName === 'CODE'
    },
    replacement: function (content, node) {
      return '\n\n```\n' + node.firstChild.textContent + '\n```\n\n'
    }
  },

  // Syntax-highlighted code blocks
  {
    filter: function (node) {
      return node.nodeName === 'PRE' &&
      node.parentNode.nodeName === 'DIV' &&
      highlightRegEx.test(node.parentNode.className)
    },
    replacement: function (content, node) {
      var language = node.parentNode.className.match(highlightRegEx)[1]
      return '\n\n```' + language + '\n' + node.textContent + '\n```\n\n'
    }
  },

  {
    filter: function (node) {
      return node.nodeName === 'DIV' &&
      highlightRegEx.test(node.className)
    },
    replacement: function (content) {
      return '\n\n' + content + '\n\n'
    }
  }
]

},{}],3:[function(require,module,exports){
/*
 * Set up window for Node.js
 */

var _window = (typeof window !== 'undefined' ? window : this)

/*
 * Parsing HTML strings
 */

function canParseHtmlNatively () {
  var Parser = _window.DOMParser
  var canParse = false

  // Adapted from https://gist.github.com/1129031
  // Firefox/Opera/IE throw errors on unsupported types
  try {
    // WebKit returns null on unsupported types
    if (new Parser().parseFromString('', 'text/html')) {
      canParse = true
    }
  } catch (e) {}

  return canParse
}

function createHtmlParser () {
  var Parser = function () {}

  // For Node.js environments
  if (typeof document === 'undefined') {
    var jsdom = require('jsdom')
    Parser.prototype.parseFromString = function (string) {
      return jsdom.jsdom(string, {
        features: {
          FetchExternalResources: [],
          ProcessExternalResources: false
        }
      })
    }
  } else {
    if (!shouldUseActiveX()) {
      Parser.prototype.parseFromString = function (string) {
        var doc = document.implementation.createHTMLDocument('')
        doc.open()
        doc.write(string)
        doc.close()
        return doc
      }
    } else {
      Parser.prototype.parseFromString = function (string) {
        var doc = new window.ActiveXObject('htmlfile')
        doc.designMode = 'on' // disable on-page scripts
        doc.open()
        doc.write(string)
        doc.close()
        return doc
      }
    }
  }
  return Parser
}

function shouldUseActiveX () {
  var useActiveX = false

  try {
    document.implementation.createHTMLDocument('').open()
  } catch (e) {
    if (window.ActiveXObject) useActiveX = true
  }

  return useActiveX
}

module.exports = canParseHtmlNatively() ? _window.DOMParser : createHtmlParser()

},{"jsdom":6}],4:[function(require,module,exports){
'use strict'

module.exports = [
  {
    filter: 'p',
    replacement: function (content) {
      return '\n\n' + content + '\n\n'
    }
  },

  {
    filter: 'br',
    replacement: function () {
      return '  \n'
    }
  },

  {
    filter: ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'],
    replacement: function (content, node) {
      var hLevel = node.nodeName.charAt(1)
      var hPrefix = ''
      for (var i = 0; i < hLevel; i++) {
        hPrefix += '#'
      }
      return '\n\n' + hPrefix + ' ' + content + '\n\n'
    }
  },

  {
    filter: 'hr',
    replacement: function () {
      return '\n\n* * *\n\n'
    }
  },

  {
    filter: ['em', 'i'],
    replacement: function (content) {
      return '_' + content + '_'
    }
  },

  {
    filter: ['strong', 'b'],
    replacement: function (content) {
      return '**' + content + '**'
    }
  },

  // Inline code
  {
    filter: function (node) {
      var hasSiblings = node.previousSibling || node.nextSibling
      var isCodeBlock = node.parentNode.nodeName === 'PRE' && !hasSiblings

      return node.nodeName === 'CODE' && !isCodeBlock
    },
    replacement: function (content) {
      return '`' + content + '`'
    }
  },

  {
    filter: function (node) {
      return node.nodeName === 'A' && node.getAttribute('href')
    },
    replacement: function (content, node) {
      var titlePart = node.title ? ' "' + node.title + '"' : ''
      return '[' + content + '](' + node.getAttribute('href') + titlePart + ')'
    }
  },

  {
    filter: 'img',
    replacement: function (content, node) {
      var alt = node.alt || ''
      var src = node.getAttribute('src') || ''
      var title = node.title || ''
      var titlePart = title ? ' "' + title + '"' : ''
      return src ? '![' + alt + ']' + '(' + src + titlePart + ')' : ''
    }
  },

  // Code blocks
  {
    filter: function (node) {
      return node.nodeName === 'PRE' && node.firstChild.nodeName === 'CODE'
    },
    replacement: function (content, node) {
      return '\n\n    ' + node.firstChild.textContent.replace(/\n/g, '\n    ') + '\n\n'
    }
  },

  {
    filter: 'blockquote',
    replacement: function (content) {
      content = content.trim()
      content = content.replace(/\n{3,}/g, '\n\n')
      content = content.replace(/^/gm, '> ')
      return '\n\n' + content + '\n\n'
    }
  },

  {
    filter: 'li',
    replacement: function (content, node) {
      content = content.replace(/^\s+/, '').replace(/\n/gm, '\n    ')
      var prefix = '*   '
      var parent = node.parentNode
      var index = Array.prototype.indexOf.call(parent.children, node) + 1

      prefix = /ol/i.test(parent.nodeName) ? index + '.  ' : '*   '
      return prefix + content
    }
  },

  {
    filter: ['ul', 'ol'],
    replacement: function (content, node) {
      var strings = []
      for (var i = 0; i < node.childNodes.length; i++) {
        strings.push(node.childNodes[i]._replacement)
      }

      if (/li/i.test(node.parentNode.nodeName)) {
        return '\n' + strings.join('\n')
      }
      return '\n\n' + strings.join('\n') + '\n\n'
    }
  },

  {
    filter: function (node) {
      return this.isBlock(node)
    },
    replacement: function (content, node) {
      return '\n\n' + this.outer(node, content) + '\n\n'
    }
  },

  // Anything else!
  {
    filter: function () {
      return true
    },
    replacement: function (content, node) {
      return this.outer(node, content)
    }
  }
]

},{}],5:[function(require,module,exports){
/**
 * This file automatically generated from `build.js`.
 * Do not manually edit.
 */

module.exports = [
  "address",
  "article",
  "aside",
  "audio",
  "blockquote",
  "canvas",
  "dd",
  "div",
  "dl",
  "fieldset",
  "figcaption",
  "figure",
  "footer",
  "form",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "header",
  "hgroup",
  "hr",
  "main",
  "nav",
  "noscript",
  "ol",
  "output",
  "p",
  "pre",
  "section",
  "table",
  "tfoot",
  "ul",
  "video"
];

},{}],6:[function(require,module,exports){

},{}],7:[function(require,module,exports){
'use strict';

var voidElements = require('void-elements');
Object.keys(voidElements).forEach(function (name) {
  voidElements[name.toUpperCase()] = 1;
});

var blockElements = {};
require('block-elements').forEach(function (name) {
  blockElements[name.toUpperCase()] = 1;
});

/**
 * isBlockElem(node) determines if the given node is a block element.
 *
 * @param {Node} node
 * @return {Boolean}
 */
function isBlockElem(node) {
  return !!(node && blockElements[node.nodeName]);
}

/**
 * isVoid(node) determines if the given node is a void element.
 *
 * @param {Node} node
 * @return {Boolean}
 */
function isVoid(node) {
  return !!(node && voidElements[node.nodeName]);
}

/**
 * whitespace(elem [, isBlock]) removes extraneous whitespace from an
 * the given element. The function isBlock may optionally be passed in
 * to determine whether or not an element is a block element; if none
 * is provided, defaults to using the list of block elements provided
 * by the `block-elements` module.
 *
 * @param {Node} elem
 * @param {Function} blockTest
 */
function collapseWhitespace(elem, isBlock) {
  if (!elem.firstChild || elem.nodeName === 'PRE') return;

  if (typeof isBlock !== 'function') {
    isBlock = isBlockElem;
  }

  var prevText = null;
  var prevVoid = false;

  var prev = null;
  var node = next(prev, elem);

  while (node !== elem) {
    if (node.nodeType === 3) {
      // Node.TEXT_NODE
      var text = node.data.replace(/[ \r\n\t]+/g, ' ');

      if ((!prevText || / $/.test(prevText.data)) && !prevVoid && text[0] === ' ') {
        text = text.substr(1);
      }

      // `text` might be empty at this point.
      if (!text) {
        node = remove(node);
        continue;
      }

      node.data = text;
      prevText = node;
    } else if (node.nodeType === 1) {
      // Node.ELEMENT_NODE
      if (isBlock(node) || node.nodeName === 'BR') {
        if (prevText) {
          prevText.data = prevText.data.replace(/ $/, '');
        }

        prevText = null;
        prevVoid = false;
      } else if (isVoid(node)) {
        // Avoid trimming space around non-block, non-BR void elements.
        prevText = null;
        prevVoid = true;
      }
    } else {
      node = remove(node);
      continue;
    }

    var nextNode = next(prev, node);
    prev = node;
    node = nextNode;
  }

  if (prevText) {
    prevText.data = prevText.data.replace(/ $/, '');
    if (!prevText.data) {
      remove(prevText);
    }
  }
}

/**
 * remove(node) removes the given node from the DOM and returns the
 * next node in the sequence.
 *
 * @param {Node} node
 * @return {Node} node
 */
function remove(node) {
  var next = node.nextSibling || node.parentNode;

  node.parentNode.removeChild(node);

  return next;
}

/**
 * next(prev, current) returns the next node in the sequence, given the
 * current and previous nodes.
 *
 * @param {Node} prev
 * @param {Node} current
 * @return {Node}
 */
function next(prev, current) {
  if (prev && prev.parentNode === current || current.nodeName === 'PRE') {
    return current.nextSibling || current.parentNode;
  }

  return current.firstChild || current.nextSibling || current.parentNode;
}

module.exports = collapseWhitespace;

},{"block-elements":5,"void-elements":8}],8:[function(require,module,exports){
/**
 * This file automatically generated from `pre-publish.js`.
 * Do not manually edit.
 */

module.exports = {
  "area": true,
  "base": true,
  "br": true,
  "col": true,
  "embed": true,
  "hr": true,
  "img": true,
  "input": true,
  "keygen": true,
  "link": true,
  "menuitem": true,
  "meta": true,
  "param": true,
  "source": true,
  "track": true,
  "wbr": true
};

},{}]},{},[1])(1)
});
/**
 * marked - a markdown parser
 * Copyright (c) 2011-2014, Christopher Jeffrey. (MIT Licensed)
 * https://github.com/chjj/marked
 */
(function(){var block={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:noop,hr:/^( *[-*_]){3,} *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *#* *(?:\n+|$)/,nptable:noop,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,blockquote:/^( *>[^\n]+(\n(?!def)[^\n]+)*\n*)+/,list:/^( *)(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:/^ *(?:comment *(?:\n|\s*$)|closed *(?:\n{2,}|\s*$)|closing *(?:\n{2,}|\s*$))/,def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +["(]([^\n]+)[")])? *(?:\n+|$)/,table:noop,paragraph:/^((?:[^\n]+\n?(?!hr|heading|lheading|blockquote|tag|def))+)\n*/,text:/^[^\n]+/};block.bullet=/(?:[*+-]|\d+\.)/;block.item=/^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/;block.item=replace(block.item,"gm")(/bull/g,block.bullet)();block.list=replace(block.list)(/bull/g,block.bullet)("hr","\\n+(?=\\1?(?:[-*_] *){3,}(?:\\n+|$))")("def","\\n+(?="+block.def.source+")")();block.blockquote=replace(block.blockquote)("def",block.def)();block._tag="(?!(?:"+"a|em|strong|small|s|cite|q|dfn|abbr|data|time|code"+"|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo"+"|span|br|wbr|ins|del|img)\\b)\\w+(?!:/|[^\\w\\s@]*@)\\b";block.html=replace(block.html)("comment",/<!--[\s\S]*?-->/)("closed",/<(tag)[\s\S]+?<\/\1>/)("closing",/<tag(?:"[^"]*"|'[^']*'|[^'">])*?>/)(/tag/g,block._tag)();block.paragraph=replace(block.paragraph)("hr",block.hr)("heading",block.heading)("lheading",block.lheading)("blockquote",block.blockquote)("tag","<"+block._tag)("def",block.def)();block.normal=merge({},block);block.gfm=merge({},block.normal,{fences:/^ *(`{3,}|~{3,})[ \.]*(\S+)? *\n([\s\S]*?)\s*\1 *(?:\n+|$)/,paragraph:/^/,heading:/^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/});block.gfm.paragraph=replace(block.paragraph)("(?!","(?!"+block.gfm.fences.source.replace("\\1","\\2")+"|"+block.list.source.replace("\\1","\\3")+"|")();block.tables=merge({},block.gfm,{nptable:/^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,table:/^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/});function Lexer(options){this.tokens=[];this.tokens.links={};this.options=options||marked.defaults;this.rules=block.normal;if(this.options.gfm){if(this.options.tables){this.rules=block.tables}else{this.rules=block.gfm}}}Lexer.rules=block;Lexer.lex=function(src,options){var lexer=new Lexer(options);return lexer.lex(src)};Lexer.prototype.lex=function(src){src=src.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n");return this.token(src,true)};Lexer.prototype.token=function(src,top,bq){var src=src.replace(/^ +$/gm,""),next,loose,cap,bull,b,item,space,i,l;while(src){if(cap=this.rules.newline.exec(src)){src=src.substring(cap[0].length);if(cap[0].length>1){this.tokens.push({type:"space"})}}if(cap=this.rules.code.exec(src)){src=src.substring(cap[0].length);cap=cap[0].replace(/^ {4}/gm,"");this.tokens.push({type:"code",text:!this.options.pedantic?cap.replace(/\n+$/,""):cap});continue}if(cap=this.rules.fences.exec(src)){src=src.substring(cap[0].length);this.tokens.push({type:"code",lang:cap[2],text:cap[3]||""});continue}if(cap=this.rules.heading.exec(src)){src=src.substring(cap[0].length);this.tokens.push({type:"heading",depth:cap[1].length,text:cap[2]});continue}if(top&&(cap=this.rules.nptable.exec(src))){src=src.substring(cap[0].length);item={type:"table",header:cap[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:cap[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:cap[3].replace(/\n$/,"").split("\n")};for(i=0;i<item.align.length;i++){if(/^ *-+: *$/.test(item.align[i])){item.align[i]="right"}else if(/^ *:-+: *$/.test(item.align[i])){item.align[i]="center"}else if(/^ *:-+ *$/.test(item.align[i])){item.align[i]="left"}else{item.align[i]=null}}for(i=0;i<item.cells.length;i++){item.cells[i]=item.cells[i].split(/ *\| */)}this.tokens.push(item);continue}if(cap=this.rules.lheading.exec(src)){src=src.substring(cap[0].length);this.tokens.push({type:"heading",depth:cap[2]==="="?1:2,text:cap[1]});continue}if(cap=this.rules.hr.exec(src)){src=src.substring(cap[0].length);this.tokens.push({type:"hr"});continue}if(cap=this.rules.blockquote.exec(src)){src=src.substring(cap[0].length);this.tokens.push({type:"blockquote_start"});cap=cap[0].replace(/^ *> ?/gm,"");this.token(cap,top,true);this.tokens.push({type:"blockquote_end"});continue}if(cap=this.rules.list.exec(src)){src=src.substring(cap[0].length);bull=cap[2];this.tokens.push({type:"list_start",ordered:bull.length>1});cap=cap[0].match(this.rules.item);next=false;l=cap.length;i=0;for(;i<l;i++){item=cap[i];space=item.length;item=item.replace(/^ *([*+-]|\d+\.) +/,"");if(~item.indexOf("\n ")){space-=item.length;item=!this.options.pedantic?item.replace(new RegExp("^ {1,"+space+"}","gm"),""):item.replace(/^ {1,4}/gm,"")}if(this.options.smartLists&&i!==l-1){b=block.bullet.exec(cap[i+1])[0];if(bull!==b&&!(bull.length>1&&b.length>1)){src=cap.slice(i+1).join("\n")+src;i=l-1}}loose=next||/\n\n(?!\s*$)/.test(item);if(i!==l-1){next=item.charAt(item.length-1)==="\n";if(!loose)loose=next}this.tokens.push({type:loose?"loose_item_start":"list_item_start"});this.token(item,false,bq);this.tokens.push({type:"list_item_end"})}this.tokens.push({type:"list_end"});continue}if(cap=this.rules.html.exec(src)){src=src.substring(cap[0].length);this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:!this.options.sanitizer&&(cap[1]==="pre"||cap[1]==="script"||cap[1]==="style"),text:cap[0]});continue}if(!bq&&top&&(cap=this.rules.def.exec(src))){src=src.substring(cap[0].length);this.tokens.links[cap[1].toLowerCase()]={href:cap[2],title:cap[3]};continue}if(top&&(cap=this.rules.table.exec(src))){src=src.substring(cap[0].length);item={type:"table",header:cap[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:cap[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:cap[3].replace(/(?: *\| *)?\n$/,"").split("\n")};for(i=0;i<item.align.length;i++){if(/^ *-+: *$/.test(item.align[i])){item.align[i]="right"}else if(/^ *:-+: *$/.test(item.align[i])){item.align[i]="center"}else if(/^ *:-+ *$/.test(item.align[i])){item.align[i]="left"}else{item.align[i]=null}}for(i=0;i<item.cells.length;i++){item.cells[i]=item.cells[i].replace(/^ *\| *| *\| *$/g,"").split(/ *\| */)}this.tokens.push(item);continue}if(top&&(cap=this.rules.paragraph.exec(src))){src=src.substring(cap[0].length);this.tokens.push({type:"paragraph",text:cap[1].charAt(cap[1].length-1)==="\n"?cap[1].slice(0,-1):cap[1]});continue}if(cap=this.rules.text.exec(src)){src=src.substring(cap[0].length);this.tokens.push({type:"text",text:cap[0]});continue}if(src){throw new Error("Infinite loop on byte: "+src.charCodeAt(0))}}return this.tokens};var inline={escape:/^\\([\\`*{}\[\]()#+\-.!_>])/,autolink:/^<([^ >]+(@|:\/)[^ >]+)>/,url:noop,tag:/^<!--[\s\S]*?-->|^<\/?\w+(?:"[^"]*"|'[^']*'|[^'">])*?>/,link:/^!?\[(inside)\]\(href\)/,reflink:/^!?\[(inside)\]\s*\[([^\]]*)\]/,nolink:/^!?\[((?:\[[^\]]*\]|[^\[\]])*)\]/,strong:/^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,em:/^\b_((?:[^_]|__)+?)_\b|^\*((?:\*\*|[\s\S])+?)\*(?!\*)/,code:/^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,br:/^ {2,}\n(?!\s*$)/,del:noop,text:/^[\s\S]+?(?=[\\<!\[_*`]| {2,}\n|$)/};inline._inside=/(?:\[[^\]]*\]|[^\[\]]|\](?=[^\[]*\]))*/;inline._href=/\s*<?([\s\S]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*/;inline.link=replace(inline.link)("inside",inline._inside)("href",inline._href)();inline.reflink=replace(inline.reflink)("inside",inline._inside)();inline.normal=merge({},inline);inline.pedantic=merge({},inline.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/});inline.gfm=merge({},inline.normal,{escape:replace(inline.escape)("])","~|])")(),url:/^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/,del:/^~~(?=\S)([\s\S]*?\S)~~/,text:replace(inline.text)("]|","~]|")("|","|https?://|")()});inline.breaks=merge({},inline.gfm,{br:replace(inline.br)("{2,}","*")(),text:replace(inline.gfm.text)("{2,}","*")()});function InlineLexer(links,options){this.options=options||marked.defaults;this.links=links;this.rules=inline.normal;this.renderer=this.options.renderer||new Renderer;this.renderer.options=this.options;if(!this.links){throw new Error("Tokens array requires a `links` property.")}if(this.options.gfm){if(this.options.breaks){this.rules=inline.breaks}else{this.rules=inline.gfm}}else if(this.options.pedantic){this.rules=inline.pedantic}}InlineLexer.rules=inline;InlineLexer.output=function(src,links,options){var inline=new InlineLexer(links,options);return inline.output(src)};InlineLexer.prototype.output=function(src){var out="",link,text,href,cap;while(src){if(cap=this.rules.escape.exec(src)){src=src.substring(cap[0].length);out+=cap[1];continue}if(cap=this.rules.autolink.exec(src)){src=src.substring(cap[0].length);if(cap[2]==="@"){text=cap[1].charAt(6)===":"?this.mangle(cap[1].substring(7)):this.mangle(cap[1]);href=this.mangle("mailto:")+text}else{text=escape(cap[1]);href=text}out+=this.renderer.link(href,null,text);continue}if(!this.inLink&&(cap=this.rules.url.exec(src))){src=src.substring(cap[0].length);text=escape(cap[1]);href=text;out+=this.renderer.link(href,null,text);continue}if(cap=this.rules.tag.exec(src)){if(!this.inLink&&/^<a /i.test(cap[0])){this.inLink=true}else if(this.inLink&&/^<\/a>/i.test(cap[0])){this.inLink=false}src=src.substring(cap[0].length);out+=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(cap[0]):escape(cap[0]):cap[0];continue}if(cap=this.rules.link.exec(src)){src=src.substring(cap[0].length);this.inLink=true;out+=this.outputLink(cap,{href:cap[2],title:cap[3]});this.inLink=false;continue}if((cap=this.rules.reflink.exec(src))||(cap=this.rules.nolink.exec(src))){src=src.substring(cap[0].length);link=(cap[2]||cap[1]).replace(/\s+/g," ");link=this.links[link.toLowerCase()];if(!link||!link.href){out+=cap[0].charAt(0);src=cap[0].substring(1)+src;continue}this.inLink=true;out+=this.outputLink(cap,link);this.inLink=false;continue}if(cap=this.rules.strong.exec(src)){src=src.substring(cap[0].length);out+=this.renderer.strong(this.output(cap[2]||cap[1]));continue}if(cap=this.rules.em.exec(src)){src=src.substring(cap[0].length);out+=this.renderer.em(this.output(cap[2]||cap[1]));continue}if(cap=this.rules.code.exec(src)){src=src.substring(cap[0].length);out+=this.renderer.codespan(escape(cap[2],true));continue}if(cap=this.rules.br.exec(src)){src=src.substring(cap[0].length);out+=this.renderer.br();continue}if(cap=this.rules.del.exec(src)){src=src.substring(cap[0].length);out+=this.renderer.del(this.output(cap[1]));continue}if(cap=this.rules.text.exec(src)){src=src.substring(cap[0].length);out+=this.renderer.text(escape(this.smartypants(cap[0])));continue}if(src){throw new Error("Infinite loop on byte: "+src.charCodeAt(0))}}return out};InlineLexer.prototype.outputLink=function(cap,link){var href=escape(link.href),title=link.title?escape(link.title):null;return cap[0].charAt(0)!=="!"?this.renderer.link(href,title,this.output(cap[1])):this.renderer.image(href,title,escape(cap[1]))};InlineLexer.prototype.smartypants=function(text){if(!this.options.smartypants)return text;return text.replace(/---/g,"—").replace(/--/g,"–").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1‘").replace(/'/g,"’").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1“").replace(/"/g,"”").replace(/\.{3}/g,"…")};InlineLexer.prototype.mangle=function(text){if(!this.options.mangle)return text;var out="",l=text.length,i=0,ch;for(;i<l;i++){ch=text.charCodeAt(i);if(Math.random()>.5){ch="x"+ch.toString(16)}out+="&#"+ch+";"}return out};function Renderer(options){this.options=options||{}}Renderer.prototype.code=function(code,lang,escaped){if(this.options.highlight){var out=this.options.highlight(code,lang);if(out!=null&&out!==code){escaped=true;code=out}}if(!lang){return"<pre><code>"+(escaped?code:escape(code,true))+"\n</code></pre>"}return'<pre><code class="'+this.options.langPrefix+escape(lang,true)+'">'+(escaped?code:escape(code,true))+"\n</code></pre>\n"};Renderer.prototype.blockquote=function(quote){return"<blockquote>\n"+quote+"</blockquote>\n"};Renderer.prototype.html=function(html){return html};Renderer.prototype.heading=function(text,level,raw){return"<h"+level+' id="'+this.options.headerPrefix+raw.toLowerCase().replace(/[^\w]+/g,"-")+'">'+text+"</h"+level+">\n"};Renderer.prototype.hr=function(){return this.options.xhtml?"<hr/>\n":"<hr>\n"};Renderer.prototype.list=function(body,ordered){var type=ordered?"ol":"ul";return"<"+type+">\n"+body+"</"+type+">\n"};Renderer.prototype.listitem=function(text){return"<li>"+text+"</li>\n"};Renderer.prototype.paragraph=function(text){return"<p>"+text+"</p>\n"};Renderer.prototype.table=function(header,body){return"<table>\n"+"<thead>\n"+header+"</thead>\n"+"<tbody>\n"+body+"</tbody>\n"+"</table>\n"};Renderer.prototype.tablerow=function(content){return"<tr>\n"+content+"</tr>\n"};Renderer.prototype.tablecell=function(content,flags){var type=flags.header?"th":"td";var tag=flags.align?"<"+type+' style="text-align:'+flags.align+'">':"<"+type+">";return tag+content+"</"+type+">\n"};Renderer.prototype.strong=function(text){return"<strong>"+text+"</strong>"};Renderer.prototype.em=function(text){return"<em>"+text+"</em>"};Renderer.prototype.codespan=function(text){return"<code>"+text+"</code>"};Renderer.prototype.br=function(){return this.options.xhtml?"<br/>":"<br>"};Renderer.prototype.del=function(text){return"<del>"+text+"</del>"};Renderer.prototype.link=function(href,title,text){if(this.options.sanitize){try{var prot=decodeURIComponent(unescape(href)).replace(/[^\w:]/g,"").toLowerCase()}catch(e){return""}if(prot.indexOf("javascript:")===0||prot.indexOf("vbscript:")===0){return""}}var out='<a href="'+href+'"';if(title){out+=' title="'+title+'"'}out+=">"+text+"</a>";return out};Renderer.prototype.image=function(href,title,text){var out='<img src="'+href+'" alt="'+text+'"';if(title){out+=' title="'+title+'"'}out+=this.options.xhtml?"/>":">";return out};Renderer.prototype.text=function(text){return text};function Parser(options){this.tokens=[];this.token=null;this.options=options||marked.defaults;this.options.renderer=this.options.renderer||new Renderer;this.renderer=this.options.renderer;this.renderer.options=this.options}Parser.parse=function(src,options,renderer){var parser=new Parser(options,renderer);return parser.parse(src)};Parser.prototype.parse=function(src){this.inline=new InlineLexer(src.links,this.options,this.renderer);this.tokens=src.reverse();var out="";while(this.next()){out+=this.tok()}return out};Parser.prototype.next=function(){return this.token=this.tokens.pop()};Parser.prototype.peek=function(){return this.tokens[this.tokens.length-1]||0};Parser.prototype.parseText=function(){var body=this.token.text;while(this.peek().type==="text"){body+="\n"+this.next().text}return this.inline.output(body)};Parser.prototype.tok=function(){switch(this.token.type){case"space":{return""}case"hr":{return this.renderer.hr()}case"heading":{return this.renderer.heading(this.inline.output(this.token.text),this.token.depth,this.token.text)}case"code":{return this.renderer.code(this.token.text,this.token.lang,this.token.escaped)}case"table":{var header="",body="",i,row,cell,flags,j;cell="";for(i=0;i<this.token.header.length;i++){flags={header:true,align:this.token.align[i]};cell+=this.renderer.tablecell(this.inline.output(this.token.header[i]),{header:true,align:this.token.align[i]})}header+=this.renderer.tablerow(cell);for(i=0;i<this.token.cells.length;i++){row=this.token.cells[i];cell="";for(j=0;j<row.length;j++){cell+=this.renderer.tablecell(this.inline.output(row[j]),{header:false,align:this.token.align[j]})}body+=this.renderer.tablerow(cell)}return this.renderer.table(header,body)}case"blockquote_start":{var body="";while(this.next().type!=="blockquote_end"){body+=this.tok()}return this.renderer.blockquote(body)}case"list_start":{var body="",ordered=this.token.ordered;while(this.next().type!=="list_end"){body+=this.tok()}return this.renderer.list(body,ordered)}case"list_item_start":{var body="";while(this.next().type!=="list_item_end"){body+=this.token.type==="text"?this.parseText():this.tok()}return this.renderer.listitem(body)}case"loose_item_start":{var body="";while(this.next().type!=="list_item_end"){body+=this.tok()}return this.renderer.listitem(body)}case"html":{var html=!this.token.pre&&!this.options.pedantic?this.inline.output(this.token.text):this.token.text;return this.renderer.html(html)}case"paragraph":{return this.renderer.paragraph(this.inline.output(this.token.text))}case"text":{return this.renderer.paragraph(this.parseText())}}};function escape(html,encode){return html.replace(!encode?/&(?!#?\w+;)/g:/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function unescape(html){return html.replace(/&([#\w]+);/g,function(_,n){n=n.toLowerCase();if(n==="colon")return":";if(n.charAt(0)==="#"){return n.charAt(1)==="x"?String.fromCharCode(parseInt(n.substring(2),16)):String.fromCharCode(+n.substring(1))}return""})}function replace(regex,opt){regex=regex.source;opt=opt||"";return function self(name,val){if(!name)return new RegExp(regex,opt);val=val.source||val;val=val.replace(/(^|[^\[])\^/g,"$1");regex=regex.replace(name,val);return self}}function noop(){}noop.exec=noop;function merge(obj){var i=1,target,key;for(;i<arguments.length;i++){target=arguments[i];for(key in target){if(Object.prototype.hasOwnProperty.call(target,key)){obj[key]=target[key]}}}return obj}function marked(src,opt,callback){if(callback||typeof opt==="function"){if(!callback){callback=opt;opt=null}opt=merge({},marked.defaults,opt||{});var highlight=opt.highlight,tokens,pending,i=0;try{tokens=Lexer.lex(src,opt)}catch(e){return callback(e)}pending=tokens.length;var done=function(err){if(err){opt.highlight=highlight;return callback(err)}var out;try{out=Parser.parse(tokens,opt)}catch(e){err=e}opt.highlight=highlight;return err?callback(err):callback(null,out)};if(!highlight||highlight.length<3){return done()}delete opt.highlight;if(!pending)return done();for(;i<tokens.length;i++){(function(token){if(token.type!=="code"){return--pending||done()}return highlight(token.text,token.lang,function(err,code){if(err)return done(err);if(code==null||code===token.text){return--pending||done()}token.text=code;token.escaped=true;--pending||done()})})(tokens[i])}return}try{if(opt)opt=merge({},marked.defaults,opt);return Parser.parse(Lexer.lex(src,opt),opt)}catch(e){e.message+="\nPlease report this to https://github.com/chjj/marked.";if((opt||marked.defaults).silent){return"<p>An error occured:</p><pre>"+escape(e.message+"",true)+"</pre>"}throw e}}marked.options=marked.setOptions=function(opt){merge(marked.defaults,opt);return marked};marked.defaults={gfm:true,tables:true,breaks:false,pedantic:false,sanitize:false,sanitizer:null,mangle:true,smartLists:false,silent:false,highlight:null,langPrefix:"lang-",smartypants:false,headerPrefix:"",renderer:new Renderer,xhtml:false};marked.Parser=Parser;marked.parser=Parser.parse;marked.Renderer=Renderer;marked.Lexer=Lexer;marked.lexer=Lexer.lex;marked.InlineLexer=InlineLexer;marked.inlineLexer=InlineLexer.output;marked.parse=marked;if(typeof module!=="undefined"&&typeof exports==="object"){module.exports=marked}else if(typeof define==="function"&&define.amd){define(function(){return marked})}else{this.marked=marked}}).call(function(){return this||(typeof window!=="undefined"?window:global)}());
function UrlParser(){"use strict";this.plugins={}}function cloneObject(a){"use strict";if(null===a||"object"!=typeof a)return a;var b=a.constructor();for(var c in a)a.hasOwnProperty(c)&&(b[c]=cloneObject(a[c]));return b}function getQueryParams(a){"use strict";if("string"!=typeof a)return{};a=a.split("+").join(" ");var b,c={},d=a.match(/(?:[\?](?:[^=]+)=(?:[^&#]*)(?:[&](?:[^=]+)=(?:[^&#]*))*(?:[#].*)?)|(?:[#].*)/);if(null===d)return{};b=d[0].substr(1).split(/[&#=]/);for(var e=0;e<b.length;e+=2)c[decodeURIComponent(b[e])]=decodeURIComponent(b[e+1]||"");return c}function combineParams(a){"use strict";if("object"!=typeof a)return"";a.params=a.params||{};var b="",c=0,d=Object.keys(a.params);if(0===d.length)return"";for(d.sort(),a.hasParams||(b+="?"+d[0]+"="+a.params[d[0]],c+=1);c<d.length;c+=1)b+="&"+d[c]+"="+a.params[d[c]];return b}function getTime(a){"use strict";var b,c=0,d={s:1,m:60,h:3600,d:86400,w:604800};if(!a.match(/^(\d+[smhdw]?)+$/))return 0;a=a.replace(/([smhdw])/g," $1 ").trim(),b=a.split(" ");for(var e=0;e<b.length;e+=2)c+=parseInt(b[e],10)*d[b[e+1]||"s"];return c}function CanalPlus(){"use strict";this.provider="canalplus",this.defaultFormat="embed",this.formats={embed:this.createEmbedUrl},this.mediaTypes={VIDEO:"video"}}function Coub(){"use strict";this.provider="coub",this.defaultFormat="long",this.formats={"long":this.createLongUrl,embed:this.createEmbedUrl},this.mediaTypes={VIDEO:"video"}}function Dailymotion(){"use strict";this.provider="dailymotion",this.alternatives=["dai"],this.defaultFormat="long",this.formats={"short":this.createShortUrl,"long":this.createLongUrl,embed:this.createEmbedUrl},this.mediaTypes={VIDEO:"video"}}function Twitch(){"use strict";this.provider="twitch",this.defaultFormat="long",this.formats={"long":this.createLongUrl,embed:this.createEmbedUrl},this.mediaTypes={VIDEO:"video",STREAM:"stream",EMBEDVIDEO:"embed-video"}}function Vimeo(){"use strict";this.provider="vimeo",this.alternatives=["vimeopro"],this.defaultFormat="long",this.formats={"long":this.createLongUrl,embed:this.createEmbedUrl},this.mediaTypes={VIDEO:"video"}}function YouTube(){"use strict";this.provider="youtube",this.alternatives=["youtu","ytimg"],this.defaultFormat="long",this.formats={"short":this.createShortUrl,"long":this.createLongUrl,embed:this.createEmbedUrl,shortImage:this.createShortImageUrl,longImage:this.createLongImageUrl},this.imageQualities={0:"0",1:"1",2:"2",3:"3",DEFAULT:"default",HQDEFAULT:"hqdefault",SDDEFAULT:"sddefault",MQDEFAULT:"mqdefault",MAXRESDEFAULT:"maxresdefault"},this.defaultImageQuality=this.imageQualities.HQDEFAULT,this.mediaTypes={VIDEO:"video",PLAYLIST:"playlist",SHARE:"share"}}function Youku(){"use strict";this.provider="youku",this.defaultFormat="embed",this.formats={embed:this.createEmbedUrl,"long":this.createLongUrl,flash:this.createFlashUrl,"static":this.createStaticUrl},this.mediaTypes={VIDEO:"video"}}UrlParser.prototype.parseProvider=function(a){"use strict";var b=a.match(/(?:(?:https?:)?\/\/)?(?:[^\.]+\.)?(\w+)\./i);return b?b[1]:void 0},UrlParser.prototype.removeEmptyParameters=function(a){"use strict";return a.params&&0===Object.keys(a.params).length&&delete a.params,a},UrlParser.prototype.parse=function(a){"use strict";var b,c=this,d=c.parseProvider(a),e=c.plugins[d];return d&&e&&e.parse?(b=e.parse.apply(e,[a,getQueryParams(a)]),b&&(b=c.removeEmptyParameters(b),b.provider=e.provider),b):void 0},UrlParser.prototype.bind=function(a){"use strict";if(this.plugins[a.provider]=a,a.alternatives)for(var b=0;b<a.alternatives.length;b+=1)this.plugins[a.alternatives[b]]=a},UrlParser.prototype.create=function(a){"use strict";var b=a.videoInfo,c=a.params,d=this.plugins[b.provider];return c="internal"===c?b.params:c||{},d&&(a.format=a.format||d.defaultFormat,d.formats.hasOwnProperty(a.format))?d.formats[a.format].apply(d,[b,cloneObject(c)]):void 0};var urlParser=new UrlParser;"undefined"!=typeof module&&"undefined"!=typeof module.exports&&(module.exports=urlParser),CanalPlus.prototype.parseParameters=function(a){"use strict";return delete a.vid,a},CanalPlus.prototype.parse=function(a,b){"use strict";var c=this,d={mediaType:this.mediaTypes.VIDEO,id:b.vid};return d.params=c.parseParameters(b),d.id?d:void 0},CanalPlus.prototype.createEmbedUrl=function(a,b){"use strict";var c="http://player.canalplus.fr/embed/";return b.vid=a.id,c+=combineParams({params:b})},urlParser.bind(new CanalPlus),Coub.prototype.parseUrl=function(a){"use strict";var b=a.match(/(?:embed|view)\/([a-zA-Z\d]+)/i);return b?b[1]:void 0},Coub.prototype.parse=function(a,b){"use strict";var c={mediaType:this.mediaTypes.VIDEO,params:b,id:this.parseUrl(a)};return c.id?c:void 0},Coub.prototype.createUrl=function(a,b,c){"use strict";var d=a+b.id;return d+=combineParams({params:c})},Coub.prototype.createLongUrl=function(a,b){"use strict";return this.createUrl("https://coub.com/view/",a,b)},Coub.prototype.createEmbedUrl=function(a,b){"use strict";return this.createUrl("//coub.com/embed/",a,b)},urlParser.bind(new Coub),Dailymotion.prototype.parseParameters=function(a){"use strict";return this.parseTime(a)},Dailymotion.prototype.parseTime=function(a){"use strict";return a.start&&(a.start=getTime(a.start)),a},Dailymotion.prototype.parseUrl=function(a){"use strict";var b=a.match(/(?:\/video|ly)\/([A-Za-z0-9]+)/i);return b?b[1]:void 0},Dailymotion.prototype.parse=function(a,b){"use strict";var c=this,d={mediaType:this.mediaTypes.VIDEO,params:c.parseParameters(b),id:c.parseUrl(a)};return d.id?d:void 0},Dailymotion.prototype.createUrl=function(a,b,c){"use strict";return a+b.id+combineParams({params:c})},Dailymotion.prototype.createShortUrl=function(a){"use strict";return this.createUrl("https://dai.ly/",a,{})},Dailymotion.prototype.createLongUrl=function(a,b){"use strict";return this.createUrl("https://dailymotion.com/video/",a,b)},Dailymotion.prototype.createEmbedUrl=function(a,b){"use strict";return this.createUrl("//www.dailymotion.com/embed/video/",a,b)},urlParser.bind(new Dailymotion),Twitch.prototype.seperateId=function(a){"use strict";return{pre:a[0],id:a.substr(1)}},Twitch.prototype.parseChannel=function(a,b){"use strict";var c=b.channel||b.utm_content||a.channel;return delete b.utm_content,delete b.channel,c},Twitch.prototype.parseUrl=function(a,b,c){"use strict";var d;return d=a.match(/twitch\.tv\/(\w+)(?:\/(.)\/(\d+))?/i),b.channel=d?d[1]:void 0,d&&d[2]&&d[3]?b.id=d[2]+d[3]:c.video&&(b.id=c.video,delete c.video),b},Twitch.prototype.parseMediaType=function(a){"use strict";var b;return a.channel?b=a.id?this.mediaTypes.VIDEO:this.mediaTypes.STREAM:a.id&&(b=this.mediaTypes.EMBEDVIDEO,delete a.channel),b},Twitch.prototype.parseParameters=function(a){"use strict";return a.t&&(a.start=getTime(a.t),delete a.t),a},Twitch.prototype.parse=function(a,b){"use strict";var c=this,d={};return d=c.parseUrl(a,d,b),d.channel=c.parseChannel(d,b),d.mediaType=c.parseMediaType(d),d.params=c.parseParameters(b),d.channel||d.id?d:void 0},Twitch.prototype.createLongUrl=function(a,b){"use strict";var c="";if(a.mediaType===this.mediaTypes.STREAM)c="https://twitch.tv/"+a.channel;else if(a.mediaType===this.mediaTypes.VIDEO){var d=this.seperateId(a.id);c="https://twitch.tv/"+a.channel+"/"+d.pre+"/"+d.id,b.start&&(b.t=b.start+"s",delete b.start)}return c+=combineParams({params:b})},Twitch.prototype.createEmbedUrl=function(a,b){"use strict";var c="https://player.twitch.tv/";return a.mediaType===this.mediaTypes.STREAM?b.channel=a.channel:(a.mediaType===this.mediaTypes.VIDEO||a.mediaType===this.mediaTypes.EMBEDVIDEO)&&(b.video=a.id,b.start&&(b.t=b.start+"s",delete b.start)),c+=combineParams({params:b})},urlParser.bind(new Twitch),Vimeo.prototype.parseUrl=function(a){"use strict";var b=a.match(/(?:\/(?:channels\/[\w]+|(?:(?:album\/\d+|groups\/[\w]+)\/)?videos?))?\/(\d+)/i);return b?b[1]:void 0},Vimeo.prototype.parseParameters=function(a){"use strict";return this.parseTime(a)},Vimeo.prototype.parseTime=function(a){"use strict";return a.t&&(a.start=getTime(a.t),delete a.t),a},Vimeo.prototype.parse=function(a,b){"use strict";var c={mediaType:this.mediaTypes.VIDEO,params:this.parseParameters(b),id:this.parseUrl(a)};return c.id?c:void 0},Vimeo.prototype.createUrl=function(a,b,c){"use strict";var d=a+b.id,e=c.start;return delete c.start,d+=combineParams({params:c}),e&&(d+="#t="+e),d},Vimeo.prototype.createLongUrl=function(a,b){"use strict";return this.createUrl("https://vimeo.com/",a,b)},Vimeo.prototype.createEmbedUrl=function(a,b){"use strict";return this.createUrl("//player.vimeo.com/video/",a,b)},urlParser.bind(new Vimeo),YouTube.prototype.parseUrl=function(a){"use strict";var b=a.match(/(?:(?:v|vi|be|videos|embed)\/(?!videoseries)|(?:v|ci)=)([\w\-]{11})/i);return b?b[1]:void 0},YouTube.prototype.parseTime=function(a){"use strict";return a.start=getTime(a.start||a.t),delete a.t,a},YouTube.prototype.parseParameters=function(a,b){"use strict";return(a.start||a.t)&&(a.start=getTime(a.start||a.t),delete a.t),a.v===b.id&&delete a.v,a.list===b.id&&delete a.list,a},YouTube.prototype.parseMediaType=function(a){"use strict";if(a.params.list&&(a.list=a.params.list,delete a.params.list),a.id&&!a.params.ci)a.mediaType=this.mediaTypes.VIDEO;else if(a.list)delete a.id,a.mediaType=this.mediaTypes.PLAYLIST;else{if(!a.params.ci)return void 0;delete a.params.ci,a.mediaType=this.mediaTypes.SHARE}return a},YouTube.prototype.parse=function(a,b){"use strict";var c=this,d={params:b,id:c.parseUrl(a)};return d.params=c.parseParameters(b,d),d=c.parseMediaType(d)},YouTube.prototype.createShortUrl=function(a,b){"use strict";var c="https://youtu.be/"+a.id;return b.start&&(c+="#t="+b.start),c},YouTube.prototype.createLongUrl=function(a,b){"use strict";var c="",d=b.start;return delete b.start,a.mediaType===this.mediaTypes.PLAYLIST?(b.feature="share",c+="https://youtube.com/playlist"):a.mediaType===this.mediaTypes.VIDEO?(b.v=a.id,c+="https://youtube.com/watch"):a.mediaType===this.mediaTypes.SHARE&&(b.ci=a.id,c+="https://www.youtube.com/shared"),a.list&&(b.list=a.list),c+=combineParams({params:b}),a.mediaType!==this.mediaTypes.PLAYLIST&&d&&(c+="#t="+d),c},YouTube.prototype.createEmbedUrl=function(a,b){"use strict";var c="//youtube.com/embed";return a.mediaType===this.mediaTypes.PLAYLIST?b.listType="playlist":(c+="/"+a.id,"1"===b.loop&&(b.playlist=a.id)),a.list&&(b.list=a.list),c+=combineParams({params:b})},YouTube.prototype.createImageUrl=function(a,b,c){"use strict";var d=a+b.id+"/",e=c.imageQuality||this.defaultImageQuality;return d+e+".jpg"},YouTube.prototype.createShortImageUrl=function(a,b){"use strict";return this.createImageUrl("https://i.ytimg.com/vi/",a,b)},YouTube.prototype.createLongImageUrl=function(a,b){"use strict";return this.createImageUrl("https://img.youtube.com/vi/",a,b)},urlParser.bind(new YouTube),Youku.prototype.parseUrl=function(a){"use strict";var b=a.match(/(?:(?:embed|sid)\/|v_show\/id_|VideoIDS=)([a-zA-Z0-9]+)/);return b?b[1]:void 0},Youku.prototype.parseParameters=function(a){"use strict";return a.VideoIDS&&delete a.VideoIDS,a},Youku.prototype.parse=function(a,b){"use strict";var c=this,d={mediaType:this.mediaTypes.VIDEO,id:c.parseUrl(a),params:c.parseParameters(b)};return d.id?d:void 0},Youku.prototype.createUrl=function(a,b,c){"use strict";var d=a+b.id;return d+=combineParams({params:c})},Youku.prototype.createEmbedUrl=function(a,b){"use strict";return this.createUrl("http://player.youku.com/embed/",a,b)},Youku.prototype.createLongUrl=function(a,b){"use strict";return this.createUrl("http://v.youku.com/v_show/id_",a,b)},Youku.prototype.createStaticUrl=function(a,b){"use strict";return this.createUrl("http://static.youku.com/v1.0.0638/v/swf/loader.swf?VideoIDS=",a,b)},Youku.prototype.createFlashUrl=function(a,b){"use strict";var c="http://player.youku.com/player.php/sid/"+a.id+"/v.swf";return c+=combineParams({params:b})},urlParser.bind(new Youku);
N.Functions.IO = {};


N.Functions.IO.funcIOErrorCheck = (Parameters) => {
  try {
    // Execute and return whatever funcToTry returns
    return Parameters.funcToTry();
  }
  catch (Error) {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'io-error' });
    if (Parameters.funcCatch) {
      Parameters.funcCatch();
    }

    console.error(Error);
    return false;
  }
};



N.Functions.IO.funcReadFile = (Parameter) => {
  // Return whatever funcToTry returns
  return N.Functions.IO.funcIOErrorCheck({ funcToTry: () => {
    return N.ElectronFramework.Fs.readFileSync(Parameter.strPath, 'utf8');
  } });
};



N.Functions.IO.funcLoadSettings = () => {
  N.Settings;

  try {
    N.Settings = JSON.parse( N.ElectronFramework.Fs.readFileSync(N.strSettingsFilePath, 'utf8') );
    N.Functions.IO.funcSettingsLegacy();
  }
  catch (Error) {
    N.Settings = {
      boolWindowFrame: false,
      boolFirstStart: true,
      strUIThemeSlug: '_ORIGINAL_white-room',
      strUILangSlug: 'english',
      boolAutoUpdateCheck: true,
      boolLinuxControlsRight: false
    };

    N.Functions.IO.funcSaveSettings();
  }
};



N.Functions.IO.funcSaveSettings = () => {
  N.Functions.IO.funcIOErrorCheck({ funcToTry: () => {
    N.ElectronFramework.Fs.writeFileSync(N.strSettingsFilePath, JSON.stringify(N.Settings), 'utf8');
  } });
};



// Settings object compatibility with previous versions of the app
N.Functions.IO.funcSettingsLegacy = () => {
  let boolModified = false;

  if( ! N.Settings.hasOwnProperty('boolWindowFrame')) {
    N.Settings.boolWindowFrame = false;
    boolModified = true;
  }
  if( ! N.Settings.hasOwnProperty('boolLinuxControlsRight')) {
    N.Settings.boolLinuxControlsRight = false;
    boolModified = true;
  }

  if (boolModified) {
    N.Functions.IO.funcSaveSettings();
  }
};



N.Functions.IO.funcLoadDocThemesLibs = () => {
  N.Functions.IO.funcIOErrorCheck({ funcToTry: () => {
    const strDocThemesLibrariesPath = `${N.strAppPath}/themes/doc-themes/lib`;
    N.DocThemesLibraries = {};

    // Lib
    N.DocThemesLibraries.strNormalizeCSS = N.ElectronFramework.Fs.readFileSync(`${strDocThemesLibrariesPath}/normalize.custom.min.css`, 'utf8');

    N.DocThemesLibraries.strHighlightJS = N.ElectronFramework.Fs.readFileSync(`${strDocThemesLibrariesPath}/highlight.pack.custom.min.js`, 'utf8');

    N.DocThemesLibraries.strEmojisCSS = N.ElectronFramework.Fs.readFileSync(`${strDocThemesLibrariesPath}/emojify.pack.min.css`, 'utf8');
    N.DocThemesLibraries.strEmojisJS = N.ElectronFramework.Fs.readFileSync(`${strDocThemesLibrariesPath}/emojify.min.js`, 'utf8');

    // Common code
    N.DocThemesLibraries.strDocumentCSS = N.ElectronFramework.Fs.readFileSync(`${strDocThemesLibrariesPath}/document.css`, 'utf8');
    N.DocThemesLibraries.strDocumentJS = N.ElectronFramework.Fs.readFileSync(`${strDocThemesLibrariesPath}/document.js`, 'utf8');
  } });
};



N.Functions.IO.funcLoadEmojis = () => {
  // Return whatever funcToTry returns
  return N.Functions.IO.funcIOErrorCheck({ funcToTry: () => {
    // https://github.com/github/gemoji/blob/master/db/emoji.json
    return JSON.parse( N.ElectronFramework.Fs.readFileSync(`${N.strAppPath}/json/emojis-list.json`, 'utf8') );
  } });
};



// Parameters :
// - strSavePath
// - strFormat
// - strDocThemeSlug
// - $ContentEditable
N.Functions.IO.funcSaveDoc = (Parameters) => {
  // Return whatever funcToTry returns
  return N.Functions.IO.funcIOErrorCheck({ funcToTry: () => {
    const $ContentEditableClone = Parameters.$ContentEditable.cloneNode(true);

    const strDocThemePath = `${N.strAppPath}/themes/doc-themes/themes-dir/${Parameters.strDocThemeSlug}`;
    let strDocContent = '';

    if (Parameters.strFormat === 'HTML') {
      N.Functions.Content.funcClearHTMLForHTMLExport({ $ContentEditable: $ContentEditableClone });

      strDocContent = N.ElectronFramework.Fs.readFileSync(`${strDocThemePath}/template.html`, 'utf8');

      const strHighlightThemeCSS = N.ElectronFramework.Fs.readFileSync(`${strDocThemePath}/highlight.js-theme.min.css`, 'utf8');
      const strDocThemeCSS = N.ElectronFramework.Fs.readFileSync(`${strDocThemePath}/style.css`, 'utf8');

      const strDocThemeJS = N.ElectronFramework.Fs.readFileSync(`${strDocThemePath}/script.js`, 'utf8');

      // Lib
      strDocContent = strDocContent.replace('/* __normalizecss */', N.DocThemesLibraries.strNormalizeCSS);

      if ($ContentEditableClone.getElementsByTagName('pre').length) {
        strDocContent = strDocContent.replace('/* __highlightthemecss */', strHighlightThemeCSS);
        strDocContent = strDocContent.replace('/* __highlightjs */', N.DocThemesLibraries.strHighlightJS);
      } else {
        strDocContent = strDocContent.replace('/* __highlightthemecss */', '');
        strDocContent = strDocContent.replace('/* __highlightjs */', '');
      }

      if ($ContentEditableClone.getElementsByClassName('emoji').length) {
        strDocContent = strDocContent.replace('/* __emojifycss */', N.DocThemesLibraries.strEmojisCSS);
        strDocContent = strDocContent.replace('/* __emojifyjs */', N.DocThemesLibraries.strEmojisJS);
      } else {
        strDocContent = strDocContent.replace('/* __emojifycss */', '');
        strDocContent = strDocContent.replace('/* __emojifyjs */', '');
      }

      // Common code
      strDocContent = strDocContent.replace('/* __documentcss */', N.DocThemesLibraries.strDocumentCSS);
      strDocContent = strDocContent.replace('/* __documentjs */', N.DocThemesLibraries.strDocumentJS);

      // Doc theme code
      strDocContent = strDocContent.replace('/* __docthemecss */', strDocThemeCSS);
      strDocContent = strDocContent.replace('/* __docthemejs */', strDocThemeJS);

      // HTML content replace at the end, to avoid regexp false detection with previous strings
      strDocContent = strDocContent.replace('<!-- __documentcontent -->', $ContentEditableClone.innerHTML);
    }


    else if (Parameters.strFormat === 'Markdown') {
      N.Functions.Content.funcClearHTMLForMarkdownExport({ $ContentEditable: $ContentEditableClone });
      strDocContent = N.Functions.Utils.funcHTMLToMarkdown({ strContent: $ContentEditableClone.innerHTML });
    }

    N.ElectronFramework.Fs.writeFileSync(Parameters.strSavePath, strDocContent, 'utf8');

    return true;
  } });
};



// Parameters :
// - strPath
// - strFormat
N.Functions.IO.funcLoadDoc = (Parameters) => {
  // Return whatever funcToTry returns
  return N.Functions.IO.funcIOErrorCheck({ funcToTry: () => {
    let strDocContent = N.ElectronFramework.Fs.readFileSync(Parameters.strPath, 'utf8');

    if (Parameters.strFormat === 'HTML') {
      return {
        strLoadedDocThemeSlug: strDocContent.match('- __themeslug: (.*) -')[1],
        strLoadedDocThemeName: strDocContent.match('- __themename: (.*) -')[1],
        // RegExp -> [\s\S] any characters, even line breaks
        strLoadedContent: strDocContent.match(/<main>([\s\S]*)<\/main>/)[1]
      };
    }
    else if (Parameters.strFormat === 'Markdown') {
      return {
        strLoadedContent: N.Functions.Utils.funcMarkdownToHTML({ strContent: strDocContent })
      };
    }
  } });
};

N.Functions.Window = {};


N.Functions.Window.funcClose = () => {
  window.close();
};

N.Functions.Window.funcMinimize = () => {
  N.ElectronFramework.CurrentWindow.minimize();
};

N.Functions.Window.funcToggleMaximize = () => {
  if (N.ElectronFramework.CurrentWindow.isMaximized()) {
    N.ElectronFramework.CurrentWindow.unmaximize();
  } else {
    N.ElectronFramework.CurrentWindow.maximize();
  }
};

N.Functions.Window.funcToggleFullscreen = () => {
  if (N.ElectronFramework.CurrentWindow.isFullScreen()) {
    N.ElectronFramework.CurrentWindow.setFullScreen(false);
    document.body.classList.remove('fullscreen');
  } else {
    N.ElectronFramework.CurrentWindow.setFullScreen(true);
    document.body.classList.add('fullscreen');
  }
};

N.Functions.Window.funcToggleAlwaysOnTop = () => {
  if (N.ElectronFramework.CurrentWindow.isAlwaysOnTop()) {
    N.ElectronFramework.CurrentWindow.setAlwaysOnTop(false);
    document.body.classList.remove('always-on-top');
  } else {
    N.ElectronFramework.CurrentWindow.setAlwaysOnTop(true);
    document.body.classList.add('always-on-top');
  }
};


N.Functions.Window.funcPlatformDetect = () => {
  if (process.platform === 'win32') {
    N.strOS = 'windows';
    document.body.classList.add('windows-os');
  } else if (process.platform === 'darwin') {
    N.strOS = 'osx';
    document.body.classList.add('osx-os');
  } else {
    N.strOS = 'linux';
    document.body.classList.add('linux-os');
  }
};

N.Functions.Utils = {};


N.Functions.Utils.funcSetDOMAppName = () => {
  forEach(document.getElementsByClassName('app-name'), ($Element) => {
    $Element.textContent = N.strAppName;
  });
};


// Parameter :
// - strPath
N.Functions.Utils.funcGetFilePathInfo = (Parameter) => {
  const strExtensionLowerCase = N.ElectronFramework.Path.extname(Parameter.strPath).toLowerCase();

  let strFormat = '';
  if (['.html', '.htm'].indexOf(strExtensionLowerCase) !== -1) {
    strFormat = 'HTML';
  } else if (['.md', '.markdown'].indexOf(strExtensionLowerCase) !== -1) {
    strFormat = 'Markdown';
  }

  return {
    strName: N.ElectronFramework.Path.basename(Parameter.strPath),
    strDirPath: N.ElectronFramework.Path.dirname(Parameter.strPath),
    strFormat: strFormat
  };
};


// Parameters :
// - strEvent
// - $Element
N.Functions.Utils.funcTriggerEvent = (Parameters) => {
  Parameters.$Element.dispatchEvent(new Event(Parameters.strEvent));
};


// http://stackoverflow.com/questions/3446170/escape-string-for-use-in-javascript-regex
// https://github.com/sindresorhus/escape-string-regexp
// Parameter :
// - strRegExp
N.Functions.Utils.funcEscapeStringRegexp = (Parameter) => {
  return Parameter.strRegExp.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
};


N.Functions.Utils.funcNoCacheSuffix = () => {
  // http://stackoverflow.com/questions/728616/disable-cache-for-some-images/6116854#6116854
  return '?nocache2650=' + new Date().getTime();
};


N.Functions.Utils.funcMarkdownToHTML = (Parameter) => {
  try {
    return marked(Parameter.strContent);
  } catch (Error) {
    console.error(Error);
    // Error during the convertion.
    return false;
  }
};

N.Functions.Utils.funcHTMLToMarkdown = (Parameter) => {
  try {
    return toMarkdown(Parameter.strContent);
  } catch (Error) {
    console.error(Error);
    // Error during the convertion.
    return false;
  }
};

N.Functions.Documents = {};


N.Functions.Documents.funcDocActiveChange = () => {
  if (N.DocActive) {
    N.DocActive.LastSelection = lightrange.saveSelection();
    N.DocActive.$Tab.classList.remove('active');
    N.DocActive.$ContentContainer.classList.remove('active');

    N.Functions.Content.funcCleanSearch({ Document: N.DocActive });
  }
};


N.Functions.Documents.funcOpenDialog = () => {
  N.Functions.Dialogs.funcCloseContext();

  N.ElectronFramework.Dialog.showOpenDialog({
    properties: [
      'openFile',
      'multiSelections',
      'createDirectory'
    ],
    filters: [
      {name: 'Supported documents', extensions: ['html', 'htm', 'md', 'markdown']},
      {name: 'HTML documents', extensions: ['html', 'htm']},
      {name: 'Markdown documents', extensions: ['md', 'markdown']}
    ]
  }, (arrPaths) => {
    // arrPaths is undefined if the opening is cancelled by the user
    if (arrPaths) {
      N.Functions.Documents.funcOpen({ arrPaths: arrPaths });
    }
  });
};



N.Functions.Documents.funcOpen = (Parameter) => {

  forEach(Parameter.arrPaths, (strPath) => {
    strPath = N.ElectronFramework.Path.normalize(strPath);

    let boolIsDocAlreadyOpened = false;

    // Check the current path with all opened document
    forEach(N.arrDocs, (Doc) => {
      // If the document is saved on disk (has a path) and has the same path (already opened)
      if (Doc && Doc.strPath && Doc.strPath === strPath) {
        // We mark it for the next step
        boolIsDocAlreadyOpened = true;
        if (Parameter.arrPaths.length === 1) {
          Doc.methShow();
        }
        // Break the loop, it's useless to continue
        return;
      }
    });

    // After looping into all the saved and opened documents, the document is not already opened, so we open it
    if ( ! boolIsDocAlreadyOpened) {
      const FilePathInfo = N.Functions.Utils.funcGetFilePathInfo({ strPath: strPath });

      let LoadedFile = N.Functions.IO.funcLoadDoc({ strPath: strPath, strFormat: FilePathInfo.strFormat });

      if (LoadedFile) {
        let strDocThemeSlug;
        let strDocThemeName;
        if (FilePathInfo.strFormat === 'HTML') {
          strDocThemeSlug = LoadedFile.strLoadedDocThemeSlug;
          strDocThemeName = LoadedFile.strLoadedDocThemeName;
        }

        let boolLockedDoc = false;
        if (FilePathInfo.strDirPath === N.ElectronFramework.Path.normalize(`${N.strAppPath}/documents`)) {
          boolLockedDoc = true;
        }

        new Document({
          strPath: strPath,
          strContent: LoadedFile.strLoadedContent,
          strDocThemeSlug: strDocThemeSlug,
          strDocThemeName: strDocThemeName,
          boolLockedDoc: boolLockedDoc
        });

        // Close the previous empty tab if there is only two tabs
        if (N.intCurrentDocs === 2) {
          const $PreviousTab = N.DocActive.$Tab.previousElementSibling;
          if ( ! $PreviousTab.classList.contains('doc-unsaved') && ! $PreviousTab.classList.contains('opened-doc')) {
            $PreviousTab.getElementsByClassName('close-tab')[0].click();
          }
        }
      }
    }
  });

};


// Option :
// - boolForceAction
N.Functions.Documents.funcCloseAll = (Option) => {
  forEach(N.arrDocs, (Doc) => {
    if (Doc) {
      if (Option && Option.boolForceAction) {
        Doc.methClose({ boolForceAction: true });
      } else {
        Doc.methClose();
      }
    }
  });

  if (N.$TabsList.getElementsByClassName('doc-unsaved').length) {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'unsaved-docs' });
    // returning a status to show a warning dialog at application closing
    return { boolUnsavedDocs: true };
  }

  return { boolUnsavedDocs: false };
};



N.Functions.Documents.funcMenuAvailabilityCheck = () => {
  if (N.DocActive.strPath) {
    N.$MenuOpenDocFolder.classList.remove('disabled');

    if (N.DocActive.$Tab.classList.contains('doc-unsaved')) {
      N.$MenuSave.classList.remove('disabled');
    } else {
      N.$MenuSave.classList.add('disabled');
    }
  } else {
    N.$MenuOpenDocFolder.classList.add('disabled');
    N.$MenuSave.classList.add('disabled');
  }

  if (N.DocActive.boolLocked) {
    N.$MenuSave.classList.add('disabled');
  }
};

N.Functions.Content = {};


N.Functions.Content.funcPurifyHTML = (Parameters) => {
  let arrAllowedTags = [];
  let arrAllowedAttr = [];

  if (Parameters.strAllowedContentMode === 'paste') {
    arrAllowedTags = [
      'h1', 'h2', 'h3', 'h4', 'h5', 'h6',
      'blockquote', 'ul', 'ol', 'li', 'img',
      'b', 'i', 'u', 'strike', 'a', 'sup', 'sub', 'br'
    ];
    arrAllowedAttr = [
      'src', 'href'
    ];
  }
  else if (Parameters.strAllowedContentMode === 'document') {
    arrAllowedTags = [
      'h1', 'h2', 'h3', 'h4', 'h5', 'h6',
      'p', 'blockquote', 'ul', 'ol', 'li', 'img', 'iframe',
      'b', 'i', 'u', 'strike', 'a', 'sup', 'sub', 'br'
    ];
    arrAllowedAttr = [
      'src', 'href',
      'id',
      // For iframe only :
      'width', 'height', 'allowfullscreen'
    ];
  }
  else if (Parameters.strAllowedContentMode === 'embed') {
    arrAllowedTags = ['iframe'];
    arrAllowedAttr = [
      'src', 'width', 'height', 'allowfullscreen'
    ];
  }

  const PurifyParameters = { ALLOWED_TAGS: arrAllowedTags, ALLOWED_ATTR: arrAllowedAttr };

  return DOMPurify.sanitize(Parameters.strHTML, PurifyParameters);
};



N.Functions.Content.funcSetHeadingsIDs = (Parameter) => {
  forEach(Parameter.Document.$ContentEditable.querySelectorAll('h1, h2, h3, h4, h5, h6'), ($H) => {
    // From https://github.com/chjj/marked/blob/master/lib/marked.js#L800
    $H.id = $H.textContent.toLowerCase().replace(/[^\w]+/g, '-');
  });
};



N.Functions.Content.funcDisplayEmojis = (Parameter) => {
  // https://github.com/Ranks/emojify.js#browser
  emojify.run(Parameter.Document.$ContentEditable, (strEmojiSymbol, strEmojiName) => {
    const $Span = document.createElement('span');
    $Span.classList.add('emoji');
    $Span.classList.add('emoji-' + strEmojiName);
    $Span.setAttribute('contenteditable', 'false');

    const $SpanInner = document.createElement('span');
    $SpanInner.classList.add('emoji-text');
    $SpanInner.innerHTML = ':' + strEmojiName + ':';

    $Span.appendChild($SpanInner);

    return $Span;
  });

  forEach(Parameter.Document.$ContentEditable.getElementsByClassName('emoji'), ($Emoji) => {
    $Emoji.setAttribute('contenteditable', 'false');
  });
};



N.Functions.Content.funcClearHTMLForHTMLExport = (Parameter) => {
  // Selecting all links exept those with [href] starting with "#" (anchor links)
  forEach(Parameter.$ContentEditable.querySelectorAll('a:not([href^="#"])'), ($A) => {
    $A.target = '_blank';
  });

  forEach(Parameter.$ContentEditable.getElementsByClassName('emoji'), ($Emoji) => {
    $Emoji.removeAttribute('contenteditable');
    $Emoji.title = $Emoji.getElementsByClassName('emoji-text')[0].textContent;
  });
  // Not deleting &nbsp; because user may write some in <pre> elements in a future release of the app.
};

N.Functions.Content.funcClearHTMLForMarkdownExport = (Parameter) => {
  while (Parameter.$ContentEditable.getElementsByClassName('emoji').length) {
    forEach(Parameter.$ContentEditable.getElementsByClassName('emoji'), ($Emoji) => {
      if ($Emoji) {
        $Emoji.outerHTML = $Emoji.getElementsByClassName('emoji-text')[0].textContent;
      }
    });
  }
};



N.Functions.Content.funcClearHTML = (Parameter) => {
  // Must use while : outerHTML = innerHTML cause issues with for/forEach loops

  // It happens that the editor outputs some <div>. But we want <p> instead.
  while (Parameter.Document.$ContentEditable.getElementsByTagName('div').length) {
    forEach(Parameter.Document.$ContentEditable.getElementsByTagName('div'), ($Div) => {
      if ($Div) {
        $Div.outerHTML = '<p>' + $Div.innerHTML + '</p>';
      }
    });
  }

  // It happens that the editor outputs some <span>. But we want only .emoji
  while (Parameter.Document.$ContentEditable.querySelectorAll('span:not(.emoji):not(.emoji-text), a:not([href])').length) {
    forEach(Parameter.Document.$ContentEditable.querySelectorAll('span:not(.emoji):not(.emoji-text), a:not([href])'), ($Element) => {
      if ($Element) {
        $Element.outerHTML = $Element.innerHTML;
      }
    });
  }

  // It happens that the editor outputs some element with [style], we don't want this attribute.
  forEach(Parameter.Document.$ContentEditable.querySelectorAll('[style]'), ($Element) => {
    $Element.removeAttribute('style');
  });

  // See N.Functions.Content.funcPurifyHTML() for a better comprehension

  forEach(Parameter.Document.$ContentEditable.querySelectorAll('[href]:not(a)'), ($Element) => {
    $Element.removeAttribute('href');
  });

  forEach(Parameter.Document.$ContentEditable.querySelectorAll('[src]:not(img):not(iframe)'), ($Element) => {
    $Element.removeAttribute('src');
  });
  forEach(Parameter.Document.$ContentEditable.querySelectorAll('img:not([src]), iframe:not([src])'), ($Element) => {
    $Element.parentNode.removeChild($Element);
  });

  forEach(Parameter.Document.$ContentEditable.querySelectorAll('[width]:not(iframe), [height]:not(iframe), [allowfullscreen]:not(iframe)'), ($Element) => {
    $Element.removeAttribute('width');
    $Element.removeAttribute('height');
    $Element.removeAttribute('allowfullscreen');
  });
};



N.Functions.Content.funcCleanSearch = (Parameter) => {
  // Must use while : outerHTML = innerHTML cause issues with for/forEach loops
  while (Parameter.Document.$ContentEditable.getElementsByTagName('searchresult').length) {
    forEach(Parameter.Document.$ContentEditable.getElementsByTagName('searchresult'), ($Searchresult) => {
      if ($Searchresult) {
        $Searchresult.outerHTML = $Searchresult.innerHTML;
      }
    });
  }

  N.$SearchResultsTotal.textContent = '0';
};

N.Functions.Toolbar = {};


N.Functions.Toolbar.funcAutoPosition = () => {
  const Range = lightrange.getSelectionInfo();
  const intToolsWidth = N.$Toolbar.offsetWidth;

  let intToolsTop = Range.yStart - N.$Toolbar.offsetHeight - 4;
  // 38px : .tab-bar height
  if (intToolsTop < 38) {
    intToolsTop = Range.yStart + Range.height + 5;
  }
  N.$Toolbar.style.top = intToolsTop + 'px';


  let intToolsLeft = Range.xStart + (Range.width / 2 - intToolsWidth / 2);
  if (intToolsLeft < 7) {
    intToolsLeft = 7;
  }
  else {
    const intWindowRightLimit = window.innerWidth - 12;
    if (intToolsLeft + intToolsWidth > intWindowRightLimit) {
      intToolsLeft = intWindowRightLimit - intToolsWidth;
    }
  }
  N.$Toolbar.style.left = intToolsLeft + 'px';


  // To know if the selection is a range or a caret, for displaying the toolbar or not
  return Range;
};


N.Functions.Toolbar.funcResetPosition = () => {
  N.$Toolbar.style.top = '134px';
  N.$Toolbar.style.left = '7px';
};


N.Functions.Toolbar.funcView = () => {
  N.$Toolbar.dataset.view = 'tools-list';

  if (N.Functions.Toolbar.funcAutoPosition().characters) {
    N.$Toolbar.classList.add('active');
  } else {
    N.$Toolbar.classList.remove('active');
  }
};


N.Functions.Toolbar.funcResetView = () => {
  lightrange.restoreSelection(N.DocActive.LastSelection);
  N.$Toolbar.dataset.view = 'tools-list';
  N.Functions.Toolbar.funcAutoPosition();
};


N.Functions.Toolbar.funcCheckTools = () => {
  forEach(N.$Toolbar.getElementsByTagName('li'), ($Button) => {
    if ($Button.dataset.cmd) {
      if ($Button.dataset.cmdcheck) {
        if (document.queryCommandState($Button.dataset.cmdcheck)) {
          $Button.classList.add('active');
        } else {
          $Button.classList.remove('active');
        }
      } else {
        if (document.queryCommandState($Button.dataset.cmd)) {
          $Button.classList.add('active');
        } else {
          $Button.classList.remove('active');
        }
      }
    } else if ($Button.dataset.tag) {
      if (document.queryCommandValue('formatBlock') === $Button.dataset.tag) {
        $Button.classList.add('active');
      } else {
        $Button.classList.remove('active');
      }
    }
  });

  if (N.$ToolQuote.classList.contains('active') || N.$ToolH1.classList.contains('active') || N.$ToolH2.classList.contains('active') || N.$ToolH3.classList.contains('active') || N.$ToolH4.classList.contains('active') || N.$ToolH5.classList.contains('active') || N.$ToolH6.classList.contains('active') ) {
    N.$ToolUnorderedList.classList.add('disabled');
    N.$ToolOrderedList.classList.add('disabled');
  } else {
    N.$ToolUnorderedList.classList.remove('disabled');
    N.$ToolOrderedList.classList.remove('disabled');
  }

  if (N.$ToolUnorderedList.classList.contains('active') || N.$ToolOrderedList.classList.contains('active')) {
    N.$ToolQuote.classList.add('disabled');
    N.$ToolH1.classList.add('disabled');
    N.$ToolH2.classList.add('disabled');
    N.$ToolH3.classList.add('disabled');
    N.$ToolH4.classList.add('disabled');
    N.$ToolH5.classList.add('disabled');
    N.$ToolH6.classList.add('disabled');
  } else {
    N.$ToolQuote.classList.remove('disabled');
    N.$ToolH1.classList.remove('disabled');
    N.$ToolH2.classList.remove('disabled');
    N.$ToolH3.classList.remove('disabled');
    N.$ToolH4.classList.remove('disabled');
    N.$ToolH5.classList.remove('disabled');
    N.$ToolH6.classList.remove('disabled');
  }
};

N.Functions.Dialogs = {};


N.Functions.Dialogs.funcShow = (Parameter) => {
  if (N.strDialogActiveSlug === 'search') {
    N.Functions.Content.funcCleanSearch({ Document: N.DocActive });
  }

  document.body.dataset.dialog = Parameter.strDialogSlug;
  N.strDialogActiveSlug = Parameter.strDialogSlug;

  if (N.strDialogActiveSlug) {
    N.$DialogActive = document.getElementById(`${N.strDialogActiveSlug}-dialog_unc2741`);
  } else {
    N.$DialogActive = null;
  }

  N.$Toolbar.classList.remove('active');
};


N.Functions.Dialogs.funcValidateCurrent = () => {
  if (N.strDialogActiveSlug) {
    const $RaisedButton = N.$DialogActive.getElementsByClassName('mdl-button--raised')[0];
    if ($RaisedButton) {
      $RaisedButton.click();
    }
  }
};


N.Functions.Dialogs.funcCloseCurrent = () => {
  if (N.strDialogActiveSlug) {
    // In every dialog, there is at least one .close-dialog-button
    N.$DialogActive.getElementsByClassName('close-dialog-button')[0].click();
  }
};


N.Functions.Dialogs.funcForceClose = () => {
  N.Functions.Dialogs.funcShow({ strDialogSlug: '' });
};


N.Functions.Dialogs.funcCloseContext = () => {
  if (
    N.strDialogActiveSlug
    && N.strDialogActiveSlug !== 'table-content'
    && N.strDialogActiveSlug !== 'doc-info'
    && N.strDialogActiveSlug !== 'unsaved-docs'
    && N.strDialogActiveSlug !== 'new-update'
    && N.strDialogActiveSlug !== 'priority-info'
    && N.strDialogActiveSlug !== 'io-error'
  ) {
    N.Functions.Dialogs.funcCloseCurrent();
  }
};



N.Functions.Dialogs.funcUpdateTableContent = () => {
  N.$HeadingsList.innerHTML = '';
  const arrDocHeadings = N.DocActive.$ContentEditable.querySelectorAll('h1, h2, h3, h4, h5, h6');

  if (arrDocHeadings.length) {
    N.Functions.Content.funcSetHeadingsIDs({ Document: N.DocActive });

    forEach(arrDocHeadings, ($H) => {
      const intHeadingLevel = parseInt($H.tagName.slice(-1));
      let strHeadingLevel = '';
      switch (intHeadingLevel) {
        case 1:
          strHeadingLevel = 'XL';
          break;
        case 2:
          strHeadingLevel = 'L';
          break;
        case 3:
          strHeadingLevel = 'M';
          break;
        case 4:
          strHeadingLevel = 'S';
          break;
        case 5:
          strHeadingLevel = 'XS';
          break;
        case 6:
          strHeadingLevel = 'XXS';
          break;
      }

      const $HeadingItem = N.$TableContentHeadingModel.cloneNode(true);
      $HeadingItem.getElementsByClassName('mdl-list__item-primary-content')[0].textContent = $H.textContent;
      $HeadingItem.getElementsByClassName('mdl-list__item-secondary-action')[0].textContent = strHeadingLevel;
      $HeadingItem.dataset.anchor = '#' + $H.id;


      $HeadingItem.addEventListener('click', () => {
        const $Anchor = document.querySelector($HeadingItem.dataset.anchor);
        if ($Anchor) {
          zenscroll.createScroller(N.DocActive.$ContentContainer).center($Anchor);
        }
      });

      N.$HeadingsList.appendChild($HeadingItem);
    });

    N.$TableContentDialog.dataset.view = 'headings-list';
  }
  else {
    N.$TableContentDialog.dataset.view = 'no-headings';
  }
};



N.Functions.Dialogs.funcUpdateDocInfo = () => {
  if (N.DocActive.strDocThemeName) {
    N.$DocInfoThemeName.textContent = N.DocActive.strDocThemeName;
  } else {
    N.$DocInfoThemeName.textContent = '—';
  }

  Countable.once(N.DocActive.$ContentEditable, (Counter) => {
    N.$DocInfoParagraphs.textContent = Counter.paragraphs;
    N.$DocInfoSentences.textContent = Counter.sentences;
    N.$DocInfoWords.textContent = Counter.words;
    N.$DocInfoCharacters.textContent = Counter.characters;
    N.$DocInfoCharactersSpaces.textContent = Counter.all;
  });
};

N.Functions.Remote = {};


N.Functions.Remote.funcGetUpdateInfo = (Parameters) => {
  reqwest({
    // url: `${N.strAppPath}/../CHANGELOG.md`,
    url: 'https://raw.githubusercontent.com/n457/Uncolored/master/CHANGELOG.md',
    success: (strResponse) => {
      let boolUpdateAvailable = false;

      // Remotly, strResponse.response doesn't work, use strResponse instead
      let strRemoteContent = N.Functions.Utils.funcMarkdownToHTML({ strContent: strResponse });

      if (strRemoteContent) {
        const strRemoteLastestVersion = strRemoteContent.match('- currentversion: (.*) -')[1];

        if (versionCompare(strRemoteLastestVersion, N.strAppVersion) > 0) {
          boolUpdateAvailable = true;
        }

        Parameters.funcOnSuccess.call(null, {
          boolUpdateAvailable: boolUpdateAvailable,
          strRemoteLastestVersion: strRemoteLastestVersion,
          strRemoteReleaseNotesHTML: strRemoteContent
        });
      }
    },
    error: (Error) => {
      console.error(Error);
      Parameters.funcOnError.call(null, Error);
    }
  });
};


N.Functions.Remote.funcGetPriorityInfo = (Parameters) => {
  reqwest({
    // url: `${N.strAppPath}/../project/docs/priority-info.md`,
    url: 'https://raw.githubusercontent.com/n457/Uncolored/master/project/docs/priority-info.md',
    success: (strResponse) => {
      // Remotly, strResponse.response doesn't work, use strResponse instead
      let strRemoteContent = N.Functions.Utils.funcMarkdownToHTML({ strContent: strResponse });

      if (strRemoteContent) {
        Parameters.funcOnSuccess.call(null, {
          strRemotePriorityInfoHTML: strRemoteContent
        });
      }
    },
    error: (Error) => {
      console.error(Error);
      Parameters.funcOnError.call(null, Error);
    }
  });
};

// https://developer.mozilla.org/fr/docs/Web/JavaScript/Reference/Classes
class Document {

  // Add a document and the corresponding content (empty or not).
  // Options :
  // - strPath (optional)
  // - strContent (optional)
  // - strDocThemeSlug (optional)
  // - strDocThemeName (optional)
  // - boolLockedDoc (optional)
  constructor(Options) {
    const ThisDoc = this;

    N.intDocIDsCount++;
    ThisDoc.intID = N.intDocIDsCount;

    ThisDoc.$Tab = N.$TabModel.cloneNode(true);
    ThisDoc.$ContentContainer = N.$ContentContainerModel.cloneNode(true);
    ThisDoc.$ContentEditable = ThisDoc.$ContentContainer.getElementsByClassName('wysiwyg-content')[0];
    ThisDoc.$FileName = ThisDoc.$Tab.getElementsByClassName('file-name')[0];

    ThisDoc.boolLocked = false;

    if (Options) {
      ThisDoc.methSetTabData(Options);

      ThisDoc.$ContentEditable.innerHTML = N.Functions.Content.funcPurifyHTML({
        strHTML: Options.strContent,
        strAllowedContentMode: 'document'
      });
      N.Functions.Content.funcClearHTML({ Document: ThisDoc });
      N.Functions.Content.funcSetHeadingsIDs({ Document: ThisDoc });
      N.Functions.Content.funcDisplayEmojis({ Document: ThisDoc });

      if (Options.boolLockedDoc) {
        ThisDoc.boolLocked = true;
      }
    } else {
      ThisDoc.$FileName.textContent += N.intDocIDsCount + 1;
    }

    ThisDoc.$Tab.dataset.id = ThisDoc.intID;

    ThisDoc.LastSelection;

    ThisDoc.strLastSavedContent = ThisDoc.$ContentEditable.innerHTML;



    ThisDoc.$Tab.getElementsByClassName('close-tab')[0].addEventListener('click', (Event) => {
      ThisDoc.methClose();

      // To avoid triggering ThisDoc.methShow() because the button is a child of the tab.
      Event.stopPropagation();
    });


    ThisDoc.$Tab.getElementsByClassName('close-tab-cancel')[0].addEventListener('click', (Event) => {
      ThisDoc.$Tab.classList.remove('close-confirm');

      // To avoid triggering ThisDoc.methShow() because the button is a child of the tab.
      Event.stopPropagation();
    });
    ThisDoc.$Tab.getElementsByClassName('close-tab-confirm')[0].addEventListener('click', (Event) => {
      ThisDoc.methClose({ boolForceAction: true });

      // To avoid triggering ThisDoc.methShow() because the button is a child of the tab.
      Event.stopPropagation();
    });


    ThisDoc.$Tab.addEventListener('click', (Event) => {
      if (Event.button === 0) {
        ThisDoc.methShow();
      }
      else if (Event.button === 1) {
        ThisDoc.methClose();

        // FIXME [(Un)colored] : On Windows, cancel the default middle mouse click page navigation system. Event.preventDefault() not working.
      }
    });


    // To avoid triggering the 'dblclick' of N.$TabsList.
    ThisDoc.$Tab.addEventListener('dblclick', (Event) => {
      Event.stopPropagation();
    });


    ThisDoc.$ContentContainer.addEventListener('scroll', () => {
      N.Functions.Toolbar.funcAutoPosition();
    });



    ThisDoc.Editor = wysiwyg({
      element: ThisDoc.$ContentEditable
    });

    ThisDoc.$ContentEditable.addEventListener('click', () => {
      ThisDoc.LastSelection = lightrange.saveSelection();
      N.Functions.Toolbar.funcView();
      N.Functions.Toolbar.funcAutoPosition();
      N.Functions.Toolbar.funcCheckTools();
      // Because of the context menu on a tab
      N.$Header.classList.remove('active');
    });

    ThisDoc.$ContentEditable.addEventListener('keydown', (Event) => {
      ThisDoc.LastSelection = lightrange.saveSelection();
      N.Functions.Toolbar.funcView();
      N.Functions.Toolbar.funcAutoPosition();
      N.Functions.Toolbar.funcCheckTools();

      // Space key
      if (Event.keyCode === 32) {
        N.Functions.Content.funcDisplayEmojis({ Document: ThisDoc });
      }
      else if (Event.altKey) {
        N.$Toolbar.classList.add('active');
      }

      N.Functions.Documents.funcMenuAvailabilityCheck();
    });

    ThisDoc.$ContentEditable.addEventListener('input', () => {
      if ( ! ThisDoc.$ContentEditable.innerHTML) {
        ThisDoc.$ContentEditable.innerHTML = '<p><br></p>';
      }

      clearTimeout(N.timerInput);
      N.timerInput = setTimeout(() => {
        N.Functions.Content.funcClearHTML({ Document: ThisDoc });

        if (ThisDoc.$ContentEditable.innerHTML === ThisDoc.strLastSavedContent) {
          N.$GlobalUnsavedMark.classList.remove('active');
          ThisDoc.$Tab.classList.remove('doc-unsaved');
        } else {
          N.$GlobalUnsavedMark.classList.add('active');
          ThisDoc.$Tab.classList.add('doc-unsaved');
        }

        // keydown is not triggered with some command like 'undo', so we have to check here as well
        N.Functions.Documents.funcMenuAvailabilityCheck();

        clearTimeout(N.timerInput);
      }, 400);
    });

    ThisDoc.$ContentEditable.addEventListener('copy', () => {
      clearTimeout(N.timerClipboard);
      N.timerClipboard = setTimeout(() => {
        N.strLastHTMLCopied = N.ElectronFramework.Clipboard.readHTML();
        clearTimeout(N.timerClipboard);
      }, 30);
    });
    ThisDoc.$ContentEditable.addEventListener('cut', () => {
      clearTimeout(N.timerClipboard);
      N.timerClipboard = setTimeout(() => {
        N.strLastHTMLCopied = N.ElectronFramework.Clipboard.readHTML();
        clearTimeout(N.timerClipboard);
      }, 30);
    });

    ThisDoc.$ContentEditable.addEventListener('paste', () => {
      let strClipboardHTML = N.ElectronFramework.Clipboard.readHTML();

      if (strClipboardHTML !== N.strLastHTMLCopied && strClipboardHTML !== N.strLastHTMLPasted) {
        strClipboardHTML = N.Functions.Content.funcPurifyHTML({
          strHTML: strClipboardHTML,
          strAllowedContentMode: 'paste'
        });

        N.ElectronFramework.Clipboard.writeHTML(strClipboardHTML);
        N.strLastHTMLPasted = strClipboardHTML;
      }
      // Set capture mode to "true" to execute paste instructions before the content is actually pasted.
      // http://stackoverflow.com/questions/7398290/unable-to-understand-usecapture-attribute-in-addeventlistener/7398447#7398447
    }, true);


    ThisDoc.$ContentEditable.addEventListener('paste', () => {
      clearTimeout(N.timerClipboard);
      N.timerClipboard = setTimeout(() => {
        N.Functions.Content.funcClearHTML({ Document: ThisDoc });
        N.Functions.Content.funcSetHeadingsIDs({ Document: ThisDoc });
        N.Functions.Content.funcDisplayEmojis({ Document: ThisDoc });
        clearTimeout(N.timerClipboard);
      }, 50);
    });


    ThisDoc.$ContentEditable.addEventListener('dragstart', (Event) => {
      N.strLastHTMLDragged = Event.target;
    });

    ThisDoc.$ContentEditable.addEventListener('drag', (Event) => {
      if (Event.target === N.strLastHTMLDragged) {
        N.boolCanDrop = true;
      } else {
        Event.preventDefault();
        return false;
      }
    });

    ThisDoc.$ContentEditable.addEventListener('dragover', (Event) => {
      if ( ! N.boolCanDrop) {
        Event.preventDefault();
        return false;
      }
    });

    ThisDoc.$ContentEditable.addEventListener('drop', (Event) => {
      if ( ! N.boolCanDrop) {
        Event.preventDefault();
        return false;
      }
      // N.boolCanDrop always "false" by default
      N.boolCanDrop = false;
    });


    N.$TabsList.appendChild(ThisDoc.$Tab);
    N.$Workspace.appendChild(ThisDoc.$ContentContainer);

    N.arrDocs.push(ThisDoc);
    N.intCurrentDocs++;

    ThisDoc.methShow();
    N.Functions.Toolbar.funcResetPosition();

    N.$TabsList.scrollLeft = N.$TabsList.scrollWidth;
  }


  methSetTabData(Parameter) {
    const ThisDoc = this;

    ThisDoc.FilePathInfo = N.Functions.Utils.funcGetFilePathInfo({ strPath: Parameter.strPath });

    ThisDoc.strPath = Parameter.strPath;
    ThisDoc.strFormat = ThisDoc.FilePathInfo.strFormat;

    if (Parameter.strDocThemeSlug) {
      ThisDoc.strDocThemeSlug = Parameter.strDocThemeSlug;
      ThisDoc.strDocThemeName = Parameter.strDocThemeName;
    }

    ThisDoc.$FileName.textContent = ThisDoc.FilePathInfo.strName;
    ThisDoc.$Tab.classList.add('opened-doc');
  }


  methShow() {
    const ThisDoc = this;

    N.Functions.Documents.funcDocActiveChange();

    ThisDoc.$Tab.classList.add('active');
    ThisDoc.$ContentContainer.classList.add('active');

    if (ThisDoc.$Tab.classList.contains('doc-unsaved')) {
      N.$GlobalUnsavedMark.classList.add('active');
    } else {
      N.$GlobalUnsavedMark.classList.remove('active');
    }

    N.DocActive = ThisDoc;

    if (ThisDoc.LastSelection) {
      lightrange.restoreSelection(ThisDoc.LastSelection);
    } else {
      ThisDoc.$ContentEditable.focus();
    }
    N.Functions.Toolbar.funcView();

    N.Functions.Dialogs.funcCloseContext();
    N.Functions.Documents.funcMenuAvailabilityCheck();

    N.Functions.Dialogs.funcUpdateTableContent();
    N.Functions.Dialogs.funcUpdateDocInfo();
  }


  // Option :
  // - boolForceAction (optional)
  methClose(Option) {
    const ThisDoc = this;

    // if boolForceAction : close the tab without warning.
    if (Option && Option.boolForceAction) {

      N.arrDocs[ThisDoc.intID] = undefined;
      N.intCurrentDocs--;

      if (ThisDoc === N.DocActive) {
        const $PreviousTab = ThisDoc.$Tab.previousElementSibling;
        if ($PreviousTab) {
          $PreviousTab.click();
        } else {
          const $NextTab = ThisDoc.$Tab.nextElementSibling;
          if ($NextTab) {
            $NextTab.click();
          }
        }
      }

      ThisDoc.$Tab.parentNode.removeChild(ThisDoc.$Tab);
      ThisDoc.$ContentContainer.parentNode.removeChild(ThisDoc.$ContentContainer);

      // There is always at least 1 tab opened.
      if ( ! N.intCurrentDocs) {
        new Document();
      }

    } else {

      if (ThisDoc.$Tab.classList.contains('doc-unsaved')) {
        ThisDoc.$Tab.classList.add('close-confirm');
      } else {
        ThisDoc.methClose({ boolForceAction: true });
      }

    }

  }


  methOpenFolder() {
    const ThisDoc = this;

    if (ThisDoc.strPath) {
      N.ElectronFramework.Shell.showItemInFolder(ThisDoc.strPath);
    }
  }

}

N.strAppName = '(Un)colored';
N.strAppVersion = N.ElectronFramework.App.getVersion();

N.strAppPath = N.ElectronFramework.App.getAppPath();
N.strAppExePath = N.ElectronFramework.App.getPath('exe');

N.strAppUserData = N.ElectronFramework.App.getPath('userData');
N.strSettingsFilePath = `${N.strAppUserData}/settings.min.json`;


N.Functions.IO.funcLoadSettings();
N.Functions.IO.funcLoadDocThemesLibs();


N.$Header = document.getElementsByClassName('mdl-layout__header')[0];
N.$WindowControls = document.getElementsByClassName('window-controls')[0];
N.$TabsList = document.getElementsByClassName('tabs-list')[0];
N.$TabModel = document.querySelector('#tab-model-container_unc2741 li');

N.$MenuOpenDocFolder = document.getElementById('menu-open-doc-folder_unc2741');
N.$MenuSave = document.getElementById('menu-save_unc2741');
N.$MenuQuickGuide = document.getElementById('menu-quick-guide_unc2741');

N.$Workspace = document.getElementsByClassName('mdl-layout__content')[0];
N.$ContentContainerModel = N.$Workspace.getElementsByClassName('content-container')[0];
N.$GlobalUnsavedMark = document.getElementById('global-unsaved-mark_unc2741');

N.$Toolbar = document.getElementById('toolbar_unc2741');
// Need to be here because of disabled tool state
N.$ToolQuote = document.getElementById('tool-quote_unc2741');
N.$ToolUnorderedList = document.getElementById('tool-unordered-list_unc2741');
N.$ToolOrderedList = document.getElementById('tool-ordered-list_unc2741');
N.$ToolH1 = document.getElementById('tool-h1_unc2741');
N.$ToolH2 = document.getElementById('tool-h2_unc2741');
N.$ToolH3 = document.getElementById('tool-h3_unc2741');
N.$ToolH4 = document.getElementById('tool-h4_unc2741');
N.$ToolH5 = document.getElementById('tool-h5_unc2741');
N.$ToolH6 = document.getElementById('tool-h6_unc2741');

N.$ContextMenu = document.getElementById('context-menu_unc2741');

N.$SearchDialog = document.getElementById('search-dialog_unc2741');
N.$SearchInput = document.getElementById('search-field_unc2741');
N.$ReplaceInput = document.getElementById('replace-field_unc2741');
N.$SearchResultsTotal = N.$SearchDialog.getElementsByClassName('search-results-total')[0];

N.$TableContentDialog = document.getElementById('table-content-dialog_unc2741');
N.$HeadingsList = N.$TableContentDialog.getElementsByClassName('headings-list')[0];
N.$TableContentHeadingModel = document.querySelector('#heading-item-model-container_unc2741 li');

N.$DocInfoDialog = document.getElementById('doc-info-dialog_unc2741');
N.$DocInfoThemeName = N.$DocInfoDialog.getElementsByClassName('doc-theme-name')[0];
N.$DocInfoParagraphs = N.$DocInfoDialog.getElementsByClassName('paragraphs-number')[0];
N.$DocInfoSentences = N.$DocInfoDialog.getElementsByClassName('sentences-number')[0];
N.$DocInfoWords = N.$DocInfoDialog.getElementsByClassName('words-number')[0];
N.$DocInfoCharacters = N.$DocInfoDialog.getElementsByClassName('characters-number')[0];
N.$DocInfoCharactersSpaces = N.$DocInfoDialog.getElementsByClassName('characters-spaces-number')[0];

N.$AboutDialog = document.getElementById('about-dialog_unc2741');

N.$UnsavedDocsDialog = document.getElementById('unsaved-docs-dialog_unc2741');


N.arrDocs = [];
N.DocActive;

N.intDocIDsCount = -1;
N.intCurrentDocs = 0;

N.strLastHTMLCopied = '';
N.strLastHTMLPasted = '';
N.strLastHTMLDragged = '';
N.timerInput;
N.timerClipboard;
// N.boolCanDrop always "false" by default
N.boolCanDrop = false;

N.LastContextMenuElementInfo;
N.RegExpHeading = new RegExp(/^h\d$/, 'i');

N.$DialogActive;
N.strDialogActiveSlug = '';



N.Functions.Utils.funcSetDOMAppName();


Mousetrap.bindGlobal('tab', () => {
  if (document.activeElement !== N.$SearchInput) {
    return false;
  }
});
Mousetrap.bindGlobal('shift+tab', () => {
  if (document.activeElement !== N.$ReplaceInput) {
    return false;
  }
});

emojify.setConfig({ mode: 'data-uri' });

(() => {

  N.Functions.Window.funcPlatformDetect();

  N.$WindowControls.getElementsByClassName('close')[0].addEventListener('click', () => {
    N.Functions.Window.funcClose();
  });

  N.$WindowControls.getElementsByClassName('minimize')[0].addEventListener('click', () => {
    N.Functions.Window.funcMinimize();
  });

  N.$WindowControls.getElementsByClassName('toggle-maximize')[0].addEventListener('click', () => {
    N.Functions.Window.funcToggleMaximize();
  });

  N.$WindowControls.getElementsByClassName('toggle-fullscreen')[0].addEventListener('click', () => {
    N.Functions.Window.funcToggleFullscreen();
  });
  Mousetrap.bindGlobal(['f11', 'command+ctrl+f'], () => {
    N.Functions.Window.funcToggleFullscreen();
  });

  N.$WindowControls.getElementsByClassName('toggle-always-on-top')[0].addEventListener('click', () => {
    N.Functions.Window.funcToggleAlwaysOnTop();
  });

})();

(() => {

  let timerHeaderVisible;
  const funcShowHeader = (Parameter) => {
    N.$Header.classList.add('active');

    clearTimeout(timerHeaderVisible);
    timerHeaderVisible = setTimeout(() => {
      N.$Header.classList.remove('active');
      clearTimeout(timerHeaderVisible);
    }, Parameter.flDelay);
  };



  document.getElementById('menu-new-doc_unc2741').addEventListener('click', () => {
    new Document();
  });
  N.$TabsList.addEventListener('dblclick', () => {
    new Document();
  });
  N.$Header.getElementsByClassName('add-tab-button')[0].addEventListener('click', () => {
    new Document();
  });
  // bind() doesn't work in any text fields. An official plugin 'global bind' allows that.
  Mousetrap.bindGlobal(['mod+n', 'mod+t'], () => {
    new Document();
  });

  N.$TabsList.addEventListener('mousewheel', (Event) => {
    N.$TabsList.scrollLeft -= Event.wheelDelta;
  });



  document.getElementById('menu-open-doc_unc2741').addEventListener('click', () => {
    N.Functions.Documents.funcOpenDialog();
  });
  Mousetrap.bindGlobal('mod+o', () => {
    N.Functions.Documents.funcOpenDialog();
  });


  Mousetrap.bindGlobal('mod+w', () => {
    N.DocActive.methClose();
  });


  document.getElementById('menu-close-all-docs_unc2741').addEventListener('click', () => {
    N.Functions.Documents.funcCloseAll();
  });
  Mousetrap.bindGlobal('mod+shift+w', () => {
    N.Functions.Documents.funcCloseAll();
  });



  Mousetrap.bindGlobal('ctrl+tab', () => {
    funcShowHeader({ flDelay: 2000 });

    // Click on the concerned tab only if there are more than 1 tab opened
    if (N.intCurrentDocs > 1) {
      let $NextTab = N.DocActive.$Tab.nextElementSibling;
      if ( ! $NextTab) {
        $NextTab = N.$TabsList.firstElementChild;
      }
      N.$TabsList.scrollLeft = $NextTab.offsetLeft - 120;
      $NextTab.click();
    }
  });

  Mousetrap.bindGlobal('ctrl+shift+tab', () => {
    funcShowHeader({ flDelay: 2000 });

    // Click on the concerned tab only if there are more than 1 tab opened
    if (N.intCurrentDocs > 1) {
      let $PreviousTab = N.DocActive.$Tab.previousElementSibling;
      if ( ! $PreviousTab) {
        // Warning : N.$TabsList must contain ONLY usable tabs, otherwise the script won't work.
        $PreviousTab = N.$TabsList.lastElementChild;
      }
      N.$TabsList.scrollLeft = $PreviousTab.offsetLeft - N.$TabsList.offsetWidth + $PreviousTab.offsetWidth + 120;
      $PreviousTab.click();
    }
  });



  N.$UnsavedDocsDialog.getElementsByClassName('force-close-all')[0].addEventListener('click', () => {
    N.Functions.Documents.funcCloseAll({ boolForceAction: true });
  });
  N.$UnsavedDocsDialog.getElementsByClassName('cancel-all')[0].addEventListener('click', () => {
    forEach(N.$TabsList.getElementsByClassName('tab'), ($Tab) => {
      $Tab.classList.remove('close-confirm');
    });
  });



  Sortable.create(N.$TabsList, {
    delay: 10,
    animation: 150
  });



  new Document();

})();

(() => {

  const $ToolParagraph = document.getElementById('tool-paragraph_unc2741');
  const $ToolRemoteImage = document.getElementById('tool-remote-image_unc2741');
  const $ToolRemoteVideo = document.getElementById('tool-remote-video_unc2741');
  const $ToolRemoteEmbed = document.getElementById('tool-remote-embed_unc2741');

  const $ToolBold = document.getElementById('tool-bold_unc2741');
  const $ToolItalic = document.getElementById('tool-italic_unc2741');
  const $ToolUnderline = document.getElementById('tool-underline_unc2741');
  const $ToolStrike = document.getElementById('tool-strike_unc2741');
  const $ToolApplyLink = document.getElementById('tool-apply-link_unc2741');
  const $ToolSuperscript = document.getElementById('tool-superscript_unc2741');
  const $ToolSubscript = document.getElementById('tool-subscript_unc2741');
  const $ToolClear = document.getElementById('tool-clear_unc2741');
  const $ToolEmojis = document.getElementById('tool-emojis_unc2741');


  const $InputRemoteImage = N.$Toolbar.querySelector('.remote-image-view input');
  const $CancelRemoteImage = N.$Toolbar.querySelector('.remote-image-view .cancel-tool');
  const $ValidateRemoteImage = N.$Toolbar.querySelector('.remote-image-view .validate-tool');

  const $InputRemoteVideo = N.$Toolbar.querySelector('.remote-video-view input');
  const $CancelRemoteVideo = N.$Toolbar.querySelector('.remote-video-view .cancel-tool');
  const $ValidateRemoteVideo = N.$Toolbar.querySelector('.remote-video-view .validate-tool');

  const $InputRemoteEmbed = N.$Toolbar.querySelector('.remote-embed-view input');
  const $CancelRemoteEmbed = N.$Toolbar.querySelector('.remote-embed-view .cancel-tool');
  const $ValidateRemoteEmbed = N.$Toolbar.querySelector('.remote-embed-view .validate-tool');

  const $InputApplyLink = N.$Toolbar.querySelector('.apply-link-view input');
  const $CancelApplyLink = N.$Toolbar.querySelector('.apply-link-view .cancel-tool');
  const $ValidateApplyLink = N.$Toolbar.querySelector('.apply-link-view .validate-tool');

  const $InputEmojis = N.$Toolbar.querySelector('.emojis-view input');
  const $CancelEmojis = N.$Toolbar.querySelector('.emojis-view .cancel-tool');
  const $SearchEmojis = N.$Toolbar.querySelector('.emojis-view .search-button');
  const $EmojisList = N.$Toolbar.querySelector('.emojis-view .emojis-list');
  const Emojis = N.Functions.IO.funcLoadEmojis();



  const funcToolButtonsCompatibility = (Parameter) => {
    const $Button = Parameter.$ButtonClicked;
    let boolCanFormat = true;

    // Some tools incompatibilities with activated lists
    if (N.$ToolUnorderedList.classList.contains('active') || N.$ToolOrderedList.classList.contains('active')) {
      if (
        $Button === $ToolParagraph || $Button === N.$ToolQuote ||
        $Button === N.$ToolH1 || $Button === N.$ToolH2 || $Button === N.$ToolH3 || $Button === N.$ToolH4 || $Button === N.$ToolH5 || $Button === N.$ToolH6
      ) {
        boolCanFormat = false;
      }
    }

    // List tools incompatibilities with some activated tools
    if ($Button === N.$ToolUnorderedList || $Button === N.$ToolOrderedList) {
      if (
        N.$ToolQuote.classList.contains('active') || N.$ToolH1.classList.contains('active') || N.$ToolH2.classList.contains('active') || N.$ToolH3.classList.contains('active') || N.$ToolH4.classList.contains('active') || N.$ToolH5.classList.contains('active') || N.$ToolH6.classList.contains('active')
      ) {
        boolCanFormat = false;
      }
    }

    return boolCanFormat;
  };



  N.$Toolbar.addEventListener('mousedown', (Event) => {
    Event.preventDefault();
  });
  forEach(N.$Toolbar.getElementsByTagName('input'), ($Input) => {
    $Input.addEventListener('mousedown', (Event) => {
      Event.stopPropagation();
    });
  });


  forEach(N.$Toolbar.querySelectorAll('.tools-list-view li'), ($Button) => {
    $Button.addEventListener('click', () => {
      const boolCanFormat = funcToolButtonsCompatibility({ $ButtonClicked: $Button });

      if (boolCanFormat) {
        if ($Button.dataset.cmd) {
          if ($Button.dataset.cmdparam) {
            // http://stackoverflow.com/questions/1723287/calling-a-javascript-function-named-in-a-variable
            N.DocActive.Editor[$Button.dataset.cmd]($Button.dataset.cmdparam);
          } else {
            N.DocActive.Editor[$Button.dataset.cmd]();
          }
        } else if ($Button.dataset.tag) {
          N.DocActive.Editor.format($Button.dataset.tag);

          // if it's a heading tool button
          if (N.RegExpHeading.test($Button.dataset.tag)) {
            N.Functions.Dialogs.funcUpdateTableContent();
          }
        } else {
          N.DocActive.LastSelection = lightrange.saveSelection();
          N.$Toolbar.dataset.view = $Button.id.replace('tool-', '').replace('_unc2741', '');
          N.Functions.Toolbar.funcAutoPosition();

          if ($Button === $ToolRemoteImage) {
            $InputRemoteImage.select();
          }
          else if ($Button === $ToolRemoteVideo) {
            $InputRemoteVideo.select();
          }
          else if ($Button === $ToolRemoteEmbed) {
            $InputRemoteEmbed.select();
          }
          else if ($Button === $ToolApplyLink) {
            $InputApplyLink.select();
          }
          else if ($Button === $ToolEmojis) {
            $InputEmojis.select();
          }
        }

        N.Functions.Toolbar.funcCheckTools();
      }

    });
  });



  forEach(N.$Toolbar.getElementsByClassName('cancel-tool'), ($Button) => {
    $Button.addEventListener('click', () => {
      N.Functions.Toolbar.funcResetView();
    });
  });


  $ValidateRemoteImage.addEventListener('click', () => {
    if ($InputRemoteImage.value) {
      $InputRemoteImage.classList.remove('invalid');
      lightrange.restoreSelection(N.DocActive.LastSelection);
      N.DocActive.Editor.insertImage($InputRemoteImage.value + N.Functions.Utils.funcNoCacheSuffix());
      N.Functions.Toolbar.funcResetView();
      N.Functions.Toolbar.funcAutoPosition();
    } else {
      $InputRemoteImage.classList.add('invalid');
    }
  });


  $ValidateRemoteVideo.addEventListener('click', () => {
    const ParsedURL = urlParser.parse($InputRemoteVideo.value);

    if (ParsedURL) {
      $InputRemoteVideo.classList.remove('invalid');

      lightrange.restoreSelection(N.DocActive.LastSelection);

      // Cleared & Embed URL
      const strEmbedURL = urlParser.create({
        videoInfo: ParsedURL,
        format: 'embed'
      });

      // All embed video player at the same dimensions : 560px x 315px, which is the YouTube dimensions.
      if (ParsedURL.provider === 'youtube' || ParsedURL.provider === 'vimeo' || ParsedURL.provider === 'dailymotion' || ParsedURL.provider === 'twitch') {
        let strProtocol = '';

        if (ParsedURL.provider === 'youtube' || ParsedURL.provider === 'vimeo') {
          strProtocol = 'https:';
        } else if (ParsedURL.provider === 'dailymotion') {
          strProtocol = 'http:';
        }

        N.DocActive.Editor.insertHTML(`<iframe src="${strProtocol}${strEmbedURL}" width="560" height="315" allowfullscreen></iframe>`);
      }

      N.Functions.Toolbar.funcResetView();
      N.Functions.Toolbar.funcAutoPosition();
    }
    else {
      $InputRemoteVideo.classList.add('invalid');
    }
  });


  $ValidateRemoteEmbed.addEventListener('click', () => {
    let strEmbedCode = $InputRemoteEmbed.value;
    const RegExpEmbed = new RegExp(/^<iframe.+><\/iframe>$/, 'i');

    if (RegExpEmbed.test(strEmbedCode)) {
      $InputRemoteEmbed.classList.remove('invalid');

      lightrange.restoreSelection(N.DocActive.LastSelection);

      strEmbedCode = N.Functions.Content.funcPurifyHTML({
        strHTML: strEmbedCode,
        strAllowedContentMode: 'embed'
      });

      N.DocActive.Editor.insertHTML(strEmbedCode);

      N.Functions.Toolbar.funcResetView();
      N.Functions.Toolbar.funcAutoPosition();
    }
    else {
      $InputRemoteEmbed.classList.add('invalid');
    }
  });


  $ValidateApplyLink.addEventListener('click', () => {
    if ($InputApplyLink.value) {
      $InputApplyLink.classList.remove('invalid');
      lightrange.restoreSelection(N.DocActive.LastSelection);
      N.DocActive.Editor.insertLink($InputApplyLink.value);
      N.Functions.Toolbar.funcResetView();
      N.Functions.Toolbar.funcAutoPosition();
    } else {
      $InputApplyLink.classList.add('invalid');
    }
  });



  // forEach(Emojis, (Emoji) => {
  //   console.log(Emoji);
  // });

  forEach(N.$Toolbar.querySelectorAll('.emojis-view .category-buttons li'), ($Button) => {
    $Button.addEventListener('click', () => {
      // https://github.com/zengabor/zenscroll#8-execute-something-when-the-scrolling-is-done
      // .center(element, duration, offset, onDone)
      zenscroll.createScroller($EmojisList).center(document.querySelector($Button.dataset.anchor), null, -5);
    });
  });



  $InputRemoteImage.addEventListener('keyup', (Event) => {
    // Enter
    if (Event.keyCode === 13) {
      $ValidateRemoteImage.click();
    }
    // Escape
    else if (Event.keyCode === 27) {
      $CancelRemoteImage.click();
    }
  });

  $InputRemoteVideo.addEventListener('keyup', (Event) => {
    // Enter
    if (Event.keyCode === 13) {
      $ValidateRemoteVideo.click();
    }
    // Escape
    else if (Event.keyCode === 27) {
      $CancelRemoteVideo.click();
    }
  });

  $InputRemoteEmbed.addEventListener('keyup', (Event) => {
    // Enter
    if (Event.keyCode === 13) {
      $ValidateRemoteEmbed.click();
    }
    // Escape
    else if (Event.keyCode === 27) {
      $CancelRemoteEmbed.click();
    }
  });

  $InputApplyLink.addEventListener('keyup', (Event) => {
    // Enter
    if (Event.keyCode === 13) {
      $ValidateApplyLink.click();
    }
    // Escape
    else if (Event.keyCode === 27) {
      $CancelApplyLink.click();
    }
  });

  $InputEmojis.addEventListener('keyup', (Event) => {
    // Enter
    if (Event.keyCode === 13) {
      $SearchEmojis.click();
    }
    // Escape
    else if (Event.keyCode === 27) {
      $CancelEmojis.click();
    }
  });



  Mousetrap.bindGlobal('mod+1', () => {
    N.$ToolH1.click();
  });
  Mousetrap.bindGlobal('mod+2', () => {
    N.$ToolH2.click();
  });
  Mousetrap.bindGlobal('mod+3', () => {
    N.$ToolH3.click();
  });
  Mousetrap.bindGlobal('mod+4', () => {
    N.$ToolH4.click();
  });
  Mousetrap.bindGlobal('mod+5', () => {
    N.$ToolH5.click();
  });
  Mousetrap.bindGlobal('mod+6', () => {
    N.$ToolH6.click();
  });

  Mousetrap.bindGlobal('mod+shift+p', () => {
    $ToolParagraph.click();
  });
  Mousetrap.bindGlobal('mod+shift+q', () => {
    N.$ToolQuote.click();
  });
  Mousetrap.bindGlobal('mod+shift+l', () => {
    N.$ToolUnorderedList.click();
  });
  Mousetrap.bindGlobal('mod+alt+l', () => {
    N.$ToolOrderedList.click();
  });
  Mousetrap.bindGlobal('mod+alt+i', () => {
    N.$Toolbar.classList.add('active');
    $ToolRemoteImage.click();
  });
  Mousetrap.bindGlobal('mod+alt+v', () => {
    N.$Toolbar.classList.add('active');
    $ToolRemoteVideo.click();
    // Prevent triggering the paste event
    return false;
  });

  Mousetrap.bindGlobal('mod+b', () => {
    $ToolBold.click();
    // Prevent the Chromium default shortcut
    return false;
  });
  Mousetrap.bindGlobal('mod+i', () => {
    $ToolItalic.click();
    return false;
  });
  Mousetrap.bindGlobal('mod+u', () => {
    $ToolUnderline.click();
    return false;
  });
  Mousetrap.bindGlobal('mod+alt+s', () => {
    $ToolStrike.click();
  });
  Mousetrap.bindGlobal('mod+l', () => {
    N.$Toolbar.classList.add('active');
    $ToolApplyLink.click();
  });
  Mousetrap.bindGlobal('mod+shift+up', () => {
    $ToolSuperscript.click();
  });
  Mousetrap.bindGlobal('mod+shift+down', () => {
    $ToolSubscript.click();
  });
  Mousetrap.bindGlobal('mod+shift+c', () => {
    $ToolClear.click();
  });

})();

(() => {

  const $MinorInfoBar = document.getElementById('minor-info-bar_unc2741');

  const $ContextMenuLinkOpen = N.$ContextMenu.querySelector('.a-view .open a');
  const $ContextMenuAnchorGoTo = N.$ContextMenu.getElementsByClassName('go-to-anchor')[0];
  const $ContextMenuImgOpen = N.$ContextMenu.querySelector('.img-view .open a');

  const $PreviewLarge = document.getElementById('preview-large_unc2741');
  const $PreviewLargeImg = $PreviewLarge.getElementsByTagName('img')[0];



  const funcFindRealTarget = (Parameter) => {
    let $Target = Parameter.$ElementBase;

    while (
      $Target.tagName !== 'A'
      && $Target.tagName !== 'IMG'
      && ! N.RegExpHeading.test($Target.tagName)
      && ! $Target.classList.contains('emoji')
      && ! $Target.classList.contains('preview-list-item')
      && ! $Target.classList.contains('tab')
      && $Target !== N.$Workspace
      && $Target !== document.body
    ) {
      $Target = $Target.parentNode;
    }

    if (
      $Target.tagName === 'A'
      || $Target.tagName === 'IMG'
      || N.RegExpHeading.test($Target.tagName)
      || $Target.classList.contains('emoji')
      || $Target.classList.contains('preview-list-item')
      || $Target.classList.contains('tab')
      || $Target === N.$Workspace
    ) {
      let TargetInfo = {};

      if ($Target.tagName === 'A') {
        // http://stackoverflow.com/questions/3861076/how-can-i-extract-text-after-hash-in-the-href-part-from-a-tag/3861095#3861095
        if ($Target.hash) {
          TargetInfo = {
            $Target: $Target,
            strTargetType: 'anchor-link',
            strTargetValue: $Target.hash
          };
        } else {
          TargetInfo = {
            $Target: $Target,
            strTargetType: 'a',
            strTargetValue: $Target.href
          };
        }
      }
      else if ($Target.tagName === 'IMG') {
        TargetInfo = {
          $Target: $Target,
          strTargetType: 'img',
          strTargetValue: $Target.src
        };
      }
      else if (N.RegExpHeading.test($Target.tagName)) {
        TargetInfo = {
          $Target: $Target,
          strTargetType: 'anchor',
          strTargetValue: '#' + $Target.id
        };
      }
      else if ($Target.classList.contains('emoji')) {
        TargetInfo = {
          $Target: $Target,
          strTargetType: 'emoji',
          strTargetValue: $Target.getElementsByClassName('emoji-text')[0].textContent
        };
      }
      else if ($Target.classList.contains('preview-list-item')) {
        TargetInfo = {
          $Target: $Target,
          strTargetType: 'preview-list-item',
          strTargetValue: $Target.getElementsByTagName('img')[0].src
        };
      }
      else if ($Target.classList.contains('tab')) {
        TargetInfo = {
          $Target: $Target,
          strTargetType: 'tab',
          strTargetValue: N.arrDocs[$Target.dataset.id].strPath
        };
      }
      else if ($Target === N.$Workspace) {
        TargetInfo = {
          $Target: $Target,
          strTargetType: 'text',
          strTargetValue: null
        };
      }

      return TargetInfo;
    } else {
      return null;
    }
  };



  const funcPositionElementContext = (Parameters) => {
    if (Parameters.Event.pageX < window.innerWidth / 2) {
      Parameters.$Element.style.left = Parameters.Event.pageX + 'px';
    } else {
      Parameters.$Element.style.left = (Parameters.Event.pageX - Parameters.$Element.offsetWidth) + 'px';
    }

    if (Parameters.Event.pageY < window.innerHeight / 2) {
      Parameters.$Element.style.top = Parameters.Event.pageY + 'px';
    } else {
      Parameters.$Element.style.top = (Parameters.Event.pageY - Parameters.$Element.offsetHeight) + 'px';
    }
  };



  document.addEventListener('click', (Event) => {
    if ( ! Event.target.classList.contains('menu-list-item')) {
      N.$ContextMenu.classList.remove('active');
    }
  });



  document.addEventListener('mousemove', (Event) => {
    const TargetInfo = funcFindRealTarget({ $ElementBase: Event.target });

    if (TargetInfo && TargetInfo.strTargetValue) {

      if (TargetInfo.$Target.classList.contains('no-info-bar') || TargetInfo.$Target.classList.contains('no-context-info')) {
        $MinorInfoBar.classList.remove('active');
      } else {
        $MinorInfoBar.textContent = TargetInfo.strTargetValue;
        $MinorInfoBar.classList.add('active');
      }

      if (TargetInfo.strTargetType === 'preview-list-item') {
        $PreviewLargeImg.src = TargetInfo.strTargetValue;
        funcPositionElementContext({
          $Element: $PreviewLarge,
          Event: Event
        });
        $PreviewLarge.classList.add('active');
      } else {
        $PreviewLarge.classList.remove('active');
      }

    } else {
      $MinorInfoBar.classList.remove('active');
      $PreviewLarge.classList.remove('active');
    }
  });


  document.addEventListener('contextmenu', (Event) => {
    const TargetInfo = funcFindRealTarget({ $ElementBase: Event.target });

    if (TargetInfo) {

      if (TargetInfo.$Target.classList.contains('no-context-menu') || TargetInfo.$Target.classList.contains('no-context-info')) {
        N.$ContextMenu.classList.remove('active');
      }
      else {
        N.$ContextMenu.dataset.target = TargetInfo.strTargetType;

        // No need to check TargetInfo.strTargetValue, the user can't directly add an empty value and the document content is cleared at input.

        if (TargetInfo.strTargetType === 'a') {
          $ContextMenuLinkOpen.href = TargetInfo.strTargetValue;
        }
        else if (TargetInfo.strTargetType === 'anchor-link') {
          $ContextMenuAnchorGoTo.dataset.anchor = TargetInfo.strTargetValue;
        }
        else if (TargetInfo.strTargetType === 'img') {
          $ContextMenuImgOpen.href = TargetInfo.strTargetValue;
        }
        else if (TargetInfo.strTargetType === 'tab') {
          N.$Header.classList.add('active');
        }

        funcPositionElementContext({
          $Element: N.$ContextMenu,
          Event: Event
        });

        N.$ContextMenu.classList.add('active');

        N.LastContextMenuElementInfo = TargetInfo;

        // Toolbar and context menu must not be visible at the same time.
        N.Functions.Toolbar.funcResetView();
        N.$Toolbar.classList.remove('active');
      }
    } else {
      N.$ContextMenu.classList.remove('active');
    }
  });



  N.$ContextMenu.addEventListener('mousedown', (Event) => {
    Event.preventDefault();
  });


  forEach(N.$ContextMenu.querySelectorAll('li.copy'), ($Item) => {
    $Item.addEventListener('click', () => {
      N.$ContextMenu.classList.remove('active');
      N.ElectronFramework.Clipboard.writeText(N.LastContextMenuElementInfo.strTargetValue);
    });
  });

  forEach(N.$ContextMenu.querySelectorAll('li.open'), ($Item) => {
    $Item.addEventListener('click', () => {
      N.$ContextMenu.classList.remove('active');
    });
  });

  N.$ContextMenu.getElementsByClassName('close-tabs')[0].addEventListener('click', () => {
    N.$ContextMenu.classList.remove('active');
    N.Functions.Documents.funcCloseAll();
  });

  N.$ContextMenu.getElementsByClassName('select-all')[0].addEventListener('click', () => {
    N.$ContextMenu.classList.remove('active');
    document.execCommand('selectAll');
  });
  N.$ContextMenu.getElementsByClassName('copy-selection')[0].addEventListener('click', () => {
    N.$ContextMenu.classList.remove('active');
    document.execCommand('copy');
  });
  N.$ContextMenu.getElementsByClassName('paste')[0].addEventListener('click', () => {
    N.$ContextMenu.classList.remove('active');
    document.execCommand('paste');
  });


  $ContextMenuAnchorGoTo.addEventListener('click', () => {
    N.$ContextMenu.classList.remove('active');

    const $Anchor = document.querySelector($ContextMenuAnchorGoTo.dataset.anchor);
    if ($Anchor) {
      zenscroll.createScroller(N.DocActive.$ContentContainer).center($Anchor);
    }
  });

})();

(() => {

  forEach(document.getElementsByClassName('close-dialog-button'), ($Button) => {
    $Button.addEventListener('click', () => {
      N.Functions.Dialogs.funcForceClose();
    });
  });



  N.$MenuOpenDocFolder.addEventListener('click', () => {
    N.DocActive.methOpenFolder();
  });
  Mousetrap.bindGlobal('mod+shift+o', () => {
    N.$MenuOpenDocFolder.click();
  });


  document.getElementById('menu-save-as_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'save-as' });
  });
  Mousetrap.bindGlobal('mod+shift+s', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'save-as' });
  });


  document.getElementById('menu-search_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'search' });
    N.$SearchInput.select();
  });
  Mousetrap.bindGlobal('mod+f', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'search' });
    N.$SearchInput.select();
  });


  document.getElementById('menu-table-content_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'table-content' });
    N.Functions.Dialogs.funcUpdateTableContent();
  });
  N.$TableContentDialog.getElementsByClassName('refresh-button')[0].addEventListener('click', () => {
    N.Functions.Dialogs.funcUpdateTableContent();
  });


  document.getElementById('menu-doc-info_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'doc-info' });
    N.Functions.Dialogs.funcUpdateDocInfo();
  });
  N.$DocInfoDialog.getElementsByClassName('recount-button')[0].addEventListener('click', () => {
    N.Functions.Dialogs.funcUpdateDocInfo();
  });

  document.getElementById('menu-print_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'print' });
  });
  Mousetrap.bindGlobal('mod+p', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'print' });
  });


  document.getElementById('menu-settings_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'settings' });
  });


  document.getElementById('menu-shortcuts_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'shortcuts' });
  });
  Mousetrap.bindGlobal('ctrl+space', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'shortcuts' });
  });


  N.$MenuQuickGuide.addEventListener('click', () => {
    N.Functions.Documents.funcOpen({ arrPaths: [`${N.strAppPath}/documents/quick-guide-${N.Settings.strUILangSlug}.html`] });
  });


  document.getElementById('menu-about_unc2741').addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'about' });
  });
  N.$AboutDialog.getElementsByClassName('app-folder-button')[0].addEventListener('click', () => {
    N.ElectronFramework.Shell.showItemInFolder(N.strAppExePath);
  });



  Mousetrap.bindGlobal('escape', () => {
    if (N.$Toolbar.dataset.view === 'tools-list') {
      N.$Toolbar.classList.remove('active');
    }

    N.$ContextMenu.classList.remove('active');

    N.Functions.Dialogs.funcCloseCurrent();
  });


  Mousetrap.bindGlobal('enter', () => {
    N.Functions.Dialogs.funcValidateCurrent();
  });




  N.$UnsavedDocsDialog.getElementsByClassName('quit-app')[0].addEventListener('click', () => {
    document.body.classList.add('force-close-app');
    N.Functions.Window.funcClose();
  });


  window.addEventListener('beforeunload', (Event) => {
    if ( ! document.body.classList.contains('force-close-app')) {
      const AfterCloseStatus = N.Functions.Documents.funcCloseAll();

      // Prevent the window from closing if there are unsaved documents
      if (AfterCloseStatus.boolUnsavedDocs) {
        Event.returnValue = false;
      }
    }
  });

})();

(() => {

  const $SaveAsDialog = document.getElementById('save-as-dialog_unc2741');

  const $PathField = document.getElementById('save-path-field_unc2741');
  let strPathFieldValue = '';
  const $PathFieldContainer = $PathField.parentNode;
  const $PathFieldTooltip = $SaveAsDialog.getElementsByClassName('mdl-tooltip')[0];


  const $DocThemeListLabel = $SaveAsDialog.getElementsByClassName('preview-list-label')[0];
  // For populating document themes item list
  const $DocThemeList = $SaveAsDialog.getElementsByClassName('preview-list')[0];
  const $DocThemeItem = $DocThemeList.getElementsByClassName('preview-list-item')[0];

  let FilePathInfo = {};



  const funcSaveDocController = (Options) => {
    if ( (N.DocActive.$Tab.classList.contains('doc-unsaved') && ! N.DocActive.boolLocked) || (Options && Options.boolSaveAsMode) ) {
      if (N.DocActive.strPath || (Options && Options.boolSaveAsMode) ) {
        let SaveParameters = {};

        if (Options && Options.boolSaveAsMode) {
          SaveParameters = {
            strSavePath: Options.strSavePath,
            strFormat: Options.strFormat,
            strDocThemeSlug: Options.strDocThemeSlug,
            $ContentEditable: N.DocActive.$ContentEditable
          };
        } else {
          SaveParameters = {
            strSavePath: N.DocActive.strPath,
            strFormat: N.DocActive.strFormat,
            strDocThemeSlug: N.DocActive.strDocThemeSlug,
            $ContentEditable: N.DocActive.$ContentEditable
          };
        }

        const boolSaveResult = N.Functions.IO.funcSaveDoc(SaveParameters);

        if (boolSaveResult) {
          N.DocActive.strLastSavedContent = N.DocActive.$ContentEditable.innerHTML;
          N.DocActive.$Tab.classList.remove('doc-unsaved');
          N.$GlobalUnsavedMark.classList.remove('active');
        }

      } else {
        N.Functions.Dialogs.funcShow({ strDialogSlug: 'save-as' });
      }
    }
  };



  N.$MenuSave.addEventListener('click', () => {
    funcSaveDocController();
  });
  Mousetrap.bindGlobal('mod+s', () => {
    // We don't force the N.$MenuSave.click() here to keep the save as dialog display system.
    funcSaveDocController();
  });





  // Handling document themes

  const arrFolderNames = N.ElectronFramework.Fs.readdirSync(`${N.strAppPath}/themes/doc-themes/themes-dir/`);
  // For each interface theme
  forEach(arrFolderNames, (strFolderName) => {
    // Create a document theme list item
    const $DocThemeItemClone = $DocThemeItem.cloneNode(true);
    $DocThemeItemClone.removeAttribute('hidden');
    $DocThemeItemClone.dataset.slug = strFolderName;

    // Trying to read the HTML document theme file.
    const strDocThemeHTML = N.Functions.IO.funcReadFile({ strPath: `${N.strAppPath}/themes/doc-themes/themes-dir/${strFolderName}/template.html` });

    if (strDocThemeHTML) {
      // Getting the document theme name inside the file content
      $DocThemeItemClone.getElementsByClassName('mdl-list__item-primary-content')[0].textContent = strDocThemeHTML.match('- __themename: (.*) -')[1];
      $DocThemeItemClone.getElementsByTagName('img')[0].src = `../themes/doc-themes/themes-dir/${strFolderName}/preview.png`;

      // Set document theme on item click
      $DocThemeItemClone.addEventListener('click', () => {
          const $DocThemeSelected = $DocThemeList.getElementsByClassName('active')[0];
          if ($DocThemeSelected) {
            $DocThemeSelected.classList.remove('active');
          }
          $DocThemeItemClone.classList.add('active');
      });

      $DocThemeList.appendChild($DocThemeItemClone);
    }
  });

  // Selecting the corresponding document theme in the list
  $DocThemeList.querySelector('li:nth-child(2)').click();






  $PathField.addEventListener('click', () => {
    const strExtensionLowerCase = N.ElectronFramework.Path.extname(N.DocActive.$FileName.textContent).toLowerCase();
    let strDefaultPathExtension = '';

    if (['.html', '.htm', '.md', '.markdown'].indexOf(strExtensionLowerCase) === -1) {
      strDefaultPathExtension = '.html';
    }

    N.ElectronFramework.Dialog.showSaveDialog({
      defaultPath: N.DocActive.$FileName.textContent + strDefaultPathExtension,
      filters: [
        {name: 'HTML document', extensions: ['html', 'htm']},
        {name: 'Markdown document', extensions: ['md', 'markdown']}
      ]
    }, (strSavePath) => {
      // strSavePath is undefined if the action is cancelled by the user
      if (strSavePath) {
        $PathField.value = strSavePath;
        strPathFieldValue = strSavePath;
        $PathFieldTooltip.textContent = strSavePath;

        FilePathInfo = N.Functions.Utils.funcGetFilePathInfo({ strPath: strSavePath });
        if (FilePathInfo.strFormat === 'HTML') {
          $DocThemeListLabel.removeAttribute('hidden');
          $DocThemeList.removeAttribute('hidden');
        } else if (FilePathInfo.strFormat === 'Markdown') {
          $DocThemeListLabel.setAttribute('hidden', null);
          $DocThemeList.setAttribute('hidden', null);
        }

      } else {
        $PathField.value = '';
        strPathFieldValue = '';
        $PathFieldTooltip.textContent = '';
      }

      N.Functions.Utils.funcTriggerEvent({
        strEvent: 'input',
        $Element: $PathField
      });

    });

  });


  // Save button
  $SaveAsDialog.getElementsByClassName('save-button')[0].addEventListener('click', () => {
    if (strPathFieldValue) {
      $PathFieldContainer.classList.remove('is-invalid');
      N.Functions.Dialogs.funcForceClose();

      let strDocThemeSlug = null;
      let strDocThemeName = null;
      if (FilePathInfo.strFormat === 'HTML') {
        const $DocThemeSelected = $DocThemeList.getElementsByClassName('active')[0];
        strDocThemeSlug = $DocThemeSelected.dataset.slug;
        strDocThemeName = $DocThemeSelected.textContent;
      }

      funcSaveDocController({
        boolSaveAsMode: true,
        strSavePath: strPathFieldValue,
        strFormat: FilePathInfo.strFormat,
        strDocThemeSlug: strDocThemeSlug
      });
      N.DocActive.methSetTabData({
        strPath: strPathFieldValue,
        strDocThemeSlug: strDocThemeSlug,
        strDocThemeName: strDocThemeName
      });

      N.DocActive.methShow();

    } else {
      $PathFieldContainer.classList.add('is-invalid');
    }
  });

})();

(() => {

  const $SearchInputContainer = N.$SearchInput.parentNode;
  const $ReplaceInputContainer = N.$ReplaceInput.parentNode;
  const $SwitchCaseSensitive = N.$SearchDialog.querySelector('[for="switch-search-case-sensitive_unc2741"]');

  let LastSearchRegExp;
  let Search = {};



  const funcMakeSearchRegExp = () => {
    let strRegExpFlags = 'g';
    if ( ! $SwitchCaseSensitive.classList.contains('is-checked')) {
      strRegExpFlags += 'i';
    }
    LastSearchRegExp = new RegExp(`(${N.Functions.Utils.funcEscapeStringRegexp({ strRegExp: N.$SearchInput.value })})`, strRegExpFlags);
  };


  const funcFindAll = () => {
    Search = findAndReplaceDOMText(N.DocActive.$ContentEditable, {
      find: LastSearchRegExp,

      replace: function(Portion, Match) {
        const $Searchresult = document.createElement('searchresult');
        $Searchresult.dataset.match = Match.index;
        $Searchresult.textContent = Portion.text;
        return $Searchresult;
      }
    });
  };


  const funcReplaceAll = () => {
    let strReplace = N.$ReplaceInput.value;
    if (! strReplace) {
      // findAndReplaceDOMText() doesn't accept empty value, but replace ' ' by an empty value
      strReplace = ' ';
    }

    findAndReplaceDOMText(N.DocActive.$ContentEditable, {
      find: LastSearchRegExp,
      replace: strReplace
    });
  };


  const funcFindReplaceController = (Parameter) => {
    if (N.$SearchInput.value) {
      $SearchInputContainer.classList.remove('is-invalid');

      if (Parameter.strMode === 'find-all') {
        N.Functions.Content.funcCleanSearch({ Document: N.DocActive });
        funcMakeSearchRegExp();
        funcFindAll();
        N.$SearchResultsTotal.textContent = Search.reverts.length;
      }

      else if (Parameter.strMode === 'replace-all') {
        N.Functions.Content.funcCleanSearch({ Document: N.DocActive });
        funcMakeSearchRegExp();
        funcReplaceAll();

        N.Functions.Utils.funcTriggerEvent({
          strEvent: 'input',
          $Element: N.DocActive.$ContentEditable
        });

        N.$SearchResultsTotal.textContent = '0';
      }
    }
    else {
      $SearchInputContainer.classList.add('is-invalid');
    }
  };


  N.$SearchDialog.getElementsByClassName('find-all-button')[0].addEventListener('click', () => {
    funcFindReplaceController({ strMode: 'find-all' });
  });
  N.$SearchDialog.getElementsByClassName('replace-all-button')[0].addEventListener('click', () => {
    funcFindReplaceController({ strMode: 'replace-all' });
  });

})();

(() => {

  const $SettingsDialog = document.getElementById('settings-dialog_unc2741');

  const $UIThemeSheet = document.getElementById('ui-theme-sheet_unc2741');

  // For populating UI language select list
  const $SelectUILangInput = document.getElementById('select-ui-lang_unc2741');
  const $SelectUILang = $SettingsDialog.querySelector('.mdl-menu[for="select-ui-lang_unc2741"]');
  const $SelectUILangItem = $SelectUILang.getElementsByClassName('mdl-menu__item')[0];

  const $SwitchAutoUpdate = $SettingsDialog.querySelector('[for="switch-auto-update-check_unc2741"]');
  const $SwitchAutoUpdateInput = $SwitchAutoUpdate.getElementsByTagName('input')[0];

  const $SwitchWindowFrame = $SettingsDialog.querySelector('[for="switch-window-frame_unc2741"]');
  const $SwitchWindowFrameInput = $SwitchWindowFrame.getElementsByTagName('input')[0];

  const $SwitchLinuxControlsRight = $SettingsDialog.querySelector('[for="switch-linux-controls-right_unc2741"]');
  const $SwitchLinuxControlsRightInput = $SwitchLinuxControlsRight.getElementsByTagName('input')[0];

  // For populating UI themes select list
  const $UIThemesList = $SettingsDialog.getElementsByClassName('preview-list')[0];
  const $UIThemesListItem = $UIThemesList.getElementsByClassName('preview-list-item')[0];




  const funcResetSettings = () => {
    if (N.Settings.strUILangSlug !== 'english') {
      $SelectUILang.querySelector('[data-slug="english"]').click();
    }
    if ( ! N.Settings.boolAutoUpdateCheck) {
      $SwitchAutoUpdateInput.click();
    }
    if (N.Settings.boolWindowFrame) {
      $SwitchWindowFrameInput.click();
    }
    if (N.Settings.boolLinuxControlsRight) {
      $SwitchLinuxControlsRightInput.click();
    }
    if (N.Settings.strUIThemeSlug !== '_ORIGINAL_white-room') {
      $UIThemesList.querySelector('[data-slug="_ORIGINAL_white-room"]').click();
    }
  };


  // TODO [(Un)colored] : Lang switch function (no need to reload)
  const funcSetUIThemeLang = () => {

  };




  // Handling UI languages

  const arrFileNames = N.ElectronFramework.Fs.readdirSync(`${N.strAppPath}/lang/`);
  // For each UI language
  forEach(arrFileNames, (strFileName) => {
    // Create a UI language list item
    const $SelectUILangItemClone = $SelectUILangItem.cloneNode(true);
    $SelectUILangItemClone.removeAttribute('hidden');
    $SelectUILangItemClone.dataset.slug = strFileName.replace('.xml', '');

    // Trying to read the UI languages XML file.
    const strUILangXML = N.Functions.IO.funcReadFile({ strPath: `${N.strAppPath}/lang/${strFileName}` });

    if (strUILangXML) {
      const Parser = new DOMParser();
      const $UILangXML = Parser.parseFromString(strUILangXML, 'text/xml');

      // Getting the UI language name inside the file content
      $SelectUILangItemClone.textContent = $UILangXML.getElementsByTagName('langname')[0].textContent;

      // Set UI lang on item click
      $SelectUILangItemClone.addEventListener('click', () => {
        // If the clicked lang is different than the actual one
        if ($SelectUILangItemClone.dataset.slug !== N.Settings.strUILangSlug) {
          N.Settings.strUILangSlug = $SelectUILangItemClone.dataset.slug;
          N.Functions.IO.funcSaveSettings();
        }
      });

      if ($SelectUILangItemClone.dataset.slug === N.Settings.strUILangSlug) {
        $SelectUILangInput.value = $SelectUILangItemClone.textContent;
      }

      $SelectUILang.appendChild($SelectUILangItemClone);
    }
  });




  // Handling UI themes

  const arrFolderNames = N.ElectronFramework.Fs.readdirSync(`${N.strAppPath}/themes/ui-themes/`);
  // For each interface theme
  forEach(arrFolderNames, (strFolderName) => {
    // Create a UI theme list item
    const $UIThemesListItemClone = $UIThemesListItem.cloneNode(true);
    $UIThemesListItemClone.removeAttribute('hidden');
    $UIThemesListItemClone.dataset.slug = strFolderName;

    // Trying to read the UI theme CSS file.
    const strUIThemeCSS = N.Functions.IO.funcReadFile({ strPath: `${N.strAppPath}/themes/ui-themes/${strFolderName}/style.css` });

    if (strUIThemeCSS) {
      // Getting the UI theme name inside the file content
      $UIThemesListItemClone.getElementsByClassName('mdl-list__item-primary-content')[0].textContent = strUIThemeCSS.match('- __themename: (.*) -')[1];
      $UIThemesListItemClone.getElementsByTagName('img')[0].src = `../themes/ui-themes/${strFolderName}/preview.png`;

      // Set UI theme on item click
      $UIThemesListItemClone.addEventListener('click', () => {
        // If the clicked theme is different than the actual one
        if ($UIThemesListItemClone.dataset.slug !== N.Settings.strUIThemeSlug || ! $UIThemesList.getElementsByClassName('active')[0]) {
          N.Settings.strUIThemeSlug = $UIThemesListItemClone.dataset.slug;
          $UIThemeSheet.href = `${N.strAppPath}/themes/ui-themes/${strFolderName}/style.css`;
          const $UIThemeSelected = $UIThemesList.getElementsByClassName('active')[0];
          if ($UIThemeSelected) {
            $UIThemeSelected.classList.remove('active');
          }
          $UIThemesListItemClone.classList.add('active');

          N.Functions.IO.funcSaveSettings();
        }
      });

      $UIThemesList.appendChild($UIThemesListItemClone);
    }
  });

  // Selecting the corresponding UI theme in the list
  $UIThemesList.querySelector(`[data-slug="${N.Settings.strUIThemeSlug}"]`).click();



  // Handling app auto update check
  $SwitchAutoUpdateInput.addEventListener('click', () => {
    N.Settings.boolAutoUpdateCheck = ! $SwitchAutoUpdate.classList.contains('is-checked');
    N.Functions.IO.funcSaveSettings();
  });

  // Handling app window frame
  $SwitchWindowFrameInput.addEventListener('click', () => {
    N.Settings.boolWindowFrame = ! $SwitchWindowFrame.classList.contains('is-checked');
    N.Functions.IO.funcSaveSettings();
  });

  // Handling Linux controls side
  $SwitchLinuxControlsRightInput.addEventListener('click', () => {
    N.Settings.boolLinuxControlsRight = ! $SwitchLinuxControlsRight.classList.contains('is-checked');

    if (N.Settings.boolLinuxControlsRight) {
      document.body.dataset.linuxcontrolsside = 'right';
    } else {
      document.body.dataset.linuxcontrolsside = 'left';
    }

    N.Functions.IO.funcSaveSettings();
  });


  $SettingsDialog.getElementsByClassName('reset-button')[0].addEventListener('click', () => {
    funcResetSettings();
  });

  $SettingsDialog.getElementsByClassName('settings-folder-button')[0].addEventListener('click', () => {
    N.ElectronFramework.Shell.showItemInFolder(N.strSettingsFilePath);
  });


  // First init of the auto update switch
  if ($SwitchAutoUpdate.classList.contains('is-checked') !== N.Settings.boolAutoUpdateCheck) {
    $SwitchAutoUpdateInput.click();
  }

  // First init of the window frame switch
  if ($SwitchWindowFrame.classList.contains('is-checked') !== N.Settings.boolWindowFrame) {
    $SwitchWindowFrameInput.click();
  }
  if ( ! N.Settings.boolWindowFrame) {
    document.body.classList.add('no-frame');
  }

  // First init of the Linux controls side switch
  if ($SwitchLinuxControlsRight.classList.contains('is-checked') !== N.Settings.boolLinuxControlsRight) {
    $SwitchLinuxControlsRightInput.click();
  }


  if (N.Settings.boolFirstStart) {
    N.$MenuQuickGuide.click();
    N.Settings.boolFirstStart = false;
    N.Functions.IO.funcSaveSettings();
  }
})();

(() => {

  const $AppCurrentVersion = N.$AboutDialog.getElementsByClassName('app-version')[0];

  const $NewUpdateDialog = document.getElementById('new-update-dialog_unc2741');
  const $AppRemoteVersion = $NewUpdateDialog.getElementsByClassName('last-version')[0];
  const $RemoteReleaseNotes = $NewUpdateDialog.getElementsByClassName('release-notes')[0];

  const $RemotePriorityInfo = document.getElementById('priority-info-dialog_unc2741').getElementsByClassName('mdl-card__supporting-text')[0];


  const funcUpdateCheck = () => {
    N.$AboutDialog.dataset.state = 'loading';

    N.Functions.Remote.funcGetUpdateInfo({
      funcOnSuccess: (UpdateCheckResult) => {
        if (UpdateCheckResult.boolUpdateAvailable) {
          $AppRemoteVersion.textContent = UpdateCheckResult.strRemoteLastestVersion;
          $RemoteReleaseNotes.innerHTML = UpdateCheckResult.strRemoteReleaseNotesHTML;
          N.$AboutDialog.dataset.state = 'new-update';
          N.Functions.Dialogs.funcShow({ strDialogSlug: 'new-update' });
        } else {
          N.$AboutDialog.dataset.state = 'up-to-date';
        }
      },
      funcOnError: (Error) => {
        N.$AboutDialog.dataset.state = 'error';
      }
    });
  };

  const funcPriorityInfoCheck = () => {
    N.Functions.Remote.funcGetPriorityInfo({
      funcOnSuccess: (PriorityInfoResult) => {
        if (PriorityInfoResult.strRemotePriorityInfoHTML !== '') {
          $RemotePriorityInfo.innerHTML = PriorityInfoResult.strRemotePriorityInfoHTML;
          N.Functions.Dialogs.funcShow({ strDialogSlug: 'priority-info' });
        }
      },
      funcOnError: (Error) => {}
    });
  };


  N.$AboutDialog.getElementsByClassName('show-update-dialog')[0].addEventListener('click', () => {
    N.Functions.Dialogs.funcShow({ strDialogSlug: 'new-update' });
  });

  N.$AboutDialog.getElementsByClassName('recheck')[0].addEventListener('click', () => {
    funcUpdateCheck();
  });


  $AppCurrentVersion.textContent = N.strAppVersion;


  if (N.Settings.boolAutoUpdateCheck) {
    funcUpdateCheck();
  }

  let timerPriorityInfoCheck;
  timerPriorityInfoCheck = setTimeout(() => {
    funcPriorityInfoCheck();
    clearTimeout(timerPriorityInfoCheck);
  }, 4000);

})();
